asypow.help <- function() {

### Print help messages for asypow users

  repeat {

    repeat {

      cat(
'\n Help messages on asypow topics are categorized under:\n\n',
' 1. Models and their parameters\n',
' 2. Arguments of the routines\n',
' Enter 1 or 2 or 0 to exit.\n')

      model.arg.which <- scan(file='',n=1)
      if (model.arg.which == 0) return( invisible() )
      if (model.arg.which > 0 && model.arg.which <= 11) break
      cat('/n Illegal entry - must be 1 or 2.\n')

    }

    if (model.arg.which == 1 ) {

      repeat {

        cat(
'The models on which information is available are:\n',
'\n',
' 1. binomial.kgp: Single- or Multiple-Group Binomial\n',
' 2. poisson.kgp: Single- or Multiple-Group Poisson\n',
' 3. expsurv.kgp:  Single- or  Multiple-Group Exponential Survival\n',
' 4. multinomial.kgp: Single- or Multiple-Group Multinomial\n',
' 5. ordinal.kgp: Single- or Multiple-Group Ordinal Data\n',
' 6. binomial.design: Binomial Outcome Dependent on One Covariate\n',
' 7. poisson.design: Poisson Outcome Dependent on One Covariate\n',
' 8. expsurv.design: Exponential Survival Dependent on One Covariate\n',
' 9. ordinal.design: Ordinal Outcome Dependent on a Single Covariate\n',
'10. mv.logistic: Binomial Outcome Depending on Multiple Covariates\n',
'11. mv.loglin: Binomial Outcome Depending on Multiple Covarites\n',
'\n',
'Enter the number of the model of your choice or 0 to exit.\n')

        which <- scan(file='',n=1)
        if (which == 0) return( invisible() )
        if (which > 0 && which <= 11) break
        cat('/n Illegal entry - must be 0 or 1 through 11.\n')
      }

      if (which == 1){

###  binomial.kgp 
        cat(
'           binomial.kgp: Single- or Multiple-Group Binomial\n',
'\n',
'The parameter, "p", is the probability of an event in each group.  The\n',
'alternative hypothesis  value    of the probability  is  specified  by\n',
'p=<values> where <values> is a  single value for a  single group or an\n',
'array of values for multiple groups.\n',
'\n',
'Since there is only one parameter, it does not need to be specified in\n',
'constraints, i.e., no const.constraint.param or equal.constraint.param\n',
'is necessary.\n')
pause()
next
      }

      if (which == 2) {

### poisson.kgp
        cat(
'            poisson.kgp: Single- or Multiple-Group Poisson\n',
'\n',
'The parameter,  "lambda" is the  mean  of the Poisson  distribution in\n',
'each group.  The alternative hypothesis value of the mean is specified\n',
'by lambda=<values> where <values> is a single value for a single group\n',
'or an array of values for multiple groups.\n',
'\n',
'Since there is only one parameter, it does not need to be specified in\n',
'constraints, i.e., no const.constraint.param or equal.constraint.param\n',
'is necessary.\n')
pause()
next
      }

      if (which==3) {

### expsurv.kgp
        cat(
'     expsurv.kgp:  Single- or  Multiple-Group Exponential Survival\n',
'\n',
'A clinical trial accrues subjects over a time period L.  Each subject\n',
'will enters   the study at   a random time between 0   and  L, so the\n',
'subject\'s follow up time, U,  will be uniformly distributed over this\n',
'range. The outcome is whether the patient is alive or dead at the end\n',
'of the study.   Time to death is  distributed exponentially with mean\n',
'1/w.\n',
'\n',
'The parameter,  "w"  is the  hazard  (reciprocal  of the  mean of  the\n',
'exponential distribution)  in each group.   The alternative hypothesis\n',
'value  of the hazard  is specified by w=<values>   where <values> is a\n',
'single value for a  single group or an  array  of values  for multiple\n',
'groups.\n',
'\n',
'Since there is only one parameter, it does not need to be specified in\n',
'constraints, i.e., no const.constraint.param or equal.constraint.param\n',
'is necessary.\n')
pause()
next
      }

      if (which==4) {

### multinomial.kgp
        cat(
'        multinomial.kgp: Single- or Multiple-Group Multinomial\n',
'\n',
'The  parameters   are "p1",   "p2",  ....  The  parameter pi    is the\n',
'probability that a  single outcome will  be category i.   There is one\n',
'such p for each  of the n categories  except the last one, i.e., there\n',
'are n-1  p\'s.  The last one  is determined by  the condition  that the\n',
'probabilities must sum to one.\n',
'\n',
'The alternative  hypothesis is specified  by p=<values>.  For a single\n',
'group, <values> is  an array of   probabilities of length  n-1.  For k\n',
'groups, <values> is  a  matrix, the  j\'th row  of which  specifies the\n',
'alternative hypothesis probabilities  for group j.   For k groups, the\n',
'matrix is dimensioned k X (n-1)\n')
pause()
next
      }

      if (which ==5) {

### ordinal.kgp
        cat(
'         ordinal.kgp: Single- or Multiple-Group Ordinal Data\n',
'\n',
'The parameters  are  "p1",   "p2",  ....   The  parameter  pi  is  the\n',
'probability that the outcome is some category less than or equal to i.\n',
'Hence the pi  must be monotonely increasing.  There  is one such p for\n',
'each of the n categories except the last one, i.e., there are n-1 p\'s.\n',
'The last one is necessarily 1.\n',
'\n',
'The alternative  hypothesis is specified  by p=<values>.  For a single\n',
'group, <values> is  an array of   probabilities of length  n-1.  For k\n',
'groups, <values> is  a  matrix, the  j\'th row  of which  specifies the\n',
'alternative hypothesis probabilities  for group j.   For k groups, the\n',
'matrix is dimensioned k X (n-1)\n')
pause()
next
      }

      if (which==6) {

### binomial.design
        cat(
'     binomial.design: Binomial Outcome Dependent on One Covariate\n',
'\n',
'If  design="linear", the parameters are "a" and "b".  The quantity\n',
'u is\n',
'                              a + b * x.\n',
'\n',
'If  design="quadratic", the parameters are "a", "b", and "c".  The\n',
'quanitity u is\n',
'                           a + b*x + c*x^2.\n',
'\n',
'If link="logistic", the probability of an event is:\n',
'                          exp(u)/(1+exp(u)).\n',
'\n',
'\n',
'If link="complementary log", the probability of an event is\n',
'                          1 - exp( -exp(u)).\n',
'\n',
'The alternative hypothesis values  of  the parameters is  specified by\n',
'theta=<values>.  For a single group, <values>  is an array of length 2\n',
'for design="linear" or of    length 3 for design="quadratic".  For   k\n',
'groups, <values>   has k rows,    the i\'th   of which  specifies   the\n',
'alternative hypothesis values of the parameters for the i\'th group.\n')
pause()
next
      }

      if (which==7) {

### poisson.design
        cat(
'      poisson.design: Poisson Outcome Dependent on One Covariate\n',
'\n',
'If design="linear", the parameters  are "a" and  "b".  The quantity  u\n',
'is:\n',
'                              a + b * x.\n',
'\n',
'If design="quadratic",  the  parameters are "a", "b",   and  "c".  The\n',
'quanitity u is:\n',
'                           a + b*x + c*x^2.\n',
'\n',
'The mean of the Poisson distribution is:\n',
'                               exp(u).\n',
'\n',
'The alternative  hypothesis values of  the parameters is  specified by\n',
'theta=<values>.  For a single group, <values>  is an array of length 2\n',
'for   design="linear" or of  length  3  for design="quadratic".  For k\n',
'groups,  <values>  has   k rows, the  i\'th   of   which  specifies the\n',
'alternative hypothesis values of the parameters for the i\'th group.\n')
pause()
next
      }

      if (which==8) {

### expsurv.design
        cat(
'   expsurv.design: Exponential Survival Dependent on One Covariate\n',
'\n',
'A clinical trial accrues subjects over a time period L.  Each subject\n',
'will enters   the study at   a random time between 0   and  L, so the\n',
'subject\'s follow up time, U,  will be uniformly distributed over this\n',
'range. The outcome is whether the patient is alive or dead at the end\n',
'of the study.   Time to death is  distributed exponentially with mean\n',
'1/hazard.\n')
pause()
cat(
'If design="linear",  the parameters are "a" and  "b".  The  quantity u\n',
'is:\n',
'                              a + b * x.\n',
'\n',
'If design="quadratic", the  parameters  are "a", "b",  and  "c".   The\n',
'quanitity u is:\n',
'                           a + b*x + c*x^2.\n',
'\n',
'The hazard (reciprocal of the mean survival) is:\n',
'                               exp(u).\n',
'\n',
'The alternative hypothesis  values of the  parameters  is specified by\n',
'theta=<values>.  For a single group, <values> is  an array of length 2\n',
'for design="linear" or   of  length 3 for  design="quadratic".   For k\n',
'groups, <values>   has  k rows,  the  i\'th   of  which  specifies  the\n',
'alternative hypothesis values of the parameters for the i\'th group.\n')
pause()
next
      }

      if (which==9) {

### ordinal.design
        cat(
'   ordinal.design: Ordinal Outcome Dependent on a Single Covariate\n',
'\n',
'If design="linear", the parameters are "a1", "a2", ..., "b".  There is\n',
'one "a" for all  categories EXCEPT the last one.    So if there  are n\n',
'categories, there are (n-1) a\'s. The quantity ui is defined by:\n',
'                            ui = ai + b*x.\n',
'\n',
'If design="quadratic",  the parameter "c" is added  at the  end of the\n',
'list of parameters.  The quentity ui is defined by:\n',
'                        ui = ai + b*x + c*x^2.\n')
pause()
cat(
'If link="logistic", the probability of the i""th category or a smaller\n',
'numbered category being observed is:\n',
'                         exp(ui)/(1+exp(ui))\n',
'for i less than the total number of  categories.  The probability that\n',
'the observation is in any category is, of course, 1.0.\n',
'\n',
'If link="complementary log", the  probability of the i\'th category or\n',
'a smaller numbered category being observed is:\n',
'                         1 - exp( -exp(ui) )\n',
'for i less than the total number of  categories.  The probability that\n',
'the observation is in any category is, of course, 1.0.\n',
'\n',
'Alternative hypothesis values are specified  by theta=<values>.  For a\n',
'single  group, <values> is  an  array of values   of parameters in the\n',
'order specified above.  Thus,  if design="linear", <values> has length\n',
'n; if design="quadratic", <values> has length n+1.\n')
pause()
next
      }

      if (which == 10) {

### mv.logistic
        cat(
'    mv.logistic: Binomial Outcome Depending on Multiple Covariates\n',
'         Intended Primarily for Data that is to be Tabulated\n',
'\n',
'If the   data will be  tabulated,  the x\'s will be    0 or 1 indicator\n',
'variables.\n',
'\n',
'The parameters  are  "coef1", "coef2",  ...   one  for each of  the  k\n',
'covariates.  The quantity:\n',
'           u = coef1 * x1 + coef2 * x2 + ... + coefk * xk.\n',
'\n',
'The probability of an event is:\n',
'                          exp(u)/(1+exp(u)).\n',
'\n',
'The alternative  hypothesis values of  the  parameters is specified by\n',
'coef.ha=<values>, where <values> is an array of length k.\n')
pause()
next
      }

      if (which==11) {

### mv.loglin
        cat(
'     mv.loglin: Binomial Outcome Depending on Multiple Covarites\n',
'         Intended Primarily for Data that is to be Tabulated\n',
'\n',
'If the  data  will be tabulated,  the  x\'s will be  0   or 1 indicator\n',
'variables.\n',
'\n',
'The parameters are "coef1", "coef2", ... one for each of k covariates.\n',
'The quantity u = log(coef1*x1) + log(coef2*x2) + ... log(coefk*xk).\n',
'\n',
'The probability of an event is:\n',
'                               exp(u).\n',
'\n',
'The  alternative hypothesis values of  the  parameters is specified by\n',
'coef.ha=<values>, where <values> is an array of length k.\n')
pause()
next
      }

    }

### Arg stuff goes here

    if (model.arg.which == 2 ) {

      repeat {

        cat(
'The topics on arguments on which information is available are:\n',
'\n',
' 1. Constant constraints\n',
' 2. Equality constraints\n',
' 3. Covariates\n',
' 4. Proportion of Subjects\n',
' 5. significance, power, sample.size\n',
'\n',
'Enter the number  of your choice or 0 to exit.\n')

        which <- scan(file='',n=1)
        if (which == 0) return( invisible() )
        if (which > 0 && which <= 5) break
        cat('/n Illegal entry - must be 0 or 1 through 5.\n')
      }
    }

    if (which == 1){
### Constant Constraints
      cat(

'          Constant Constraints Producing the Null Hypothesis\n',
'\n',
'Constant Constraints: These constraints set null hypothesis parameters\n',
'to   specified     values,  zero     is   popular.    The     argument\n',
'const.constraint.group    specifies  the experimental    group of each\n',
'parameter to be  so constrained.  The  argument const.constraint.param\n',
'specifies   the string-valued name   of  each parameter.  The argument\n',
'const.constraint.value  specifies  the numeric null  hypothesis value.\n',
'If  there  is  only one  group  or  one  parameter,  the corresponding\n',
'specification can be  omitted.  More than one  parameter can be set by\n',
'providing an array of values for each argument.   Example: a two group\n',
'multinomial model with three categories, hence two parameters.\n',
'\n',
'const.constraint.group <- c( 1, 1, 2, 2 )\n',
'const.constraint.param <- c( "p1", "p2", "p1", "p2" )\n',
'const.constraint.value <- c( 0.33, 0.33, 0.33, 0.33 )\n',
'\n'
          )
pause()
next
    }

    if (which == 2){
###Equality Constraints

      cat( 
'          Equality Constraints Producing the Null Hypothesis\n',
'\n',
'Equality Constraints: set   null hypothesis parameters equal  to  each\n',
'other, the common value cannot be specified.  Use constant constraints\n',
'for  specific values.  If   there is more than   one set of parameters\n',
'constrained  to be  mutually equal,  each such  set is  specified as a\n',
'list.\n',
'\n',
'equal.constraint.group  specifies   the   experimental  group  of each\n',
'parameter  to  be  constrained.  equal.constraint.param  provides  the\n',
'string-valued  name of each parameter.  If  there is only one group or\n',
'one  parameter, the  corresponding  specification  can  be   ommitted.\n',
'Example: a  two group multinomial  model with  three categories, hence\n',
'two parameters.  The null  hypothesis is that  the probability of each\n',
'category in the two  models is the same  for  the two groups.\n',
'\n',
'equal.constraint.group <- list( c(1,2), c(1,2)   )\n',
'equal.constraint.param <- list( c( "p1", "p1" ), c( "p2", "p2" ) )\n'
          )
pause()
next
    }

    if (which == 3){
###Covariates
      cat( 
'                           Covariate Values\n',
'\n',
'The covariate values in the  univariate design routines are  specified\n',
'as a vector of numbers in the argument xpoints.  This also works if if\n',
'there are  several  groups  with the  same  covariate values.   If the\n',
'covariate values differ  by groups, a  matrix is used for xpoints, the\n',
'ith row of the matrix gives the covariate values for the ith group.\n',
'\n',
'For  the multivariate models, xpoints must  be  assigned a matrix with\n',
'one  row  giving the value   of all covariates   at  one design point.\n',
'Multiple groups are not allowed in these models since group membership\n',
'can be encoded into the several variables.\n',
'\n'
          )
pause()
next
    }

    if (which == 4){
###Proportion of Subjects

      cat(
'                       Proportions of Subjects\n',
'\n',
'If all  groups are to    have the same  number  of  subjects at   each\n',
'covariate value (if any) do nothing.\n',
'\n',
'The argument group.size  specifies the relative proportion of subjects\n',
'in each  group.  The length  of group.size should be  the same  as the\n',
'number of groups.  The  sum of the members of  group.size need not add\n',
'to one, they will be normalized.\n',
'\n',
'If there are covariates  and several groups,  the argument natx should\n',
'be set  to  provide unequal  proportions  at each  design point.  natx\n',
'should have the same dimensions  as xpoints; natx[i,j] is the relative\n',
'proportion of subjects in group i at  covariate value j.  By insertion\n',
'of  zeros  in  natx,  different groups  can have  different  covariate\n',
'values.\n',
'\n',
'For multivariate designs,   the argument rss[i] provides  the relative\n',
"sample size of the i'th design point.  The  length of rss should equal\n",
'the number of rows in xpoints.\n','\n')
pause()
next
    }

    if (which == 5){
###Sig, power, sample.size

      cat( 
'                 significance, power and sample.size\n',
'\n',
'Exactly one of these must  be omitted from the problem  specification.\n',
'Lists of the other two  can be specified for  tables of sample size or\n',
'power.  For example, the following is legal.\n',
'\n',
'sample.size <- c( 35, 50, 100 )\n',
'significance <- c( 0.05, 0.05, 0.05 )\n'
          )
pause()
next
    }
  }
}

binomial.design <- function(method,
                            theta.ha,design="linear",link="logistic",
                            xpoints, natx=1, group.size=1,
                            const.constraint.group,
                            const.constraint.param,
                            const.constraint.value,
                            equal.constraint.group,
                            equal.constraint.param,
                            significance,power,sample.size,
                            smo.df=T)
#----------------------------------------------------------------------
# Name: binomial.design
#
# Description:
#      Calculates the estimated non-centraility parameter using the
# likelihood ratio or SMO method for a single observation for a binomial
# design where the parameter p, probability of an event, depends on a 
# covariate, x, through a logistic, p = exp(u)/(1+exp(u)), or 
# complementary log, p = 1 - exp(-exp(u)), model. The variable u 
# is either a linear, u = a + b*x, or quadratic, u = a + b*x + c*x^2,
# function of the covariate x.  Uses the non-centrality parameter to 
# calculate the significance, power or sample size.
#
# Model Parameters:
# "p" -- The probability of an event.
# 
# User Parameters:
# ("a","b") for linear design and ("a","b","c") for quadratic design.
# 
# Arguments:
# method --
#      The method used. One of {"lr" or "smo"} for the
#      likelihood ratio or SMO method.
#
# theta.ha --
#      Matrix of parameters of the linear part of the model.
#      Each row represents a group. If design is "linear" then
#      theta.ha has two columns, the values of (a,b) for each
#      group. If design is "quadratic" then theta.ha has three
#      columns, the values of (a,b,c) for each group.
#
# design --
#     One of {"linear", "quadratic"} Only enough to ensure a unique
#     match need be supplied. If design is "linear" then u = a + b*x;
#     if design is "quadratic" then u = a + b*x + c*x^2.
#
# link --
#     One of {"logistic", "complementary log"} Only enough to ensure
#     a unique match need be supplied. If link is "logistic" then
#     p = exp(u)/(1+exp(u)); if link is "complementary log" then
#     p = 1-exp(-exp(u)).
#
# xpoints --
#     Matrix of covariate values for each group.
#     Each row represents a group.
#
# natx --
#     Matrix of number of observations at each covariate value in
#     each group. Columns represent covariate values; rows represent
#     groups. At covariate value xpoint[i,j] there are natx[i,j] 
#     observations. If the number of observations at each covariate
#     value is the same for each group; natx can be a vector.
#     If the number of observations is the same for each covariate
#     value in each group; natx can be a scalar.
#
# group.size --
#      The relative number of observations in each group.
#      If group.size is identically 1 there are equal observations
#      in each group.
#
# const.constraint.group --
#      A vector of the group indicators for each constant constraint.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.group --
#      A vector of the group indicators for each parameter being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#
# smo.df --
#      Only relevent if method is "smo".
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n.
#----------------------------------------------------------------------
{
   #---------------#
   # check method. #
   #---------------#
   imethod <- pmatch(method,c("lr","smo"))
   if (is.na(imethod)) stop("method must be one of 'lr' or 'smo'")

   #--------------------------------#
   # set idesign.                   #
   # 2 for linear" 3 for quadratic. #
   #--------------------------------#
   designs <- c("kgp","linear","quadratic")
   idesign <- pmatch(design,c("linear","quadratic"))
   if (is.na(idesign)) stop("design must be one of {'linear','quadratic'}")
   idesign <- idesign + 1

   #------------------------------------------#
   # set ilink.                               #
   # 1 for logistic; 2 for complementary log. #
   #------------------------------------------#
   links <- c("logistic","complementary log")
   ilink <- pmatch(link,links)
   if (is.na(ilink))
      stop("link must be one of {'logistic','complementary log'}")

   #----------------#
   # set constants. #
   #----------------#
   imodel <- 1
   if (idesign == 2) {
      nparam <- 2
      params <- c("a","b")
   } else {
      nparam <- 3
      params <- c("a","b","c")
   }

   #-----------------#
   # check theta.ha. #
   #-----------------#
   if (is.vector(theta.ha)) theta.ha <- t(as.matrix(theta.ha))
   dimt <- dim(theta.ha)
   ngroup <- dimt[1]
   ltheta <- dimt[2]
   if ((idesign == 2) & (ltheta != 2))
      stop("for a 'linear' model theta.ha must have 2 columns")
   if ((idesign == 3) & (ltheta != 3))
      stop("for a 'quadratic' model theta.ha must have 3 columns")

   #----------------#
   # check xpoints. #
   #----------------#
   if (is.vector(xpoints)) {
      xpoints <- matrix(xpoints,ngroup,length(xpoints),byrow=T)
      dimp <- dim(xpoints)
   } else {
      dimp <- dim(xpoints)
      if (dimp[1] != ngroup)
      stop("number of rows of xpoints and theta.ha must match")
   }
   npoints <- dimp[2]

   #-------------#
   # check natx. #
   #-------------#
   if (is.vector(natx)) {
      if (length(natx) == 1)
         natx <- matrix(natx,ngroup,dimp[2],byrow=T)
      else {
         if (length(natx) != dimp[2] )
            stop ("length of natx must match number of xpoints")
          natx <- matrix(natx,ngroup,dimp[2],byrow=T)
      }
      dimn <- dim(natx)
   } else {
      dimn <- dim(natx)
      if (dimn[1] != dimp[1] || dimn[2] != dimp[2])
         stop("xpoints and natx must have the same dimensions")
   }

   #-------------------#
   # check group.size. #
   #-------------------#
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(group.size,ngroup)
   else if (ngroup != lngrpsz)
      stop("number of rows of theta.ha and length of group.size must match")

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   if (missing(const.constraint.group)) const.constraint.group <- -1
   else qall <- F
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   if (missing(equal.constraint.group)) equal.constraint.group <- -1
   else qall <- F
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                     nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size

   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   if (imethod == 1) {
      info.mat <- info.binomial.design(designs[idesign],links[ilink],
                  theta.ha,xpoints,natx,group.size)
      noncent.obj <- lr.noncent(theta.ha,info.mat,constraint)
      if (icalc == 1)
         significance <- lr.sig(noncent.obj,sample.size,power)
      else if (icalc == 2)
         power <- lr.power(noncent.obj,sample.size,significance)
      else
         sample.size <- lr.n(noncent.obj,power,significance)
   } else {
      noncent.obj <- noncent.binomial.design(theta.ha,constraint,xpoints,
                     designs[idesign],links[ilink],natx,group.size)
      if (icalc == 1)
         significance <- self.sig(noncent.obj,sample.size,power,smo.df)
      else if (icalc == 2)
         power <- self.power(noncent.obj,sample.size,significance,smo.df)
      else
         sample.size <- self.n(noncent.obj,power,significance,smo.df)
   }

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   methods <- c("LR","SMO")
   designs <- c("Kgp","Linear","Quadratic")
   links <- c("Logistic","Complementary Log")
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method=methods[imethod],model="Binomial",
               design=designs[idesign],
               link=links[ilink],parameters=params,param.ha=theta.ha,
               ngroup=ngroup,group.size=group.size,
               xpoints=xpoints,natx=natx,
               constraint=constraint,calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   if (imethod == 2)
      ans$smo.df <- smo.df
   class(ans) <- "asypow"
   return(ans)
}
binomial.kgp <- function(method,
                         p.ha,group.size=1,
                         const.constraint.group,
                         const.constraint.param,
                         const.constraint.value,
                         equal.constraint.group,
                         equal.constraint.param,
                         significance,power,sample.size,
                         smo.df=T)
#----------------------------------------------------------------------
# Name: binomial.kgp
#
# Description:
#      Calculates the estimated non-centraility parameter for 
# a single observation for single or multiple group binomial 
# distribution using the likelihood ratio or SMO method. Uses the
# non-centrality parameter to calculate the significance,
# power or sample size.
#
# Model Parameters:
# "p" -- The probability of an event.
#
# Arguments:
# method --
#      The method used. One of {"lr" or "smo"} for the
#      likelihood ratio or SMO method.
#
# p.ha --
#      Alternative hypothesis probability of an event.
#      If there is more than 1 group p.ha is a matrix
#      with ngroup columns where p.ha[i,1] is the probability
#      of an event in group i. P.ha can also be a vector
#      of length ngroup.
#
# group.size --
#      The relative number of observations in each group.
#      If group.size is identically 1 there are equal observations
#      in each group.
#
# const.constraint.group --
#      A vector of the group indicators for each constant constraint.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint. In this case the only avaiable
#      parameter is "p" and this vector is only included for
#      completeness with other asypow functions.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.group --
#      A vector of the group indicators for each parameter being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#
# smo.df --
#      Only relevent if method is "smo".
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n. 
#----------------------------------------------------------------------
{
   #----------------#
   # Set constants. #
   #----------------#
   nparam <- 1
   params <- "p"
   imodel <- 1
   idesign <- 1

   #---------------#
   # check method. #
   #---------------#
   imethod <- pmatch(method,c("lr","smo"))
   if (is.na(imethod)) stop("method must be one of 'lr' or 'smo'")

   #--------------------------------------#
   # check to see that p.ha is in (0,1).  #
   #--------------------------------------#
   if (is.matrix(p.ha)) p.ha <- as.vector(p.ha)
   if (any(p.ha <= 0.0 | p.ha >= 1.0)) stop ("p.ha must be in range (0,1)")
   ngroup <- length(p.ha)

   #-------------------#
   # check group.size. #
   #-------------------#
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(1,ngroup)
   else if (ngroup != lngrpsz)
      stop ("number of rows in p.ha and length of group.size must match")

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   if (missing(const.constraint.group)) const.constraint.group <- -1
   else qall <- F
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   if (missing(equal.constraint.group)) equal.constraint.group <- -1
   else qall <- F
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                     nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size
  
   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   if (imethod == 1) {
      info.mat <- info.binomial.kgp(p.ha,group.size)
      noncent.obj <- lr.noncent(p.ha,info.mat,constraint)
      if (icalc == 1)
         significance <- lr.sig(noncent.obj,sample.size,power)
      else if (icalc == 2)
         power <- lr.power(noncent.obj,sample.size,significance)
      else
         sample.size <- lr.n(noncent.obj,power,significance)
   } else {
      noncent.obj <- noncent.binomial.kgp(p.ha,constraint,group.size)
      if (icalc == 1)
         significance <- self.sig(noncent.obj,sample.size,power,smo.df)
      else if (icalc == 2)
         power <- self.power(noncent.obj,sample.size,significance,smo.df)
      else
         sample.size <- self.n(noncent.obj,power,significance,smo.df)
   }

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   methods <- c("LR","SMO")
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method=methods[imethod],model="Binomial",design="Kgp",
               parameters=params,param.ha=matrix(p.ha,ncol=1),
               ngroup=ngroup,group.size=group.size,constraint=constraint,
               calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   if (imethod == 2)
      ans$smo.df <- smo.df
   class(ans) <- "asypow"
   return(ans)
}
cdfchn <- function(which,p=0.0,x=0.0,df=0.0,pnonc=0.0)
#**********************************************************************
#
#               Cumulative Distribution Function
#               Non-central Chi-Square
#
#
#                              Function
#
#
#     Calculates any one parameter of the non-central chi-square
#     distribution given values for the others.
#
#
#                              Arguments
#
#
#     WHICH --> Integer indicating which of the next three argument
#               values is to be calculated from the others.
#               Input range: 1..4
#               iwhich = 1 : Calculate P from X and DF
#               iwhich = 2 : Calculate X from P,DF and PNONC
#               iwhich = 3 : Calculate DF from P,X and PNONC
#               iwhich = 3 : Calculate PNONC from P,X and DF
#                    INTEGER WHICH
#
#     P <--> The integral from 0 to X of the non-central chi-square
#            distribution.
#            Input range: [0, 1-1E-16).
#                    DOUBLE PRECISION P
#
#     X <--> Upper limit of integration of the non-central
#            chi-square distribution.
#            Input range: [0, +infinity).
#            Search range: [0,1E300]
#                    DOUBLE PRECISION X
#
#     DF <--> Degrees of freedom of the non-central
#             chi-square distribution.
#             Input range: (0, +infinity).
#             Search range: [ 1E-300, 1E300]
#                    DOUBLE PRECISION DF
#
#     PNONC <--> Non-centrality parameter of the non-central
#                chi-square distribution.
#                Input range: [0, +infinity).
#                Search range: [0,1E4]
#                    DOUBLE PRECISION PNONC
#
#                              Method
#
#
#     Formula  26.4.25   of   Abramowitz   and   Stegun,  Handbook  of
#     Mathematical  Functions (1966) is used to compute the cumulative
#     distribution function.
#
#     Computation of other parameters involve a seach for a value that
#     produces  the desired  value  of P.   The search relies  on  the
#     monotinicity of P with the other parameter.
#
#
#                            WARNING
#
#     The computation time  required for this  routine is proportional
#     to the noncentrality  parameter  (PNONC).  Very large  values of
#     this parameter can consume immense  computer resources.  This is
#     why the search range is bounded by 10,000.
#
#**********************************************************************
{
  request <- c("p","x","df","pnonc")

# **** cdfchn should be loaded before the next statement ****

  ans <- .Fortran("cdfchn",
		  as.integer(which),
		  as.double(p),
		  as.double(1.0-p),
		  as.double(x),
                  as.double(df),
		  as.double(pnonc),
		  status=as.integer(0),
		  bound = as.double(0))
  status <- ans$status
  bound <- ans$bound
  if (status != 0) {
    if (status == -1) stop("which should be 1,2,3 or 4")
    else if (status == -2) stop("p should be in range [0, 1-1E-16)")
    else if (status == -3) stop("x should be in range [0, +infinity)")
    else if (status == -4) stop("df should be in range [0, +infinity)")
    else if (status == -5) stop("pnonc should be in range [0, +infinity)")
    else if (status == 1) 
	stop(paste(request[which],"lower than lowest search bound",bound))
    else if (status == 2)
	stop(paste(request[which],"larger than largest search bound",bound))
    else
        stop("SMALL, X, BIG not monotone in INVR")
  }
  else {
    if (which == 1) return(list(p=ans[[2]]))
    else if (which == 2) return(list(x=ans[[4]]))
    else if (which == 3) return(list(df=ans[[5]]))
    else if (which == 4) return(list(pnonc=ans[[6]]))
  }
}
check.spss <- function(significance,power,sample.size)
#----------------------------------------------------------------------
# Name: check.spss
#
# Description:
#      Checks the values of significance, power and sample size.
#
# Arguments:
# significance --
#      The significance level of the test.
#      -1 indicates it is missing.
#
# power --
#      The power of the test.
#      -1 indicates it is missing.
#
# sample.size --
#      The sample size of the test.
#      -1 indicates it is missing.
#
# Returns:
# ncalc --
#      The number of calculations required.
#
# icalc -- 
#      An indicator specifying which value is to be calculated
#      from the other 2. 
#          1 - Calculate significance from power and sample size.
#          2 - Calculate power from significance and sample size.
#          3 - Calculate sample size from signficiance and power.
#
# significance, power, sample.size --
#      Vectors used in calculations.
#----------------------------------------------------------------------
{

   # Calculate significance
   if ((significance[1] == -1) & (power[1] != -1) & (sample.size[1] != -1)) {
      icalc <- 1
      n <- length(power)
      m <- length(sample.size)
      if (n !=1 & m!= 1 & n != m)
                stop("lengths of power and sample.size must match")
      if (n == 1) power <- rep(power,length=m)
      if (m == 1) sample.size <- rep(sample.size,length=n)
      if ((any(power <= 0.0)) | (any(power >= 1.0)))
         stop("Power must in range (0,1)")
      if (any(sample.size < 1))
         stop("Sample.size must be greater than or equal to 1")
      ncalc <- length(sample.size)
      significance <- rep(NA,ncalc)
   } else if ((power[1] == -1) & (significance[1] != -1) & 
                                                   (sample.size[1] != -1)) {
      icalc <- 2
      n <- length(significance)
      m <- length(sample.size)
      if (n !=1 & m!= 1 & n != m)
                stop("lengths of significance and sample.size must match")
      if (n == 1) significance <- rep(significance,length=m)
      if (m == 1) sample.size <- rep(sample.size,length=n)
      if ((any(significance <= 0.0)) | (any(significance >= 1.0)))
         stop("Significance must in range (0,1)")
      if (any(sample.size < 1))
         stop("Sample.size must be greater than or equal to 1")
      ncalc <- length(sample.size)
      power <- rep(NA,ncalc)
   } else if ((sample.size[1] == -1) & (power[1] != -1) & 
                                                   (significance[1] != -1)) {
      icalc <- 3
      n <- length(significance)
      m <- length(power)
      if (n !=1 & m!= 1 & n != m)
                stop("lengths of significance and power must match")
      if (n == 1) significance <- rep(significance,length=m)
      if (m == 1) power <- rep(power,length=n)
      if ((any(significance <= 0.0)) | (any(significance >= 1.0)))
         stop("Significance must in range (0,1)")
      if ((any(power <= 0.0)) | (any(power >= 1.0)))
         stop("Power must in range (0,1)")
      ncalc <- length(power)
      sample.size <- rep(NA,ncalc)
   } else {
      stop("Enter exactly two of (significance, power and sample.size)")
   }

   return(ncalc,icalc,significance,power,sample.size)
}
construct.a <- function(constraints,p) {
#----------------------------------------------------------------------
# Name: construct.a
#
# Description:
#      Contructs the matrix A using constraints. A is a matrix such
# that A*theta = (phi,lambda) where phi are the parameters
# constrained by the null hypothesis and lambda and the parameters
# which are not constrained.
#
# Arguments:
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#
# p --
#      The number of parameters in the model.
#
# Return Values:
# a  -- matrix that will multiply parameters.
#
# phi.ho -- values of constrained parameters under the null model.
#
# ix.con -- ixdex corresponding to phi.ho.
#----------------------------------------------------------------------

      s <- dim(constraints)[1]
      r <- p - s

      ix.con <- constraints[,2]
      if (r > 0) {
           ix.unc <- (1:p)[-ix.con]
           A <- matrix(0,ncol=p,nrow=r)
           for(i in 1:r) A[i,ix.unc[i]] <- 1
      }
      else A <- NULL

      phi.ho <- rep(NA,s)
      Acon <- matrix(0,ncol=p,nrow=s)
      for(i in 1:s) {
           if(constraints[i,1] == 1) {
                Acon[i,constraints[i,2]] <- 1
                phi.ho[i] <- constraints[i,3]
           }
           else {
                Acon[i,constraints[i,2]] <- 1
                Acon[i,constraints[i,3]] <- -1
                phi.ho[i] <- 0
           }
      }

      return(list(a=rbind(Acon,A),phi.ho=phi.ho,ix.con=ix.con,
                                              constraints=constraints))
}
convert.constraints <- function(imodel,idesign,nparam,param,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param) {
#----------------------------------------------------------------------
# Name: convert.constraints
#
# Description:
#      Creates a constraint matrix from the const.constraint.*
# and equal.constraint.* vectors.
#
# Arguments:
# imodel --
#      Integer indicator for model selected. Models 1 to 8 are
#      "Binomial","Poisson","Multinomial","Ordinal",
#      "Exponential Survival","Multivariate Logistic",
#      "Multivariate Log-Linear" and "Generic" respectively.
#
# idesign --
#      Integer indicator for the design selected. Designs 1, 2
#      and 3 are "Kgp", "Linear" and "Quadratic" respectively.
#
# nparam --
#      Number of parameters in the model.
#
# param --
#      Vector of characters descriptions of the parameters in
#      the model.
#
# ngroup --
#      Number of groups in the design.
#
# const.constraint.group --
#      A vector of the group indicators for each constant constraint.
#      (-1 indicates a missing vector which is allowed when
#      there is only 1 group.)
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint. (-1 indicates a missing vector 
#      which is allowed when there is only 1 parameter.)
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#      (-1 indicates a missing vector which is allowed when
#      there are no constant constraints.)
#
# equal.constraint.group --
#      A vector of the group indicators for each parameter being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#      (-1 indicates a missing vector which is allowed when
#      there is only 1 group.)
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#      (-1 indicates a missing vector which is allowed when
#      there is only 1 parameter.)
#
# Return Value:
# A constraint matrix.
#----------------------------------------------------------------------

   # Initialize the constraint matrix.
   constraint <- vector()

   ######################################
   # Deal with the constant constraints #
   ######################################

   if (const.constraint.value[1] != -1) {

      # Create the 3 vectors igroup,iparam and value
      # igroup -- The group number of each constant constraint
      # iparam -- The number of the parameter for each const. constraint
      # value -- The value for each constant constraint
      value <- const.constraint.value
      nconst <- length(value)
      if (const.constraint.group[1] == -1) {
         if (ngroup != 1)
            stop(paste("const.constraint.group must be input when",
                       "there is more than 1 group."))
         else
            igroup <- rep(1,nconst)
      } else {
         if (!is.numeric(const.constraint.group))
            stop("bad const.constraint.group vector")
         if (length(const.constraint.group) != nconst)
            stop(paste("const.constraint.param, const.constraint.group and",
                       "const.constraint.value must have the same length"))
         else {
            igroup <- as.integer(const.constraint.group)
            if ((any(igroup < 1)) | (any(igroup > ngroup)))
               stop(paste("bad const.constraint.group vector. ",
                          "Not in range [1,",ngroup,"]",sep=""))
         }
      }
      if (const.constraint.param[1] == -1) {
         if (nparam != 1)
            stop(paste("const.constraint.param must be input when",
                       "there is more than 1 parameter."))
         else
            iparam <- rep(1,nconst)
      } else {
         if (length(const.constraint.param) != nconst)
            stop(paste("const.constraint.param, const.constraint.group and",
                       "const.constraint.value must have the same length"))
         else {
            iparam <- rep(NA,nconst)
            for (i in 1:nconst) 
               iparam[i] <- pmatch(const.constraint.param[i],param)
            if (any(is.na(iparam)))
              stop(paste("bad const.constraint.param vector.",
                          const.constraint.param[is.na(iparam)],
                          "not valid"))
         }
      }

      # Add each constraint to the model.
      for (i in 1:nconst) {

         # Check to see that the constraint is unique and OK according
         # to the model.
         if (idesign == 1) {
            if ((imodel == 1) | (imodel == 3) | (imodel == 4)) {
               if ((value[i] <= 0.0) | (value[i] >= 1.0)) {
                  cat(paste("Parameter",param[iparam[i]],
                      "not in range (0,1).\n"))
                  stop("bad constant constraint")
                }
            }
            if ((imodel == 2) | (imodel == 5) | (imodel == 7)) {
               if (value[i] <= 0.0) {
                  cat(paste("Parameter",param[iparam[i]],
                            "not in range (0,Inf].\n"))
                  stop("bad constant constraint")
                }
            }
         }

         iloc <- (igroup[i]-1)*nparam+iparam[i]
         if (length(constraint) > 0) {
            ind <- ((constraint[,1] == 2) & 
                    ((constraint[,2] == iloc) | (constraint[,3] == iloc)))
            if (any(ind)) {
               mssg <- paste("Parameter ",param[iparam[i]],sep="")
               if (ngroup > 1) 
                  mssg <- paste(mssg," in group ",igroup[i],sep="")
               mssg <- paste(mssg,
                       "already included in an equality constraint.")
               cat(mssg,"\n")
               stop("bad constant constraint")
            }
            ind <- ((constraint[,1] == 1) & (constraint[,2] == iloc))
            if (any(ind)) {
               mssg <- paste("Parameter ",param[iparam[i]],sep="")
               if (ngroup > 1) 
                  mssg <- paste(mssg," in group ",igroup[i],sep="")
               mssg <- paste(mssg," already set to ",constraint[ind,3],
                             ".",sep="")
               cat(mssg,"\n")
               stop("bad constant constraint")
            }
         }
         constraint <- rbind(constraint,c(1,iloc,value[i]))
      }
   } else if ((const.constraint.param[1] != -1) | 
              (const.constraint.group[1] != -1)) {
      stop("constant value not specified in const.constraint.value")
   }

   ##################################
   # Deal with equality constraints #
   ##################################
   group.missing <- !(is.list(equal.constraint.group))
   if (group.missing) group.missing <- (equal.constraint.group[1] == -1)
   param.missing <- !(is.list(equal.constraint.param))
   if (param.missing) param.missing <- (equal.constraint.param[1] == -1)
   if ((group.missing) & (param.missing)) return(constraint)
   ntot <- nparam*ngroup
   qequal <- ((idesign != 1) | (ntot > 1))
   if (!qequal) stop("equality constraints not allowed")
   if (group.missing) {
      if (ngroup != 1)
         stop(paste("equal.constraint.group must be input when",
                    "there is more than 1 group."))
      if (!is.list(equal.constraint.param)) 
         equal.constraint.param <- list(equal.constraint.param)
      nequal.constraint <- length(equal.constraint.param)
   } else if (param.missing) {
      if (nparam != 1)
         stop(paste("equal.constraint.param must be input when",
                    "there is more than 1 parameter."))
      if (!is.list(equal.constraint.group))
         equal.constraint.group <- list(equal.constraint.group)
      nequal.constraint <- length(equal.constraint.group)
   } else {
      if (!is.list(equal.constraint.param)) 
         equal.constraint.param <- list(equal.constraint.param)
      if (!is.list(equal.constraint.group))
         equal.constraint.group <- list(equal.constraint.group)
      nequal.constraint <- length(equal.constraint.param)
      if (length(equal.constraint.group) != nequal.constraint)
         stop(paste("length of equal.constraint.param list and",
                    "equal.constraint.group list must be the same"))
   }

   for (i in 1:nequal.constraint) {
      nequal <- 0
      iparam <- -1
      igroup <- -1
      if (!param.missing) {
         nequal <- length(equal.constraint.param[[i]])
         iparam <- rep(NA,nequal)
         for (j in 1:nequal) {
            iparam[j] <- pmatch(equal.constraint.param[[i]][j],param)
            if (is.na(iparam[j]))
               stop(paste(equal.constraint.param[[i]][j],
                          "is not a valid parameter"))
         }
      }
      if (!group.missing) {
         if (!is.numeric(equal.constraint.group[[i]]))
           stop("bad equal.constraint.group value")
         if (nequal == 0) nequal <- length(equal.constraint.group[[i]])
         else {
            if (length(equal.constraint.group[[i]]) != nequal)
               stop(paste("length of equal.constraint.param and",
                    "equal.constraint.group vectors must be the same."))
         }
         igroup <- as.integer(equal.constraint.group[[i]])
         if ((any(igroup < 1)) | (any(igroup > ngroup)))
            stop(paste("bad equal.constraint.group vector; ",
                       "not in range [1,",ngroup,"]",sep=""))
      }
      if (nequal < 2) {
         cat("Must set at least 2 parameters equal.\n")
         stop("bad equality constraint")
      }
      if (iparam[1] == -1) iparam <- rep(1,nequal)
      if (igroup[1] == -1) igroup <- rep(1,nequal)
      if (imodel == 4) {
         if (idesign == 1) {
            if (any(duplicated(igroup)))
               stop(paste("category probabilities in the same group",
                    "can not be set equal in the oridinal model"))
         } else {
            group.dup <- duplicated(igroup)
            if (any(group.dup)) {
               for (i in igroup[group.dup]) {
                  param.dup <- iparam[(igroup == i)]
                  if (sum(param.dup < (nparam-idesign)) > 1)
                     stop(paste("intercept terms in the same group",
                          "can not be set equal in the oridinal model"))
               }
            }
         }
      }
      equal.list <- (igroup-1)*nparam+iparam

      # Check to see that the equality constraints are unique
      # and update the constraint matrix.
      if (any(duplicated(equal.list)))
         stop("parameters in equality constraint must be unique")
      if (length(constraint) > 0) {
         constants <- constraint[(constraint[,1] == 1),2]
         if (length(constants) > 0) {
            for (i in 1:nequal) {
               if (any(equal.list[i] == constants)) {
                  mssg <- paste("Parameter ",param[iparam[i]],sep="")
                  if (ngroup > 1) 
                     mssg <- paste(mssg," in group ",igroup[i],sep="")
                  mssg <- paste(mssg,"already set to a constant value.")
                  cat(mssg,"\n")
                  stop("bad equality constraint")
               }
             }
         }
         ind <- rep(T,nrow(constraint))
         for (i in 1:nrow(constraint)) {
            if (constraint[i,1] == 2) {
               if ((any(equal.list == constraint[i,2])) | 
                   (any(equal.list == constraint[i,3]))) {
                  equal.list <- unique(c(equal.list,constraint[i,2:3]))
                  ind[i] <- F
               }
            }
         }
         constraint <- constraint[ind,]
         if (is.vector(constraint)) constraint <- matrix(constraint,nrow=1)
      }
      equal.list <- sort(equal.list)
      nequal <- length(equal.list)
      for (i in 2:nequal)
         constraint <- rbind(constraint,c(2,equal.list[i-1],equal.list[i]))
   }

}
derivs.link <- function(u,link){
#-----------------------------------------------------------------------
# Name: derivs.link
#
# Description:
#      Value and first two derivatives of link function.
#
# Arguments:
# u --
#      Value of the argument to the link function.
#
# link --
#      (1) Logistic
#          g(u) = exp(u)/(1+exp(u))
#      (2) Complementary log-log
#          g(u) = 1 - exp( -exp(u) )
# Returns:
# A vector of length three:
#     [1] - value of link function at u
#     [2] - first derivative of link function wrt u
#     [3] - second derivative of link function wrt u
#-----------------------------------------------------------------------
  ans <- rep( 0, 3 )
  ans[1] <- 1
  BIG <- 690
  if ( u > BIG ) return( ans )
  if (link < 1 || link > 2) stop('Illegal value of link')

### Logistic

  if (link == 1 ) {
    tmp <- exp(u)
    ans[1] <- tmp / ( 1 + tmp )
    ans[2] <- ans[1] * ( 1 - ans[1] )
    ans[3] <- ans[2] * ( 1 - 2*ans[1] )  }

    else {
      tmp <- exp(u)
      ans[1] <- 1 - exp( -tmp )
      ans[2] <- exp( u - tmp )
      ans[3] <- ans[2] - exp( 2*u - tmp )   }

  return( ans )     }
enter.constraints <- function(imodel,idesign,nparam,param,ngroup) {
#----------------------------------------------------------------------
# Name: enter.constraints
#
# Description:
#      Creates a constraint matrix by querying the user.
#
# Arguments:
# imodel --
#      Integer indicator for model selected. Models 1 to 8 are
#      "Binomial","Poisson","Multinomial","Ordinal",
#      "Exponential Survival","Multivariate Logistic",
#      "Multivariate Log-Linear" and "Generic" respectively.
#
# idesign --
#      Integer indicator for the design selected. Designs 1, 2
#      and 3 are "Raw", "Linear" and "Quadratic" respectively.
#
# nparam --
#      Number of parameters in the model. For the Multinomial
#      and Ordinal models this is the number of categories minus 1.
#      For the Multivariate Logistic and Multivariate Log-Linear
#      models this is the number of covariates. For the Generic
#      model this is the number of parameters. For all other models
#      this argument is ignored. If missing and required the user
#      will be queried to input the appropriate value.
#
# param --
#      Vector of characters descriptions of the parameters in
#      the model.
#
# ngroup --
#      Number of groups for all models except the Multivariate Logistic
#      and Multivariate Log-Linear. If missing the user will be queried
#      to input ngroup.
#
# Return Value:
# A constraint matrix.
#----------------------------------------------------------------------

   #-----------------#
   # Set the prompt. #
   #-----------------#
   ppt <- "? "

   #------------------#
   # Output a header. #
   #------------------#
   models <- c("Binomial","Poisson","Multinomial","Ordinal",
               "Exponential Survival","Multivariate Logistic",
               "Multivariate Log-Linear","Generic")
   mssg <- "\nEntering Constraints for a"
   if (ngroup > 1) mssg <- paste(mssg,ngroup,"Group")
   if ((imodel == 6) | (imodel == 7))
      mssg <- paste(mssg,models[imodel])
   else if (imodel == 8)
      mssg <- paste(mssg,"Model")
   else {
      if (idesign == 1)
         mssg <- paste(mssg,"Raw",models[imodel],"Model")
      else if (idesign == 2)
         mssg <- paste(mssg,"Linear",models[imodel],"Design")
      else
         mssg <- paste(mssg,"Quadratic",models[imodel],"Design")
   }
   cat(mssg,"\n")

   #--------------------------------------#
   # Allow the user to enter constraints. #
   #--------------------------------------#
   ntot <- nparam*ngroup
   action <- 1
   qequal <- ((idesign != 1) | (ntot > 1) | ((imodel == 4) & (idesign == 1)))
   constraint <- vector()
   while(action != 0) {
 
      qprint <- (length(constraint) > 0)
      # Query the user for a selection.
      cat("\nSelect an option\n")
      cat("(1) Enter a constant constraint\n")
      if (qequal) {
         cat("(2) Enter an equality constraint\n")
         if (qprint) {
            cat("(3) Print constraints\n")
            cat("(4) Delete constraints\n")
         }
      } else {
         if (qprint) {
            cat("(2) Print constraints\n")
            cat("(3) Delete constraints\n")
         }
      }
      cat("(0) Finished entering constraints\n")
      action <- eval(parse(prompt=ppt))
      action <- as.integer(action)
      if ((qprint) & (!qequal) & (action >= 2)) action <- action + 1
      if (!((action == 0) | (action == 1) | ((qequal) & (action == 2)) |
           ((qprint) & ((action == 3) | (action == 4)))))
         stop("Bad choice")

      if (action == 1) 
         constraint <- get.constant.constraint(imodel,idesign,nparam,
                       param,ngroup,constraint)
 
      else if (action == 2)
         constraint <- get.equal.constraint(imodel,idesign,nparam,
                       param,ngroup,constraint)

      else if (action == 3) 
         ans <- print.constraints(nparam,param,ngroup,constraint)
         
      else if (action == 4) {
         ans <- print.constraints(nparam,param,ngroup,constraint)
         n <- length(ans)
         cat("\nEnter the number of the constraint to be deleted.\n")
         cat("Enter 0 to cancel.\n")
         idelete <- eval(parse(prompt=ppt))
         idelete <- as.integer(idelete)
         if (idelete != 0) {
            if (!any(idelete == 1:n))
               cat("Bad value.\n")
            else {
               row.delete <- ans[[idelete]]
               constraint <- constraint[-row.delete,]
               if ((!is.matrix(constraint)) & (length(constraint) > 0))
                  constraint <- matrix(constraint,nrow=1,ncol=3)
            }
         }
      }
   }

   #---------#
   # Return. #
   #---------#
   return(constraint)
}
expsurv.design <- function(method,
                           theta.ha,L,design="linear",
                           xpoints, natx=1, group.size=1,
                           const.constraint.group,
                           const.constraint.param,
                           const.constraint.value,
                           equal.constraint.group,
                           equal.constraint.param,
                           significance,power,sample.size,
                           smo.df=T)
#----------------------------------------------------------------------
# Name: expsurv.design
#
# Description:
#      Calculates the estimated non-centraility parameter using
# the SMO method for a single observation for a clinical trial
# with exponential survival where the rate, depends on a covariate
# x, via the equation rate=exp(u). The variable u is either a 
# linear, u = a + b*x, or quadratic, u = a + b*x + c*x^2, function 
# of the covariate x. Uses the non-centrality parameter to 
# calculate the significance, power or sample size.
#
#
# Model Parameters:
# "rate" -- The exponential failure rate or inverse mean.
# 
# User Parameters:
# ("a","b") for linear design and ("a","b","c") for quadratic design.
# 
# Arguments:
# method --
#      The method used. One of {"lr" or "smo"} for the
#      likelihood ratio or SMO method.
#
# theta.ha --
#      Matrix of parameters of the linear part of the model.
#      Each row represents a group. If design is "linear" then
#      theta.ha has two columns, the values of (a,b) for each
#      group. If design is "quadratic" then theta.ha has three
#      columns, the values of (a,b,c) for each group.
#
# L --
#      The length of the study. If L is length 1 each group has
#      a study of length L. Otherwise L is a vector of length
#      ngroup, where L[i] is the length of the study for
#      group i.
#
# design --
#     One of {"linear", "quadratic"} Only enough to ensure a unique
#     match need be supplied. If model is "linear" then u = a + b*x;
#     if model is "quadratic" then u = a + b*x + c*x^2.
#
# natx --
#     Matrix of number of observations at each covariate value in
#     each group. Columns represent covariate values; rows represent
#     groups. At covariate value xpoint[i,j] there are natx[i,j] 
#     observations. If the number of observations at each covariate
#     value is the same for each group; natx can be a vector.
#     If the number of observations is the same for each covariate
#     value in each group; natx can be a scalar.
#
# group.size --
#      The relative number of observations in each group.
#      If group.size is identically 1 there are equal observations
#      in each group.
#
# const.constraint.group --
#      A vector of the group indicators for each constant constraint.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.group --
#      A vector of the group indicators for each parameter being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#
# smo.df --
#      Only relevent if method is "smo".
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n.
#----------------------------------------------------------------------
{
   #---------------#
   # check method. #
   #---------------#
   imethod <- pmatch(method,c("lr","smo"))
   if (is.na(imethod)) stop("method must be one of 'lr' or 'smo'")

   #--------------------------------#
   # set idesign.                   #
   # 2 for linear" 3 for quadratic. #
   #--------------------------------#
   designs <- c("kgp","linear","quadratic")
   idesign <- pmatch(design,c("linear","quadratic"))
   if (is.na(idesign)) stop("design must be one of {'linear','quadratic'}")
   idesign <- idesign + 1

   #----------------#
   # set constants. #
   #----------------#
   imodel <- 5
   if (idesign == 2) {
      nparam <- 2
      params <- c("a","b")
   } else {
      nparam <- 3
      params <- c("a","b","c")
   }

   #-----------------#
   # check theta.ha. #
   #-----------------#
   if (is.vector(theta.ha)) theta.ha <- t(as.matrix(theta.ha))
   dimt <- dim(theta.ha)
   ngroup <- dimt[1]
   ltheta <- dimt[2]
   if ((idesign == 2) & (ltheta != 2))
      stop("for a 'linear' model theta.ha must have 2 columns")
   if ((idesign == 3) & (ltheta != 3))
      stop("for a 'quadratic' model theta.ha must have 3 columns")

   #----------------#
   # check xpoints. #
   #----------------#
   if (is.vector(xpoints)) {
      xpoints <- matrix(xpoints,ngroup,length(xpoints),byrow=T)
      dimp <- dim(xpoints)
   } else {
      dimp <- dim(xpoints)
      if (dimp[1] != ngroup)
      stop("number of rows of xpoints and theta.ha must match")
   }
   npoints <- dimp[2]

   #-------------#
   # check natx. #
   #-------------#
   if (is.vector(natx)) {
      if (length(natx) == 1)
         natx <- matrix(natx,ngroup,dimp[2],byrow=T)
      else {
         if (length(natx) != dimp[2] )
            stop ("length of natx must match number of xpoints")
          natx <- matrix(natx,ngroup,dimp[2],byrow=T)
      }
      dimn <- dim(natx)
   } else {
      dimn <- dim(natx)
      if (dimn[1] != dimp[1] || dimn[2] != dimp[2])
         stop("xpoints and natx must have the same dimensions")
   }

   #-------------------#
   # check group.size. #
   #-------------------#
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(group.size,ngroup)
   else if (ngroup != lngrpsz)
      stop("number of rows of theta.ha and length of group.size must match")

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   if (missing(const.constraint.group)) const.constraint.group <- -1
   else qall <- F
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   if (missing(equal.constraint.group)) equal.constraint.group <- -1
   else qall <- F
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                      nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size

   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   if (imethod == 1) {
      info.mat <- info.expsurv.design(designs[idesign],theta.ha,
                  L,xpoints,natx,group.size)
      noncent.obj <- lr.noncent(theta.ha,info.mat,constraint)
      if (icalc == 1)
         significance <- lr.sig(noncent.obj,sample.size,power)
      else if (icalc == 2)
         power <- lr.power(noncent.obj,sample.size,significance)
      else
         sample.size <- lr.n(noncent.obj,power,significance)
   } else {
      noncent.obj <- noncent.expsurv.design(theta.ha,L,constraint,xpoints,
                     designs[idesign],natx,group.size)
      if (icalc == 1)
         significance <- self.sig(noncent.obj,sample.size,power,smo.df)
      else if (icalc == 2)
         power <- self.power(noncent.obj,sample.size,significance,smo.df)
      else
         sample.size <- self.n(noncent.obj,power,significance,smo.df)
   }

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   methods <- c("LR","SMO")
   designs <- c("Kgp","Linear","Quadratic")
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method=methods[imethod],model="Exponential Survival",
               design=designs[idesign],
               parameters=params,param.ha=theta.ha,L=L,
               ngroup=ngroup,group.size=group.size,
               xpoints=xpoints,natx=natx,
               constraint=constraint,calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   if (imethod == 2)
      ans$smo.df <- smo.df
   class(ans) <- "asypow"
   return(ans)
}
expsurv.kgp <- function(method,
                        rate.ha,L,group.size=1,
                        const.constraint.group,
                        const.constraint.param,
                        const.constraint.value,
                        equal.constraint.group,
                        equal.constraint.param,
                        significance,power,sample.size,
                        smo.df=T)
#----------------------------------------------------------------------
# Name: expsurv.kgp
#
# Description:
#      Calculates the estimated non-centraility parameter for 
# a single observation for single or multiple group exponential
# survival model using the likelihood ratio or SMO method. Uses the
# non-centrality parameter to calculate the significance,
# power or sample size.
#
# Model Parameters:
# "rate" -- The exponential failure rate or inverse mean.
#
# Arguments:
# method --
#      The method used. One of {"lr" or "smo"} for the
#      likelihood ratio or SMO method.
#
# rate.ha --
#      Alternative hypothesis rate.
#      If there is more than 1 group rate.ha is a matrix
#      with ngroup columns where rate.ha[i,1] is the rate
#      in group i. Rate can also be a vector of length ngroup.
#
# L --
#      The length of the study. If L is length 1 each group has
#      a study of length L. Otherwise L is a vector of length
#      ngroup, where L[i] is the length of the study for
#      group i.
#
# group.size --
#      The relative number of observations in each group.
#      If group.size is identically 1 there are equal observations
#      in each group.
#
# const.constraint.group --
#      A vector of the group indicators for each constant constraint.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint. In this case the only avaiable
#      parameter is "rate" and this vector is only included for
#      completeness with other asypow functions.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.group --
#      A vector of the group indicators for each parameter being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#
# smo.df --
#      Only relevent if method is "smo".
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n. 
#----------------------------------------------------------------------
{
   #----------------#
   # Set constants. #
   #----------------#
   nparam <- 1
   params <- "rate"
   imodel <- 5
   idesign <- 1

   #---------------#
   # check method. #
   #---------------#
   imethod <- pmatch(method,c("lr","smo"))
   if (is.na(imethod)) stop("method must be one of 'lr' or 'smo'")

   #-------------------------------------------#
   # check to see that rate.ha is in (0,Inf].  #
   #-------------------------------------------#
   if (is.matrix(rate.ha)) rate.ha <- as.vector(rate.ha)
   if (any(rate.ha <= 0.0)) stop ("rate.ha must be greater than 0")
   if (any(is.inf(rate.ha))) 
      stop("Inf not allowed in rate.ha")
   ngroup <- length(rate.ha)

   #----------#
   # check L. #
   #----------#
   if (any(L) <= 0.0) 
      stop("L must be greater than 0")
   if (length(L) == 1) L <- rep(L,ngroup)
   if (length(L) != ngroup)
      stop("lengths of rate.ha and L must match")

   #-------------------#
   # check group.size. #
   #-------------------#
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(1,ngroup)
   else if (ngroups != lngrpsz)
      stop ("number of rows in rate.ha and length of group.size must match")

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   if (missing(const.constraint.group)) const.constraint.group <- -1
   else qall <- F
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   if (missing(equal.constraint.group)) equal.constraint.group <- -1
   else qall <- F
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                     nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size
  
   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   if (imethod == 1) {
      info.mat <- info.expsurv.kgp(rate.ha,L,group.size)
      noncent.obj <- lr.noncent(rate.ha,info.mat,constraint)
      if (icalc == 1)
         significance <- lr.sig(noncent.obj,sample.size,power)
      else if (icalc == 2)
         power <- lr.power(noncent.obj,sample.size,significance)
      else
         sample.size <- lr.n(noncent.obj,power,significance)
   } else {
      noncent.obj <- noncent.expsurv.kgp(rate.ha,L,constraint,group.size)
      if (icalc == 1)
         significance <- self.sig(noncent.obj,sample.size,power,smo.df)
      else if (icalc == 2)
         power <- self.power(noncent.obj,sample.size,significance,smo.df)
      else
         sample.size <- self.n(noncent.obj,power,significance,smo.df)
   }

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   methods <- c("LR","SMO")
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method=methods[imethod],model="Exponential Survival",
               design="Kgp",
               parameters=params,param.ha=matrix(rate.ha,ncol=1),L=L,
               ngroup=ngroup,group.size=group.size,constraint=constraint,
               calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   if (imethod == 2)
      ans$smo.df <- smo.df
   class(ans) <- "asypow"
   return(ans)
}
fix.constraints <- function(constraints,nparam) {
#-----------------------------------------------------------------------
# Name: fix.constraints
#
# Description:
#      Fixes the constraints, makes sure they are consistant.
# Stops with an error if constraint matrix is bad.
#
# Arguments:
# constraints -- Constraint matrix.
# nparam -- Number of parameters.
#
# Return Values:
# constraints -- Fixed constraint matrix.
#-----------------------------------------------------------------------

      if (is.vector(constraints)) {
           if (length(constraints) != 3)
                     stop("constraint vector must be of length 3")
           constraints <- t(as.matrix(constraints))
           s <- 1
      }
      else {
           dimc <- dim(constraints)
           if (dimc[2] != 3)
                     stop("constraint matrix must have 3 columns")
           s <- dimc[1]
      }

      if (any(constraints[,1] != 1 & constraints[,1] != 2))
                     stop("bad constraint matrix")

      for (i in 1:s) {
           if (constraints[i,1] == 2) {
                if (constraints[i,2] == constraints[i,3])
                          stop("bad constraint matrix")
                else if (constraints[i,3] < constraints[i,2])
                     constraints[i,] <- c(constraints[i,1],constraints[i,3],
                                                             constraints[i,2])
           }
      }

      if (any(duplicated(constraints[,2]))) stop("bad constraint matrix")

      ord <- order(constraints[,2])
      constraints[,1] <- constraints[ord,1]
      constraints[,2] <- constraints[ord,2]
      constraints[,3] <- constraints[ord,3]

      max.cons <- max(c(constraints[,2],constraints[constraints[,1]==2,3]))
      min.cons <- min(c(constraints[,2],constraints[constraints[,1]==2,3]))

      if (nparam < max.cons)
          stop("not enough parameters for the constraint matrix")

      if (min.cons < 1)
          stop("parameter index must be >= 1 in constraint matrix")

      return(constraints)

}
generic.model.lr <- function(theta.ha,
                             info.mat,
                             const.constraint.param,
                             const.constraint.value,
                             equal.constraint.param,
                             significance,power,sample.size)
#----------------------------------------------------------------------
# Name: generic.model.lr
#
# Description:
#      Calculates the estimated non-centraility parameter for 
# a generic problem using the likelihood ratio method. Uses the
# non-centrality parameter to calculate the significance, power or 
# sample size.
#
# Model Parameters:
# "theta1",...,"thetaN"
# 
# Arguments:
# theta.ha -- 
#      Array of parameter values under the alternative hypothesis.
#      This can be a column matrix or vector.
#
# info.mat --
#      The information matrix, the second derivate matrix of the
#      expected log likelihood under the alternative hypothesis.
#      The negative of the hessian matrix.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#----------------------------------------------------------------------
{
   #----------------#
   # define nparam. #
   #----------------#
   if (is.matrix(theta.ha)) theta.ha <- as.vector(t(theta.ha))
   nparam <- length(theta.ha)

   #-------------#
   # check info. #
   #-------------#
   if (length(info.mat)==1) info.mat <- matrix(info.mat,nrow=1,ncol=1)
   dimi <- dim(info.mat)
   if (dimi[1] != dimi[2]) stop("info.mat is not a square matrix")
   if (nparam != dimi[1])
        stop("length of theta.ha must match dimension of info.mat")

   #----------------#
   # set constants. #
   #----------------#
   imodel <- 8
   idesign <- 1
   ngroup <- 1
   params <- paste("theta",1:nparam,sep="")

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   const.constraint.group <- -1
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   equal.constraint.group <- -1
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                     nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size

   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   noncent.obj <- lr.noncent(theta.ha,info.mat,constraint)
   if (icalc == 1)
      significance <- lr.sig(noncent.obj,sample.size,power)
   else if (icalc == 2)
      power <- lr.power(noncent.obj,sample.size,significance)
   else
      sample.size <- lr.n(noncent.obj,power,significance)

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method="LR",model="Generic",
               parameters=params,param.ha=theta.ha,
               constraint=constraint,calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   class(ans) <- "asypow"
   return(ans)
}
generic.model.smo <- function(theta.ha,theta.lo,theta.hi,
                              expect.loglike,
                              const.constraint.param,
                              const.constraint.value,
                              equal.constraint.param,
                              significance,power,sample.size,
                              smo.df=T)
#----------------------------------------------------------------------
# Name: generic.model.smo
#
# Description:
#      Calculates the estimated non-centraility parameter for 
# a generic problem using the SMO method. Uses the non-centrality
# parameter to calculate the significance, power or sample size.
#
# Model Parameters:
# "theta1",...,"thetaN"
# 
# Arguments:
# theta.ha -- 
#      Array of parameter values under the alternative hypothesis.
#      This can be a column matrix or vector.
#
# theta.lo,theta.hi -- 
#      Array of lower and upper limits on the parameter values.
#
# expect.loglike -- function(theta.ha,theta.ho)
#      "expect.loglike" is a user supplied function which
#      calculates the expected value of the log-likelihood
#      function over theta.ha at the value theta.ho.
#      Expect.loglike should be a function of the two vectors,
#      theta.ha and theta.ho.
#
#      If density(theta,...) is a function which calculates
#      the density of the model at the parameter values theta,
#      and loglike(theta,...) is a function which calculates
#      the log-likelihood of the model at the parameter values
#      theta, then the expected log-likehood at theta.ho over
#      theta.ha is density(theta.ha)*loglike(theta.ho) integrated
#      over the appropriate space.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#
# smo.df --
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n.
#----------------------------------------------------------------------
{
   #----------------#
   # define nparam. #
   #----------------#
   if (is.matrix(theta.ha)) theta.ha <- as.vector(t(theta.ha))
   nparam <- length(theta.ha)

   #------------------------------------------------------#
   # check to see that theta.lo and theta.hi are the same #
   # length as theta.ha and that theta.hi >= theta.lo.    #
   #------------------------------------------------------#
   if (is.matrix(theta.lo)) theta.lo <- as.vector(t(theta.lo))
   if (length(theta.lo) != nparam) 
      stop("length of theta.lo must match length of theta.ha")
   if (is.matrix(theta.hi)) theta.hi <- as.vector(t(theta.hi))
   if (length(theta.hi) != nparam)
      stop("length of theta.hi must match length of theta.ha")
   if (any(theta.lo > theta.hi)) 
      stop("all value in theta.hi must be >= theta.lo")

   #----------------#
   # set constants. #
   #----------------#
   imodel <- 8
   idesign <- 1
   ngroup <- 1
   params <- paste("theta",1:nparam,sep="")

   #-----------------#
   # check theta.ha. #
   #-----------------#
   if (any(theta.ha <= theta.lo) | any(theta.ha >= theta.hi))
      stop("theta.ha not in (theta.lo,theta.hi)")

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   const.constraint.group <- -1
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   equal.constraint.group <- -1
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                     nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size

   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   noncent.obj <- noncent.generic(theta.ha,theta.lo,theta.hi,constraint,
                  expect.loglike)
   if (icalc == 1)
      significance <- self.sig(noncent.obj,sample.size,power,smo.df)
   else if (icalc == 2)
      power <- self.power(noncent.obj,sample.size,significance,smo.df)
   else
      sample.size <- self.n(noncent.obj,power,significance,smo.df)

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method="SMO",model="Generic",
               parameters=params,param.ha=theta.ha,
               constraint=constraint,calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   ans$smo.df <- smo.df
   class(ans) <- "asypow"
   return(ans)
}
get.constant.constraint <- function(imodel,idesign,nparam,param,
                                    ngroup,constraint) {
#----------------------------------------------------------------------
# Name: get.constant.constraint
#
# Description:
#      Adds constant constraints to a constraint matrix by querying 
# the user. Called by enter.constraints.
#
# Arguments:
# imodel --
#      Integer indicator for model selected. Models 1 to 8 are
#      "Binomial","Poisson","Multinomial","Ordinal",
#      "Exponential Survival","Multivariate Logistic",
#      "Multivariate Log-Linear" and "Generic" respectively.
#
# idesign --
#      Integer indicator for the design selected. Designs 1, 2
#      and 3 are "Kgp", "Linear" and "Quadratic" respectively.
#
# nparam --
#      Number of parameters in the model.
#
# param --
#      Vector of characters descriptions of the parameters in
#      the model.
#
# ngroup --
#      Number of groups in the design.
#
# constraint --
#      Current constraint matrix.
#
# Return Value:
# An updated valid constraint matrix for use with lr.noncent or
# noncent.*.
#----------------------------------------------------------------------

   cat("\nEntering a constant constraint:\n\n")

   # Query user for parameter value with 1 parameter and 1 group.
   if ((nparam == 1) & (ngroup == 1)) {
      iparam <- 1
      igroup <- 1
      cat(paste("Enter the value for parameter ",param[1],".\n",sep=""))
      value <- readline()
      value <- as.numeric(value)
      if (is.na(value)) {
         cat("Bad parameter value.\n")
         return(constraint)
      }

   # Query user for group number and parameter value with 1
   # parameter and multiple groups.
   } else if (nparam == 1) {
      iparam <- 1
      cat(paste("There are ",ngroup," groups.\n",sep=""))
      cat(paste("Enter the group number and value for parameter ",
                param[1],".\n",sep=""))
      string <- readline()
      ans <- parse.string(string)
      if (length(ans) != 2) {
         cat("Bad entry.\n")
         return(constraint)
      }
      igroup <- as.integer(ans[1])
      if (is.na(igroup) | (!any(igroup == 1:ngroup))) {
         cat("Bad group value.\n")
         return(constraint)
      }
      value <- as.numeric(ans[2])
      if (is.na(value)) {
         cat("Bad parameter value.\n")
         return(constraint)
      }

   # Query user for parameter and value with multiple parameters 
   # and 1 group.
   } else if (ngroup == 1) {
      igroup <- 1
      cat(paste(c("Available parameters are:",param)),"\n")
      cat("Enter the parameter and value.\n")
      string <- readline()
      ans <- parse.string(string)
      if (length(ans) != 2) {
          cat("Bad entry.\n")
          return(constraint)
      }
      iparam <- pmatch(ans[1],param)
      if (is.na(iparam)) {
         cat("Bad parameter entry.\n")
         return(constraint)
      }
      value <-  as.numeric(ans[2])
      if (is.na(value)) {
         cat("Bad parameter value.\n")
         return(constraint)
      }

   # Query the user for group number, parameter and value
   # with multiple parameters and multiple groups.
   } else {
      cat(paste(c("Available parameters are:",param)),"\n")
      cat(paste("There are ",ngroup," groups.\n",sep=""))
      cat("Enter the group number, parameter and value.\n")
      string <- readline()
      ans <- parse.string(string)
      if (length(ans) != 3) {
          cat("Bad entry.\n")
          return(constraint)
      }
      igroup <- as.integer(ans[1])
      if (is.na(igroup) | (!any(igroup == 1:ngroup))) {
         cat("Bad group value.\n")
         return(constraint)
      }
      iparam <- pmatch(ans[2],param)
      if (is.na(iparam)) {
         cat("Bad parameter entry.\n")
         return(constraint)
      }
      value <-  as.numeric(ans[3])
      if (is.na(value)) {
         cat("Bad parameter value.\n")
         return(constraint)
      }
   }

   # Check to see that the constraint is unique and OK according
   # to the model.
   if (idesign == 1) {
      if ((imodel == 1) | (imodel == 3) | (imodel == 4)) {
         if ((value <= 0.0) | (value >= 1.0)) {
            cat(paste("Parameter",param[iparam],"not in range (0,1).\n"))
            return(constraint)
          }
      }
      if ((imodel == 2) | (imodel == 5) | (imodel == 7)) {
         if (value <= 0.0) {
            cat(paste("Parameter",param[iparam],"not in range (0,Inf].\n"))
            return(constraint)
          }
      }
   }
   iloc <- (igroup-1)*nparam+iparam
   if (length(constraint) > 0) {
      ind <- ((constraint[,1] == 2) & 
              ((constraint[,2] == iloc) | (constraint[,3] == iloc)))
      if (any(ind)) {
         mssg <- paste("Parameter ",param[iparam],sep="")
         if (ngroup > 1) 
            mssg <- paste(mssg," in group ",igroup,sep="")
         mssg <- paste(mssg,"already included in an equality constraint.")
         cat(mssg,"\n")
         cat("Try deleting the old constraint before entering a new one.\n")
         return(constraint)
      }
      ind <- ((constraint[,1] == 1) & (constraint[,2] == iloc))
      if (any(ind)) {
         mssg <- paste("Parameter ",param[iparam],sep="")
         if (ngroup > 1) 
            mssg <- paste(mssg," in group ",igroup,sep="")
         mssg <- paste(mssg," already set to ",constraint[ind,3],".",sep="")
         cat(mssg,"\n")
         cat(paste("Change the value to ",value,"? (y/n)\n",sep=""))
         cont <- readline()
         char <- substring(cont,1,1)
         if ((char == "y") | (char == "Y")) {
            constraint[ind,] <- c(1,iloc,value)
         } else {
            if ((char != "n") & (char != "N"))
               cat("Bad input.\n")
         }
         return(constraint)
      }
   }
   constraint <- rbind(constraint,c(1,iloc,value))
   return(constraint)
}
get.equal.constraint <- function(imodel,idesign,nparam,param,
                                 ngroup,constraint) {
#----------------------------------------------------------------------
# Name: get.equal.constraint
#
# Description:
#      Adds equality constraints to a constraint matrix by querying 
# the user. Called by enter.constraints.
#
# Arguments:
# imodel --
#      Integer indicator for model selected. Models 1 to 8 are
#      "Binomial","Poisson","Multinomial","Ordinal",
#      "Exponential Survival","Multivariate Logistic",
#      "Multivariate Log-Linear" and "Generic" respectively.
#
# idesign --
#      Integer indicator for the design selected. Designs 1, 2
#      and 3 are "Kgp", "Linear" and "Quadratic" respectively.
#
# nparam --
#      Number of parameters in the model.
#
# param --
#      Vector of characters descriptions of the parameters in
#      the model.
#
# ngroup --
#      Number of groups in the design.
#
# constraint --
#      Current constraint matrix.
#
# Return Value:
# An updated valid constraint matrix for use with lr.noncent or
# noncent.*.
#----------------------------------------------------------------------

   cat("\nEntering an equality constraint:\n\n")

   # 1 parameter; multiple groups:
   # Query user for a list of group numbers.
   if (nparam == 1) {
      cat(paste("There are ",ngroup," groups.\n",sep=""))
      cat(paste("Enter a list of groups for which the parameter ",
                param[1]," will be set equal.\n",sep=""))
      string <- readline()
      ans <- parse.string(string)
      nequal <- length(ans)
      if (nequal < 2) {
         cat("Must be at least 2 groups.\n")
         return(constraint)
      }
      if (any(duplicated(ans))) {
         cat("Groups must be unique.\n")
         return(constraint)
      }
      igroup.list <- rep(NA,nequal)
      iparam.list <- rep(1,nequal)
      equal.list <- rep(NA,nequal)
      for (i in 1:nequal) {
         igroup <- as.integer(ans[i])
         if (is.na(igroup) | (!any(igroup == 1:ngroup))) {
            cat("Bad group value.\n")
            return(constraint)
         }
         igroup.list[i] <- igroup
         equal.list[i] <- igroup
      }

   # Multiple parameters; 1 group:
   # Query user for a list of parameters
   } else if (ngroup == 1) {
      cat(paste(c("Available parameters are:",param)),"\n")
      cat("Enter a list of prameters which will be set equal.\n")
      string <- readline()
      ans <- parse.string(string)
      nequal <- length(ans)
      if (nequal < 2) {
         cat("Must be at least 2 parameters.\n")
         return(constraint)
      }
      if (any(duplicated(ans))) {
         cat("Parameters must be unique.\n")
         return(constraint)
      }
      igroup.list <- rep(1,nequal)
      iparam.list <- rep(NA,nequal)
      equal.list <- rep(NA,nequal)
      for (i in 1:nequal) {
         iparam <- pmatch(ans[i],param)
         if (is.na(iparam)) {
            cat("Bad parameter entry.\n")
            return(constraint)
         }
         iparam.list[i] <- iparam
         equal.list[i] <- iparam
      }

   # Multiple parameters; multiple groups:
   # Query user for a list of group numbers and parameters.
   # Enter one group number/parameter value per line.
   } else {
      cat(paste(c("Available parameters are:",param)),"\n")
      cat(paste("There are ",ngroup," groups.\n",sep=""))
      cat("Enter the group number and parameters to be set equal.\n")
      cat("Enter 1 group number and parameter per line.\n")
      cat("Enter a blank line when you are done.\n")
      nequal <- 0
      equal.list <- NA
      iparam.list <- NA
      igroup.list <- NA
      while(1) {
         string <- readline()
         if (string == "") break
         ans <- parse.string(string)
         if (length(ans) != 2) {
             cat("Bad entry.\n")
             return(constraint)
         }
         igroup <- as.integer(ans[1])
         if (is.na(igroup) | (!any(igroup == 1:ngroup))) {
            cat("Bad group value.\n")
            return(constraint)
         }
         iparam <- pmatch(ans[2],param)
         if (is.na(iparam)) {
            cat("Bad parameter entry.\n")
            return(constraint)
         }
         nequal <- nequal + 1
         iparam.list[nequal] <- iparam
         igroup.list[nequal] <- igroup
         equal.list[nequal] <- (igroup-1)*nparam+iparam
         if (any(duplicated(equal.list))) {
            cat("Parameters must be unique.\n")
            return(constraint)
         }
      }
   }

   # Check to see that the equality constraints are unique
   # and update the constraint matrix.
   if (imodel == 4) {
      if (idesign == 1) {
         if (any(duplicated(igroup.list))) {
            cat("Category probabilities in the same group can not be\n")
            cat("set equal in the ordinal model\n")
            return(constraint)
         }
      } else {
         group.dup <- duplicated(igroup.list)
         if (any(group.dup)) {
            for (i in igroup.list[group.dup]) {
               param.dup <- iparam.list[(igroup.list == i)]
               if (sum(param.dup < (nparam-idesign)) > 1) {
                  cat("Intercept terms in the same group can not be\n")
                  cat("set equal in the ordinal model\n")
                  return(constraint)
               }
            }
         }
      }
   }
   if (length(constraint) > 0) {
      constants <- constraint[(constraint[,1] == 1),2]
      if (length(constants) > 0) {
         for (i in 1:nequal) {
            if (any(equal.list[i] == constants)) {
               mssg <- paste("Parameter ",param[iparam.list[i]],sep="")
               if (ngroup > 1) 
                  mssg <- paste(mssg," in group ",igroup.list[i],sep="")
               mssg <- paste(mssg,"already set to a constant value.")
               cat(mssg,"\n")
               cat("Try deleting the old constraint before entering a new one.\n")
               return(constraint)
            }
          }
      }
      ind <- rep(T,nrow(constraint))
      for (i in 1:nrow(constraint)) {
         if (constraint[i,1] == 2) {
            if ((any(equal.list == constraint[i,2])) | 
                (any(equal.list == constraint[i,3]))) {
               equal.list <- unique(c(equal.list,constraint[i,2:3]))
               ind[i] <- F
            }
         }
      }
      constraint <- constraint[ind,]
      if (is.vector(constraint)) constraint <- matrix(constraint,nrow=1)
   }
   equal.list <- sort(equal.list)
   nequal <- length(equal.list)
   for (i in 2:nequal)
      constraint <- rbind(constraint,c(2,equal.list[i-1],equal.list[i]))
   return(constraint)
}
info.binomial.design <- function(model="linear", link="logistic", theta,
                             xpoints, natx=1, group.size=1) {
#-----------------------------------------------------------------------
# Name: info.binomial.design
#
# Description:
#      Returns the information matrix for a binomial design.
#
# Arguments:
# model --
#      One of {"linear", "quadratic"} Only enough to ensure a unique
#      match need be supplied.
#
# link --
#      One of {"logistic", "complementary log"} Only enough to ensure
#      a unique match need be supplied.
#
# theta --
#      Matrix of parameters of the linear part of the model.
#      Each row represents a group.
#
# xpoints --
#      Matrix of covariate values for each group.
#      Each row represents a group.
#
# natx --
#      Matrix of number of observations at xpoints for each group.
#      Each row represents a group.
#      At covariate value xpoint[i,j] there are natx[i,j] observations.
#
# group.size --
#      The relative number of observations in each group.
#
# Return Value:
#      The the information matrix for one observation for this
#      design. The observation is assumed to be spread over xpoints
#      in proportion to natx.
#-----------------------------------------------------------------------

      if (is.vector(theta)) theta <- t(as.matrix(theta))
      dimt <- dim(theta)
      ngroups <- dimt[1]

      if (is.vector(xpoints)) {
           xpoints <- matrix(xpoints,ngroups,length(xpoints),byrow=T)
           dimp <- dim(xpoints)
      }
      else {
           dimp <- dim(xpoints)
           if (dimp[1] != ngroups)
                stop("Number of rows of xpoints and theta must match")
      }
      if (is.vector(natx)) {
           if (length(natx) == 1)
                natx <- matrix(natx,ngroups,dimp[2],byrow=T)
           else {
                if (length(natx) != dimp[2] )
                     stop ("length of natx must match number of xpoints")
                natx <- matrix(natx,ngroups,dimp[2],byrow=T)
           }
           dimn <- dim(natx)
      }
      else {
           dimn <- dim(natx)
           if (dimn[1] != dimp[1] || dimn[2] != dimp[2])
                stop("xpoints and natx must have the same dimensions")
      }

      lngrpsz <- length(group.size)
      if (lngrpsz == 1) group.size <- rep(group.size,ngroups)
      else if (ngroups != lngrpsz)
       stop("\nNumber of rows of theta and length of group.size must match")

      info <- vector("list",dimp[1])

      for (j in 1:ngroups) {
           info[[j]] <- 0
           for (i in 1:length(xpoints[j,]))
                if(natx[j, i] != 0) info[[j]] <- info[[j]] + natx[j,i] *
                     info.binomial.one(model,link,theta[j,],xpoints[j,i])
           info[[j]] <- info[[j]] * group.size[j]
      }

      info <- k.blocks.info(info)

      return(info/sum(group.size * natx))
}
info.binomial.kgp <- function(p, group.size=1) {
#-----------------------------------------------------------------------
# Name: info.binomial.kgp
#
# Description:
#      Returns the fisher information for the kgp binomial model.
#
# Arguments:
# p --
#      For l groups, a vector of length l. p[i] is the probability of 
#      an event for a single trial in group i.
#
# group.size --
#      The relative number of observations in each group.
#
# Return Value:
#      The information from a single trial which is spread over
#      the groups.
#-----------------------------------------------------------------------

  if (any(p <= 0.0 | p >= 1.0)) stop ("p must between 0 and 1")
  ngroups <- length(p)

  lngrpsz <- length(group.size)
  if (lngrpsz == 1) group.size <- rep(1,ngroups)
    else if (ngroups != lngrpsz)
      stop ("lengths of p and group.size must match")

  hess <- -1/(p*(1-p))

  info <- (group.size * -hess) / sum(group.size)
  if (ngroups > 1) info <- diag(info)

  return(info)
}
info.binomial.one <- function(model="linear", link="logistic",
                              theta, covariate) {
#-----------------------------------------------------------------------
# Name: info.binomial.one
#
# Description:
#      Returns the information matrix for the binomial design with a
#      single covariate value.
#
# Arguments:
# model --
#      One of {"linear", "quadratic"} Only enough to ensure a unique
#      match need be supplied.
#
# link --
#      One of {"logistic", "complementary log"} Only enough to ensure
#      a unique match need be supplied.
#
# theta --
#      Vector of parameters of the linear part of the model.
#
# covariate --
#      Scalar value of the covariate.
#
# Return Value:
#      The contribution to the information matrix of a single
#      observation at value covariate.
#-----------------------------------------------------------------------

      model <- pmatch(model,c("linear","quadratic"))
      if (is.na(model)) stop("model must be one of {'linear','quadratic'}")
      if (model == 1) u <- theta[1] + theta[2]*covariate
      else u <- theta[1] + theta[2]*covariate + theta[3]*covariate^2

      if(model != (length(theta)-1))
                stop("theta inconsistant with model")

      link <- pmatch(link,c("logistic","complementary log"))
      if (is.na(link))
                stop("link must be one of {'logistic','complementary log'}")
      if (link == 1) p <- exp(u) / (1 + exp(u))
      else p <- 1 - exp(-exp(u))

      d2lldp2 <- -1 / (p *(1-p))

      if (link == 1) dpdu <- p * (1-p)
      else dpdu <- exp(u) * (1-p)

      dpda <- dpdu
      dpdb <- dpdu * covariate
      if (model == 2) dpdc <- dpdu * covariate^2

      if (model == 1) hess <- matrix(c(dpda^2,rep(dpda*dpdb,2),dpdb^2),2,2)
      else hess <- matrix(c(dpda^2,dpda*dpdb,dpda*dpdc,
                     dpdb*dpda,dpdb^2,dpdb*dpdc,
                     dpdc*dpda,dpdc*dpdb,dpdc^2),3,3)

      return(- d2lldp2 * hess)
}
info.expsurv.design <- function(model="linear", theta, L, xpoints,
                             natx=1, group.size=1) {
#-----------------------------------------------------------------------
# Name: info.expsurv.design
#
# Description:
#      Returns the information matrix for an exponential survival
# design.
#
# Arguments:
# model --
#      One of {"linear", "quadratic"} Only enough to ensure a unique
#      match need be supplied.
#
# theta --
#      Matrix of parameters of the linear part of the model.
#      Each row represents a group.
#
# L --
#      The length of the study. If L is length 1 each group has
#      a study of length L. If L is the same as length as the
#      number of groups, each group has a different length.
#
# xpoints --
#      Matrix of covariate values for each group.
#      Each row represents a group.
#
# natx --
#      Matrix of number of observations at xpoints for each group.
#      Each row represents a group.
#      At covariate value xpoint[i,j] there are natx[i,j] observations.
#
# group.size --
#      The relative number of observations in each group.
#
# Return value: 
#     The the information matrix for one observation for this design.
#     The observation is assumed to be spread over xpoints in proportion
#     to natx.
#-----------------------------------------------------------------------

      if (is.vector(theta)) theta <- t(as.matrix(theta))
      dimt <- dim(theta)
      ngroups <- dimt[1]

      if (length(L) == 1) L <- rep(L,ngroups)
      else {
         if (length(L) != ngroups)
            stop("Length of L and number of rows of theta must match")
      }

      if (is.vector(xpoints)) {
           xpoints <- matrix(xpoints,ngroups,length(xpoints),byrow=T)
           dimp <- dim(xpoints)
      }
      else {
           dimp <- dim(xpoints)
           if (dimp[1] != ngroups)
                stop("Number of rows of xpoints and theta must match")
      }
      if (is.vector(natx)) {
           if (length(natx) == 1)
                natx <- matrix(natx,ngroups,dimp[2],byrow=T)
           else {
                if (length(natx) != dimp[2] )
                     stop ("length of natx must match number of xpoints")
                natx <- matrix(natx,ngroups,dimp[2],byrow=T)
           }
           dimn <- dim(natx)
      }
      else {
           dimn <- dim(natx)
           if (dimn[1] != dimp[1] || dimn[2] != dimp[2])
                stop("xpoints and natx must have the same dimensions")
      }

      lngrpsz <- length(group.size)
      if (lngrpsz == 1) group.size <- rep(group.size,ngroups)
      else if (ngroups != lngrpsz)
       stop("\nNumber of rows of theta and length of group.size must match")

      info <- vector("list",dimp[1])

      for (j in 1:dimp[1]) {
           info[[j]] <- 0
           for (i in 1:length(xpoints[j,]))
                if(natx[j, i] != 0) info[[j]] <- info[[j]] + natx[j,i] *
                      info.expsurv.one(model,L[j],theta[j,],xpoints[j,i])
           info[[j]] <- info[[j]] * group.size[j]
      }

      info <- k.blocks.info(info)

      return(info/sum(group.size * natx))
}
info.expsurv.kgp <- function(w, L, group.size=1) {
#-----------------------------------------------------------------------
# Name: info.expsurv.kgp
#
# Description:
#      Returns the fisher information for the kgp exponential
#      survival model.
# 
# Arguments:
# w --
#      For l groups a vector of length l. w[i] is the rate, or
#      inverse of the mean of the exponential distribution.
#
# L --
#      The length of the study. If L is length 1 each group has
#      a study of length L. If L is the same as length as the
#      number of groups, each group has a different length.
# group.size --
#      The relative number of observations in each group.
#
# Return Value:
#      The information from a single trial which is spread over
#      the several groups.
#-----------------------------------------------------------------------
  ngroups <- length(w)

  if (length(L) == 1) L <- rep(L,ngroups)
  if (length(L) != ngroups)
     stop("lengths of w and L must match")

  lngrpsz <- length(group.size)
  if (lngrpsz == 1) group.size <- rep(1,ngroups)
    else if (ngroups != lngrpsz)
      stop ("lengths of w and group.size must match")

  nhess <- (exp(-w*L) - 1)/(L*w^3) + 1/(w^2)
  info <- (group.size * nhess) / sum(group.size)
  if (ngroups > 1) info <- diag(info)

  return(info)
}
info.expsurv.one <- function(model="linear", L, theta, covariate) {
#-----------------------------------------------------------------------
# Name: info.expsurv.one
#
# Description:
#      Returns the information matrix for the exponential survival design
#      with a single covariate value.
#
# Arguments:
# model --
#      One of {"linear", "quadratic"} Only enough to ensure a unique
#      match need be supplied.
#
# L --
#      The length of the study. If L is length 1 each group has
#      a study of length L. If L is the same as length as the
#      number of groups, each group has a different length.
#
# theta --
#      Vector of parameters of the linear part of the model.
#
# covariate --
#      Scalar value of the covariate.
#
# Return Value:
#      The contribution to the information matrix of a single
#      observation at value covariate.
#-----------------------------------------------------------------------

      model <- pmatch(model,c("linear","quadratic"))
      if (is.na(model)) stop("model must be one of {'linear','quadratic'}")

      if(model != (length(theta)-1))
                stop("theta inconsistant with model")

      x <- covariate
      x2 <- x*x
      x3 <- x2*x
      x4 <- x3*x

      if (model == 1) u <- theta[1] + theta[2]*x
      else u <- theta[1] + theta[2]*x + theta[3]*x2

      w <- exp(u)
      wL <- w*L
      enwL <- exp(-wL)
      const <- ((enwL*(wL+2) + w*L - 2) - (enwL*(wL+1) - 1))/wL
      if (model == 1) 
         info <- const*matrix(c(1,x,x,x2),nrow=2,ncol=2)

      else
         info <- const*matrix(c(1,x,x2,x,x2,x3,x2,x3,x4),nrow=3,ncol=3)

      return(info)

}
info.multinomial.kgp <- function(p,group.size=1)
#----------------------------------------------------------------------
# Name: info.multinomial.kgp
#
# Description:
#      Returns the information matrix for the kgp multinomial
# model.
#
# Arguments:
# p --
#      For a single group with n categories p is a vector
#      where p[i] is the probability an event occured in 
#      category i. The dimension of p in this case is (n-1)
#      since p[n] would automatically be the sum of p[i]
#      for i=1,...,n-1. For k groups p is a [k x (n-1)] 
#      matrix with each row containing the category 
#      probabilities for a group.
#  
# group.size --
#      The relative number of observations in each group.
#
# Return Values:
# info -- 
#      The information matrix from a single trial spread over
#      the groups.
#----------------------------------------------------------------------
{
   # Fix p to be a matrix.
   if (is.vector(p)) p <- t(as.matrix(p))
   ngroups <- dim(p)[1]

   # Check to see that all p are in the range (0,1)
   if (any(p <= 0.0 | p >= 1.0)) 
      stop("all p must be in range (0,1)")

   # Define ncat, the number of categories
   ncatm1 <- ncol(p)
   ncat <- ncatm1 + 1

   # Check to see that the sum of p is less than 1
   if (ngroups == 1) 
      p.full <- cbind(p,1.0-sum(p[,1:ncatm1]))
   else
      p.full <- cbind(p,(rep(1,ngroups)-apply(p[,1:ncatm1],1,sum)))
   if (any(p.full[,ncat] <= 0))
      stop("each row of p must sum to less than 1.0")

   # check group.size
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(1,ngroups)
   else if (ngroups != lngrpsz)
      stop ("number of rows in p and group.size must match")

   # Calculate the hessian.
   hess <- vector("list",ngroups)
   for(j in 1:ngroups) {
      pj <- p[j,]
      if (ncatm1 == 0) next
      if (ncatm1 == 1) hess[[j]] <- -1/(pj*(1-pj))
      else {
         hess[[j]] <- matrix(0,ncatm1,ncatm1)
         diag(hess[[j]]) <- -1/pj
      }
      hess[[j]] <- group.size[j] * hess[[j]]
   }

   info <- - k.blocks.info(hess)

   # Return the information matrix.
   return(info/sum(group.size))
}

info.mvlogistic <- function( coef, design, rss=1 ){
#-----------------------------------------------------------------------
# Name: info.mvlogistic
#
# Description:
#      Information Matrix for a Multivariate Logistic.
#
# MODEL IS:
#        Prob event(u) = exp(u) / ( 1 + exp(u) )
# where u = Sum( coef[i]*x[i] )
# and coef is the argument so named.  The x are rows of the 
# design matrix.
#
# Arguments:
# coef --
#      Vector of length p (number of covariates) giving coefficients
#      of variables.
#
# design -- 
#      Matrix of length n X p each row of which gives values of
#      covariates at one of the n design points.
#      Note: Most models will include a constant term and the column of
#      design corresponding to this term will be identically 1.
#
# rss -- 
#      The relative sample size at each design point.  If changed
#      from its default value should be a vector of length n.
#      Note:  The information matrix is calculated for one observation
#      spread over the n design points in proportions determined
#      by rss.
#
# Return Value:
#      Information matrix for multivariate logistic.
#
# Note:
#      The primary use of this routine will be for tables analysed
#      using anova techniques with a logistic model.
#----------------------------------------------------------------------

p <- length( coef )

if (is.vector(design)) {
   design <- matrix(design,nrow=1)
}

tmp <- dim( design )

if ( tmp[2] != p ) stop('Number of variables in coef and design
differ')

n <- tmp[1]

lrss <- length(rss)
if ( lrss == 1 ) {
   wt <- rep(1,n)
   tot <- n }
else if ( lrss == n ) {
   wt <- rss
   tot <- sum(rss) }
else stop('Length of rss does not match number of design points.')

info <- matrix( 0, ncol=p, nrow=p )

for (i in 1:n) {
  
  row <- design[i,]

  u <- crossprod( row, coef )
  dim(u) <- NULL

  p <- invlogit( u )

  mat <- outer( row, row )

  info <- info + wt[i] * p * (1-p) * mat     }

return( info/tot )     }
info.mvloglin <- function( coef, design, rss=1 ){
#-----------------------------------------------------------------------
# Name: info.mvlogistic
#
# Description:
#      Information Matrix for a Log-Linear Model.
#
# MODEL IS:
#        Prob event(u) = exp(u)
# where u = Sum(log( coef[i] )*x[i] )
#
# Arguments:
# coef --
#      Vector of length p (number of covariates) giving coefficients
#      of variables.
#
# design -- 
#      Matrix of length n X p each row of which gives values of
#      covariates at one of the n design points.
#      Note: Most models will include a constant term and the column of
#      design corresponding to this term will be identically 1.
#
# rss -- 
#      The relative sample size at each design point.  If changed
#      from its default value should be a vector of length n.
#      Note:  The information matrix is calculated for one observation
#      spread over the n design points in proportions determined
#      by rss.
#
# Return Value:
#      Information matrix for log-linear model.
#
# Note:
#      The primary use of this routine will be for tables analysed
#      using anova techniques with a log-linear model.
#----------------------------------------------------------------------

p <- length( coef )

if (is.vector(design)) {
   design <- matrix(design,nrow=1)
}

tmp <- dim( design )

if ( tmp[2] != p ) stop('Number of variables in coef and design
differ')

n <- tmp[1]

lrss <- length(rss)
if ( lrss == 1 ) {
   wt <- rep(1,n)
   tot <- n }
else if ( lrss == n ) {
   wt <- rss
   tot <- sum(rss) }
else stop('Length of rss does not match number of design points.')

model.info <- matrix( 0, ncol=p, nrow=p )

lcoef <- log(coef)

for (i in 1:n) {
  
  row <- design[i,]

  u <- crossprod( row, lcoef )
  dim(u) <- NULL
  p <- exp( u )
  if (is.na(p) | is.inf(p))
     stop(paste("probability p generated with from design point",i,
                "is not an element of (0,1)"))
  if (p >= 1) 
     stop(paste("probability p generated with from design point",i,
                "is not an element of (0,1)"))

  mat <- outer( row/coef, row/coef )

  mult <- (wt[i] * (p / (1-p)))

  model.info <- model.info + mult * mat     }

return( model.info/tot )     }
info.ordinal.cat <- function( model, link, theta, x, icat ){
#-----------------------------------------------------------------------
# Name: info.ordinal.one
#
# Description:
#      Returns the information matrix for the ordinal model with 
# a single covariate.
#
# Arguments:
# model --
#      1 for linear; 2 for quadratic.
#
# link --
#      1 for logistic; 2 for complementary log.
#
# theta --
#      Vector of parameters of the linear part of the model.
#      If there are K categories then
#         model = "linear" :
#            U[i] = THETA[i] + THETA[k]*covariate    i = 1,(k-1)
#         model = "quadratic" :
#            U[i] = THETA[i] + THETA[k]*covariate + THETA[k+1]*covariate^2
#                                                              i = 1,(k-1)
#
# x --
#      Scalar value of covariate.
#
# icat --
#      Outcome value for which contribution to into evaluated.
#
# Returns:
# The contribution to the information matrix from an observation of 
# icat.
#-----------------------------------------------------------------------
  ntheta <- length(theta)

  if ( model == 1 ) ncat <- ntheta
    else ncat <- ntheta - 1

  Du.i <- Du.im1 <- rep(0,ntheta)
  Dg.i <- Dg.im1 <- rep(0,3)

  not.first <- icat > 1
  not.last <- icat < ncat
  if (ncat == 1) not.last <- 1

### Set up value, first and second derivative of link with respect to u
### for u_i and u_im1

  if (not.last) {
    u.i <- theta[icat] + theta[ncat]*x
    if (model == 2) u.i <- u.i + theta[ncat+1]*x^2 
    Dg.i <- derivs.link( u.i, link )  
    Du.i[icat] <- 1
    Du.i[ncat] <- x
    if (model ==2) Du.i[ntheta] <- x^2  }

  if (not.first) {
    u.im1 <- theta[icat-1] + theta[ncat]*x
    if (model == 2) u.im1 <- u.im1 + theta[ncat+1]*x^2 
    Dg.im1 <- derivs.link( u.im1, link )  
    Du.im1[icat-1] <- 1
    Du.im1[ncat] <- x
    if (model ==2) Du.im1[ntheta] <- x^2  }

### Compute p.i, probability of landing in icat

  if (ncat == 1 || icat == 1) p.i <- Dg.i[1]
    else {
      if (icat < ncat) p.i <- Dg.i[1] - Dg.im1[1]
        else p.i <- 1 - Dg.im1[1]   }

### Compute second derivatives multiplied by p.i

  ans <- outer(Du.i,Du.i) * ( Dg.i[3] - Dg.i[2]^2 / p.i ) -
    outer(Du.im1,Du.im1) * ( Dg.im1[3] + Dg.im1[2]^2 / p.i ) + 
      ( outer(Du.i,Du.im1) + outer(Du.im1,Du.i) ) * 
      ( Dg.i[2] * Dg.im1[2] / p.i )

### Return negative of second derivatives multiplied by p.i

  return( -ans )    }
info.ordinal.design <- function(model="linear", link="logistic", theta,
                             xpoints, natx=1, group.size=1) {
#-----------------------------------------------------------------------
#        Returns the information matrix for a ordinal design
#
# model: One of {"linear", "quadratic"} Only enough to ensure a unique
#           match need be supplied.
#
# link: One of {"logistic", "complementary log"} Only enough to ensure
#           a unique match need be supplied.
#
# theta: Matrix of parameters of the linear part of the model.
#          Each row represents a group.
#
# xpoints: Matrix of covariate values for each group.
#             Each row represents a group.
#
# natx: Matrix of number of observations at xpoints for each group.
#             Each row represents a group.
#           At covariate value xpoint[i,j] there are natx[i,j] observations.
#
# group.size: The relative number of observations in each group
#
#
# Returns: The the information matrix for one observation for this design.
#     The observation is assumed to be spread over xpoints in proportion
#     to natx.
#
#-----------------------------------------------------------------------

      if (is.vector(theta)) theta <- t(as.matrix(theta))
      dimt <- dim(theta)
      ngroups <- dimt[1]

      if (is.vector(xpoints)) {
           xpoints <- matrix(xpoints,ngroups,length(xpoints),byrow=T)
           dimp <- dim(xpoints)
      }
      else {
           dimp <- dim(xpoints)
           if (dimp[1] != ngroups)
                stop("Number of rows of xpoints and theta must match")
      }
      if (is.vector(natx)) {
           if (length(natx) == 1)
                natx <- matrix(natx,ngroups,dimp[2],byrow=T)
           else {
                if (length(natx) != dimp[2] )
                     stop ("length of natx must match number of xpoints")
                natx <- matrix(natx,ngroups,dimp[2],byrow=T)
           }
           dimn <- dim(natx)
      }
      else {
           dimn <- dim(natx)
           if (dimn[1] != dimp[1] || dimn[2] != dimp[2])
               stop("xpoints and natx must have the same dimensions")
      }

      lngrpsz <- length(group.size)
      if (lngrpsz == 1) group.size <- rep(group.size,ngroups)
      else if (ngroups != lngrpsz)
       stop("\nNumber of rows of theta and length of group.size must match")

      info <- vector("list",dimp[1])

      for (j in 1:dimp[1]) {
           info[[j]] <- 0
           for (i in 1:length(xpoints[j,]))
                if (natx[j,i] != 0) info[[j]] <- info[[j]] + natx[j,i] *
                      info.ordinal.one(model,link,theta[j,],xpoints[j,i])
           info[[j]] <- info[[j]] * group.size[j]
      }

      info <- k.blocks.info(info)

      return(info/sum(group.size * natx))
}
info.ordinal.kgp <- function(p, group.size=1) {
#----------------------------------------------------------------------
# Name: info.ordinal.kgp
#
# Description:
#       Returns the information matrix for the kgp ordinal model.
#
# Arguments:
# p --
#      For a single group with n categories p.ha is a vector
#      where p[i] is the probability an event occured in 
#      category i or less. The dimension of p in this case is (n-1)
#      since p[n] would automatically be 1. For k groups p is 
#      a [k x (n-1)] matrix with each row containing the category
#      probabilities for a group.
#
# group.size --
#      The relative number of observations in each group.
#
# Return Value:
#      The information from a single trial which is spread over
#      the groups.
#----------------------------------------------------------------------
  if (any(apply(cbind(0,p,1),1,diff) < 0))
    stop("p must be increasing and between 0 and 1")
  if (is.vector(p)) p <- t(as.matrix(p))
  ngroups <- dim(p)[1]

  lngrpsz <- length(group.size)
  if (lngrpsz == 1) group.size <- rep(1,ngroups)
    else if (ngroups != lngrpsz)
      stop ("\nnumber or rows of p and length of group.size must match")

  hess <- vector("list",ngroups)
  for(j in 1:ngroups) {
    pj <- p[j,]
    k <- length(pj)
    if (k == 0) next
    if (k == 1) hess[[j]] <- -1/(pj*(1-pj))
      else {
        hess[[j]] <- matrix(0,k,k)

        p.at <- diff(c(0,pj,1))
        t1 <- 1/p.at[-(k+1)]
        t2 <- 1/p.at[-1]
        diag(hess[[j]]) <- -(t1 + t2 )
        for(i in 1:(k-1)) hess[[j]][i,i+1] <- hess[[j]][i+1,i] <-
          1/p.at[i+1]
      }
    hess[[j]] <- group.size[j] * hess[[j]]
  }

  info <- - k.blocks.info(hess)

  return(info/sum(group.size))
}
info.ordinal.one <- function(model="linear", link="logistic",
                                                    theta, covariate) {
#-----------------------------------------------------------------------
# Name: info.ordinal.one
#
# Description:
#      Returns the information matrix for the ordinal model with 
# a single covariate.
#
# Arguments:
# model --
#      One of {"linear", "quadratic"} Only enough to ensure a unique
#      match need be supplied.
#
# link --
#      One of {"logistic", "complementary log"} Only enough to ensure
#      a unique match need be supplied.
#
# theta --
#      Vector of parameters of the linear part of the model.
#      If there are K categories then
#         model = "linear" :
#            U[i] = THETA[i] + THETA[k]*covariate    i = 1,(k-1)
#         model = "quadratic" :
#            U[i] = THETA[i] + THETA[k]*covariate + THETA[k+1]*covariate^2
#                                                             i = 1,(k-1)
#                    
# covariate --
#      Scalar value of the covariate.
#
# Returns:
# The contribution to the information matrix of a single
# observation at value covariate.
#-----------------------------------------------------------------------

      imodel <- pmatch(model,c("linear","quadratic"))
      if (is.na(imodel)) stop("model must be one of {'linear','quadratic'}")
	
      link <- pmatch(link,c("logistic","complementary log"))
      if (is.na(link))
                stop("link must be one of {'logistic','complementary log'}")

	
      ntheta <- length(theta)
      ans <- matrix(0,ntheta,ntheta)
	
      if (imodel==1) ncat <- ntheta
      else ncat <- ntheta - 1
      
      for (icat in 1:ncat) ans <- ans + info.ordinal.cat(
      imodel, link, theta, covariate, icat )

      return( ans )
}
info.poisson.design <- function(model="linear", theta, xpoints,
                             natx=1, group.size=1) {
#-----------------------------------------------------------------------
# Name: info.binomial.design
#
# Description:
#      Returns the information matrix for a Poisson design.
#
# Arguments:
# model --
#      One of {"linear", "quadratic"} Only enough to ensure a unique
#      match need be supplied.
#
# link --
#      One of {"logistic", "complementary log"} Only enough to ensure
#      a unique match need be supplied.
#
# theta --
#      Matrix of parameters of the linear part of the model.
#      Each row represents a group.
#
# xpoints --
#      Matrix of covariate values for each group.
#      Each row represents a group.
#
# natx --
#      Matrix of number of observations at xpoints for each group.
#      Each row represents a group.
#      At covariate value xpoint[i,j] there are natx[i,j] observations.
#
# group.size --
#      The relative number of observations in each group.
#
# Return Value:
#      The the information matrix for one observation for this
#      design. The observation is assumed to be spread over xpoints
#      in proportion to natx.
#-----------------------------------------------------------------------
      if (is.vector(theta)) theta <- t(as.matrix(theta))
      dimt <- dim(theta)
      ngroups <- dimt[1]

      if (is.vector(xpoints)) {
           xpoints <- matrix(xpoints,ngroups,length(xpoints),byrow=T)
           dimp <- dim(xpoints)
      }
      else {
           dimp <- dim(xpoints)
           if (dimp[1] != ngroups)
                stop("Number of rows of xpoints and theta must match")
      }
      if (is.vector(natx)) {
           if (length(natx) == 1)
                natx <- matrix(natx,ngroups,dimp[2],byrow=T)
           else {
                if (length(natx) != dimp[2] )
                     stop ("length of natx must match number of xpoints")
                natx <- matrix(natx,ngroups,dimp[2],byrow=T)
           }
           dimn <- dim(natx)
      }
      else {
           dimn <- dim(natx)
           if (dimn[1] != dimp[1] || dimn[2] != dimp[2])
                stop("xpoints and natx must have the same dimensions")
      }

      lngrpsz <- length(group.size)
      if (lngrpsz == 1) group.size <- rep(group.size,ngroups)
      else if (ngroups != lngrpsz)
       stop("\nNumber of rows of theta and length of group.size must match")

      info <- vector("list",dimp[1])

      for (j in 1:dimp[1]) {
           info[[j]] <- 0
           for (i in 1:length(xpoints[j,]))
                if(natx[j, i] != 0) info[[j]] <- info[[j]] + natx[j,i] *
                      info.poisson.one(model,theta[j,],xpoints[j,i])
           info[[j]] <- info[[j]] * group.size[j]
      }

      info <- k.blocks.info(info)

      return(info/sum(group.size * natx))
}
info.poisson.kgp <- function(lambda,group.size=1 ) {
#-----------------------------------------------------------------------
# Name: info.poisson.kgp
#
# Description:
#      Returns the fisher information for the kgp Poisson model.
#
# Arguments:
# lbamda --
#      For l groups, a vector of length l. lambda[i] is the mean
#      if group i.
#
# group.size --
#      The relative number of observations in each group.
#
# Return Value:
#      The information from a single trial which is spread over
#      the groups.
#-----------------------------------------------------------------------
  if (any(lambda <= 0)) stop("lambda must be positive")
  ngroups <- length(lambda)

  lngrpsz <- length(group.size)
  if (lngrpsz == 1) group.size <- rep(1,ngroups)
    else if (ngroups != lngrpsz)
      stop ("lengths of lambda and group.size must match")

  hess <- -1 / lambda
  info <- (group.size * -hess) / sum(group.size)
  if (ngroups > 1) info <- diag(info)

  return(info)
}
info.poisson.one <- function(model="linear", theta, covariate) {
#-----------------------------------------------------------------------
# Name: info.poisson.one
#
# Description:
#      Returns the information matrix for the Poisson design with a
#      single covariate value.
#
# Arguments:
# model --
#      One of {"linear", "quadratic"} Only enough to ensure a unique
#      match need be supplied.
#
# link --
#      One of {"logistic", "complementary log"} Only enough to ensure
#      a unique match need be supplied.
#
# theta --
#      Vector of parameters of the linear part of the model.
#
# covariate --
#      Scalar value of the covariate.
#
# Return Value:
#      The contribution to the information matrix of a single
#      observation at value covariate.
#-----------------------------------------------------------------------
      model <- pmatch(model,c("linear","quadratic"))
      if (is.na(model)) stop("model must be one of {'linear','quadratic'}")
      if (model == 1) u <- theta[1] + theta[2]*covariate
      else u <- theta[1] + theta[2]*covariate + theta[3]*covariate^2

      if(model != (length(theta)-1))
                stop("theta inconsistant with model")

      lambda <- exp(u)

      d2lldl2 <- -1 / lambda

      dldu <- exp(u)

      dlda <- dldu
      dldb <- dldu * covariate
      if (model == 2) dldc <- dldu * covariate**2

      if (model == 1) hess <- matrix(c(dlda^2,rep(dlda*dldb,2),dldb^2),2,2)
      else hess <- matrix(c(dlda^2,dlda*dldb,dlda*dldc,
                     dldb*dlda,dldb^2,dldb*dldc,
                     dldc*dlda,dldc*dldb,dldc^2),3,3)

      return(- d2lldl2 * hess)
}
invlogit <- function( x ){

# Inverse logit transform of x -- yields probability

infinity <- 78   # Close to largest number that can be exponentiated

tmp <- pmin( infinity, pmax( -infinity, x ) )

tmp <- exp(tmp)

return( tmp/(1+tmp) )     }
k.blocks.info <- function( blocks ) {

      n <- dim(blocks[[1]])[1]
      if (is.null(n)) n <- length(blocks[[1]])
      size <- length(blocks) * n
      info <- matrix(0,size,size)

      ind <- 1
      for (block in blocks) {
           endind <- ind + n - 1
           info[ind:endind,ind:endind] <- block
           ind <- endind + 1
      }

      return(info)
}
lr.n <- function(noncent.obj,power,significance) {
#----------------------------------------------------------------------
# Name: lr.n
#
# Description:
#      Calculates the sample size needed to obtain the
# desired power for a test using the LR method.
#
# Arguments:
# noncent.obj --
#      The object returned from lr.noncent.
#      Should be a list containing, w, the estimated noncentrality
#      parameter of the Chi-Squared distribution and df, the
#      degrees of freedom of the Chi-Squared distribution or the 
#      number of constraints in the null hypothesis.
#
# power --
#      The power of the test.
#
# significance --
#      The significance level of the test.
#
# Return Value:
# The needed sample size.
#----------------------------------------------------------------------

      n <- length(significance)
      m <- length(power)
      if (n !=1 & m!= 1 & n != m)
                stop("lengths of significance and power must match")
      if (n == 1) significance <- rep(significance,length=m)
      if (m == 1) power <- rep(power,length=n)

      w <- rep(0,n)

      crit <- qchisq(1-significance,noncent.obj$df)

      for(i in 1:n) {
	 w[i] <- cdfchn(4,p=1-power[i],x=crit[i],df=noncent.obj$df)$pnonc
      }

      sample.size <- w / noncent.obj$w

      return(sample.size)
}
lr.noncent <- function(theta.ha, info.mat, constraints, nobs.ell=1) {
#----------------------------------------------------------------------
# Name: lr.noncent
#
# Description:
#      Calculates the noncentrality parameter of the Chi-Square
# distribution given the information matrix using the LR method.
#
# Arguments:
# theta.ha --
#      Array of parameter values under the alternative hypothesis.
#
# info.mat --
#      The information matrix, the second derivate matrix of the
#      expected log likelihood under the alternative hypothesis.
#      The negative of the hessian matrix.
#
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#
# nobs.ell --
#      The number of observations used in computing the information
#      matrix.  That is, info.mat is that for nobs.ell observations.
#
# Return Values:
# w -- noncentrality parameter for 1 observation.
#
# df -- degrees of freedom of the test.
#----------------------------------------------------------------------

      if (is.matrix(theta.ha)) theta.ha <- as.vector(t(theta.ha))
      p <- length(theta.ha)

      if (length(info.mat)==1) info.mat <- matrix(info.mat,nrow=1,ncol=1)
      dimi <- dim(info.mat)
      if (dimi[1] != dimi[2]) stop("info.mat is not a square matrix")
      if (p != dimi[1])
           stop("length of theta.ha must match dimension of info.mat")
 
      constraints <- fix.constraints(constraints,length(theta.ha))

      Aans <- construct.a(constraints,length(theta.ha))
      Ainv <- solve(Aans$a)
      hess <- t(Ainv) %*% info.mat %*% Ainv

      constraints <- Aans$constraints
      s <- dim(constraints)[1]
      r <- p - s
      
      hess.phiphi <- hess[1:s,1:s]
      if (r > 0) {
           hess.philam <- hess[1:s,(s+1):p]
           hess.lamphi <- hess[(s+1):p,1:s]
           hess.lamlam <- hess[(s+1):p,(s+1):p]

           w <- hess.phiphi - 
                          hess.philam %*% solve(hess.lamlam) %*% hess.lamphi
      }
      else w <- hess.phiphi

      phi.ha.tran <- transform.phi(theta.ha,constraints)

      phi.diff <- Aans$phi.ho - phi.ha.tran

      w <- t(phi.diff) %*% w %*% phi.diff

#  now convert to the w statistic for one observation
      w <- w / nobs.ell

      df <- s

      return(list(w=w,df=df))
}
lr.power <- function(noncent.obj,sample.size,significance) {
#----------------------------------------------------------------------
# Name: lr.power
#
# Description:
#      Calculates the power of a test with a given sample size
# and significance level using the LR method.
#
# Arguments:
# noncent.obj --
#      The object returned from lr.noncent.
#      Should be a list containing, w, the estimated noncentrality
#      parameter of the Chi-Squared distribution and df, the
#      degrees of freedom of the Chi-Squared distribution or the 
#      number of constraints in the null hypothesis.
#
# sample.size --
#      The sample size of the test.
#
# significance --
#      The significance level of the test.
#
# Return Value:
# The power.
#----------------------------------------------------------------------

      n <- length(significance)
      m <- length(sample.size)
      if (n !=1 & m!= 1 & n != m)
                stop("lengths of significance and sample.size must match")
      if (n == 1) significance <- rep(significance,length=m)
      if (m == 1) sample.size <- rep(sample.size,length=n)

      crit <- qchisq(1-significance,noncent.obj$df)
      w <- noncent.obj$w * sample.size

      if (any(w <= 0.0))
         stop("significance calculation not possible")

      power <- rep(0,n)

      for(i in 1:n) {
	power[i] <- 1-cdfchn(1,x=crit[i],df=noncent.obj$df,pnonc=w[i])$p
      }
      return(power)
}
lr.sig <- function(noncent.obj,sample.size,power) {
#----------------------------------------------------------------------
# Name: lr.sig
#
# Description:
#      Calculates the significance level of a test with a given 
# sample size and power using the LR method.
#
# Arguments:
# noncent.obj --
#      The object returned from lr.noncent.
#      Should be a list containing, w, the estimated noncentrality
#      parameter of the Chi-Squared distribution and df, the
#      degrees of freedom of the Chi-Squared distribution or the 
#      number of constraints in the null hypothesis.
#
# sample.size --
#      The sample size of the test.
#
# power --
#      The power of the test.
#
# Return Value:
# The significance level.
#----------------------------------------------------------------------

      n <- length(sample.size)
      m <- length(power)
      if (n !=1 & m!= 1 & n != m)
                stop("lengths of sample.size and power must match")
      if (n == 1) sample.size <- rep(sample.size,length=m)
      if (m == 1) power <- rep(power,length=n)

      w <- noncent.obj$w * sample.size

      if (any(w <= 0.0))
         stop("significance calculation not possible")

      crit <- rep(0,n)

      for(i in 1:n) {
	crit[i] <- cdfchn(2,p=1-power[i],df=noncent.obj$df,pnonc=w[i])$x
      }

      return(1-pchisq(crit,1))
}
max.expect.loglike <- function(expect.loglike,
                               theta.ha,theta.lo,theta.hi,phi.ho,
                               A,B,
                               n.param,n.ha,n.ho,
                               concri)
#----------------------------------------------------------------------
# Name: max.expect.loglike
#
# Description:
#      Calculates the value of theta.ho.
# 
# Arguments:
# expect.loglike -- function(theta.ha,theta.ho)
#      "expect.loglike" is a user supplied function which
#      calculates the expected value of the log-likelihood
#      function over theta.ha at the value theta.ho.
#
# theta.ha -- 
#      Array of parameter values under the alternative hypothesis.
#
# theta.lo,theta.hi -- 
#      Array of lower and upper limits on the parameter values.
#             
# A, B --
#      Matrices which translate between theta.ho and (phi.ho,lambda.ho)
#      space. See Details below.
#
# n.param, n.ha, n.ho --
#      Number of parameters in the model, alternative hypothesis only,
# and null hypothesis only.
#
# concri --
#      Convergence criterion used for D. Gay minimization.
#
# Details:
#      The SMO method requires the explicit determination of 
# theta.ho, the value of the parameters under the null hypothesis.
# The "constraint" matrix is used to define a new sapce theta*.ho
# where theta*.ho = (phi.ho,lambda.ho). Theta.ho and theta*.ho are
# related via the following equations:
#    theta*.ho = A %*% theta.ho
#    theta.ho = B %*% theta*.ho   (B = Solve(A))
#
# The value of phi.ho is set by the null hypothesis. The value
# of lambda.ho is defined as the value of lambda which maximize
# the expected value of the log-likelihood over theta.ha
# given phi = phi.ho.
#
# In this routine the functions expect.loglike,density and loglike
# calculate the expected log-likelihood in theta.ho space and 
# we use D. Gay routines to minimize the negative log-likelihood in
# theta*.ho space. The matrices A and B are used to translate
# between the 2 spaces.
#----------------------------------------------------------------------
{

   # 
   # Use D. Gay routine DRMNFB to find the value of theta.ho
   # which minimizes the negative of the expect.loglike function.
   #
   
   # Set the starting value of lambda.ho
   lambda.ho <- (A%*%theta.ha)[(n.ho+1):n.param]

   # Set the boundry array
   new.theta.lo <- A%*%theta.lo
   new.theta.hi <- A%*%theta.hi
   bound <- matrix(0,nrow=2,ncol=n.ha)
   for (i in 1:n.ha) {
      bound[1,i] <- new.theta.lo[i+n.ho]
      bound[2,i] <- new.theta.hi[i+n.ho]
   }

   # Set the scale vector
   d <- rep(1,n.ha)

   # Set up the D. Gay process
   lv <- 1000
   liv <- 1000
   v <- rep(0,lv)
   iv <- rep(0,liv)
   ans <- .Fortran("divset",
                   as.integer(2),
                   iv = as.integer(iv),
                   as.integer(liv),
                   as.integer(lv),
                   v = as.double(v))
   v <- ans$v
   iv <- ans$iv
   iv[21] <- 0
   v[32] <- concri
   v[33] <- 1.0e-6
   iv[12] <- 1

   # Main D. Gay loop
   fx <- 0
   while(1) {

      # Call DRMNBF
      ans <- .Fortran("drmnfb",
                      as.double(bound),
                      as.double(d),
                      as.double(fx),
                      iv = as.integer(iv),
                      as.integer(liv),
                      as.integer(lv),
                      as.integer(n.ha),
                      v = as.double(v),
                      lambda.ho = as.double(lambda.ho))

      # Assign values from call to DRMNBF
      iv <- ans$iv
      v <- ans$v
      lambda.ho <- ans$lambda.ho
      theta.ho <- B%*%(c(phi.ho,lambda.ho))
      ierr <- iv[1]

      # If ierr >= 3 we are done
      if (ierr >= 3) break;
      
      # Calculate FX, the negative of the expected log-likelihood
      # at (phi.ho,lambda.ho)
      fx <- -expect.loglike(theta.ha,theta.ho)

      # If FX is Infinite or Not a Number then set IV[2] = 1
      # to inform the D. Gay routine that the parameters are
      # out of bounds.
      if (is.inf(fx) | is.na(fx)) {
         fx <- 0
         iv[2] <- 1
      }
   }

   # Return value of theta.ho
   return(theta.ho,ierr)
}
multinomial.kgp <- function(method,
                            p.ha,group.size=1,
                            const.constraint.group,
                            const.constraint.param,
                            const.constraint.value,
                            equal.constraint.group,
                            equal.constraint.param,
                            significance,power,sample.size,
                            smo.df=T)
#----------------------------------------------------------------------
# Name: multinomial.kgp
#
# Description:
#      Calculates the estimated noncentraility parameter for 
# a single observation for single or multiple group multinomial
# distribution using the SMO model. Uses the non-centrality 
# parameter to calculate the significance, power or sample size.
#
# Model Parameters:
# "p1","p2",... -- The probability an event occured in category i. 
#                  i=1,...,(ncat-1); ncat is the number of categories
#
# Arguments:
# method --
#      The method used. One of {"lr" or "smo"} for the
#      likelihood ratio or SMO method.
#
# p.ha --
#      Alternative hypothesis category.
#      For a single group with n categories p.ha is a vector
#      where p.ha[i] is the probability an event occured in 
#      category i. The dimension of p in this case is (n-1)
#      since p.ha[n] would automatically be the sum of p.ha[i]
#      for i=1,...,n-1. For k groups p.ha is a [k x (n-1)] 
#      matrix with each row containing the category probabilities
#      for a group.
#
# group.size --
#      The relative number of observations in each group.
#      If group.size is identically 1 there are equal observations
#      in each group.
#
# const.constraint.group --
#      A vector of the group indicators for each constant constraint.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint. Available parameters are
#      "p1","p2",... up to the number of categories minus 1.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.group --
#      A vector of the group indicators for each parameter being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#
# smo.df --
#      Only relevent if method is "smo".
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n. 
#----------------------------------------------------------------------
{
   #----------------#
   # Set constants. #
   #----------------#
   imodel <- 3
   idesign <- 1

   #---------------#
   # check method. #
   #---------------#
   imethod <- pmatch(method,c("lr","smo"))
   if (is.na(imethod)) stop("method must be one of 'lr' or 'smo'")

   #-------------#
   # check p.ha. #
   #-------------#
   if (is.vector(p.ha)) p.ha <- t(as.matrix(p.ha))
   if (any(p.ha <= 0.0 | p.ha >= 1.0)) 
      stop("all p.ha must be in range (0,1)")
   if (any(apply(p.ha,1,sum) >= 1.0))
      stop("sum of p.ha must be less than 1")
   ngroup <- nrow(p.ha)
   nparam <- ncol(p.ha)
   ncat <- nparam + 1
   params <- paste("p",1:nparam,sep="")

   #-------------------#
   # check group.size. #
   #-------------------#
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(1,ngroup)
   else if (ngroup != lngrpsz)
      stop ("number of rows in p.ha and length of group.size must match")

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   if (missing(const.constraint.group)) const.constraint.group <- -1
   else qall <- F
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   if (missing(equal.constraint.group)) equal.constraint.group <- -1
   else qall <- F
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                     nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #-------------------------------------------------#
   # check that the constraints create a value p.ho. #
   #-------------------------------------------------#
   # Determine p.ho, the probability that an event occurs
   # in category i or less under the null hypothesis.
   # There are 3 cases:
   # Case 1: No constraint
   # If p[i] is not constrainted then p.ho[i] = p.ha[i]
   # Case 2: Constrained to a value
   # If p[i] is set to a value by the null hypothesis then
   # p.ho[i] is that value.
   # Case 3: Equality constraints
   # If 2 or more probabilties are set equal to each other then
   # the null hypothesis is the mean of those probabilities
   # weighted by the number of observations in each group.
   # NOTE: Probabilities in the same group can not be set
   # equal.

   p.ha.vec <- as.vector(t(p.ha))
   group.size.vec <- as.vector(matrix(group.size,ncol=ngroup,nrow=nparam,
                     byrow=T))
   p.ho.vec <- p.ha.vec
   p.ho.equal <- rep(0,length(p.ho.vec))
   ind.equal <- 0
   n.ho <- nrow(constraint)
   for (i in 1:n.ho) {
      if (constraint[i,1] == 1) {
         p.ho.vec[constraint[i,2]] <- constraint[i,3]
      } else {
         if (p.ho.equal[constraint[i,2]] == 0) {
            ind.equal <- ind.equal + 1
            p.ho.equal[constraint[i,2]] <- ind.equal
            p.ho.equal[constraint[i,3]] <- ind.equal
         } else {
            p.ho.equal[constraint[i,3]] <- p.ho.equal[constraint[i,2]]
         }
      }
   }

   if (ind.equal > 0) {
      for (i in 1:ind.equal) {
         ind <- (p.ho.equal == i)
         p.cur <- sum(group.size.vec[ind]*p.ha.vec[ind])/
                                        sum(group.size.vec[ind])
         p.ho.vec[ind] <- p.cur
      }
   }
   p.ho <- matrix(p.ho.vec,ncol=nparam,nrow=ngroup,byrow=T)

   # Check to see that all p.ho are in the range (0,1)
   if (any(p.ho <= 0.0 | p.ho >= 1.0)) 
      stop("bad constraint. All p.ho must be in range (0,1).")
   if (any(apply(p.ho,1,sum) >= 1.0) )
      stop("bad constraint. Sum of p.ho must be less than 1.")

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size
  
   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   if (imethod == 1) {
      info.mat <- info.multinomial.kgp(p.ha,group.size)
      noncent.obj <- lr.noncent(p.ha,info.mat,constraint)
      if (icalc == 1)
         significance <- lr.sig(noncent.obj,sample.size,power)
      else if (icalc == 2)
         power <- lr.power(noncent.obj,sample.size,significance)
      else
         sample.size <- lr.n(noncent.obj,power,significance)
   } else {
      noncent.obj <- noncent.multinomial.kgp(p.ha,constraint,group.size)
      if (icalc == 1)
         significance <- self.sig(noncent.obj,sample.size,power,smo.df)
      else if (icalc == 2)
         power <- self.power(noncent.obj,sample.size,significance,smo.df)
      else
         sample.size <- self.n(noncent.obj,power,significance,smo.df)
   }

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   methods <- c("LR","SMO")
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method=methods[imethod],model="Multinomial",design="Kgp",
               parameters=params,param.ha=p.ha,
               ngroup=ngroup,group.size=group.size,constraint=constraint,
               calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   if (imethod == 2)
      ans$smo.df <- smo.df
   class(ans) <- "asypow"
   return(ans)
}
mvlogistic.design <- function(method,
                              coef.ha,
                              xpoints,
                              rss=1,
                              const.constraint.param,
                              const.constraint.value,
                              equal.constraint.param,
                              significance,power,sample.size,
                              smo.df=T)
#----------------------------------------------------------------------
# Name: mvlogistic.design
#
# Description:
#      Calculates the estimated non-centraility parameter using
# the SMO method for a single observation for a multivariate
# logistic model where the parameter p, probability of an event,
# depends on the covariates, x = c(x[1], x[2], ..., x[n]),
# through a logistic, p = exp(u)/(1+exp(u)), model. The variable
# u is a linear combination of the covariates via a set of
# coefficients, coef = c(coef[1], coef[2], ..., coef[n]),
# u = Sum (coef[i] * x[i]) i = 1, ... ,n.
#
# The usual use of this routine is for tabulated data in which case the
# x's will all be 0 or 1 valued indicator variables.
#
# Uses the non-centrality parameter to calculate the significance,
# power or sample size.
#
# Model Parameters:
# "p" -- probability of an event
#
# User Parameters:
# "coef1", "coef2",... -- The coefficients of the model
# 
# Arguments:
# method --
#      The method used. One of {"lr" or "smo"} for the
#      likelihood ratio or SMO method.
#
# coef.ha --
#     Vector of length p (number of covariates) giving coefficients
#     of variables.
#
# xpoints --
#     Matrix of length n X p each row of which gives values of
#     covariates at one of the n design points
#     Note: Most models will include a constant term and the column of
#     xpoints corresponding to this term will be identically 1.
#
# rss --
#     The relative sample size at each design point.  If changed
#     from its default value should be a vector of length n.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint. The parameters "coef1",...
#      are available in this model.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#
# smo.df --
#      Only relevent if method is "smo".
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n.
#----------------------------------------------------------------------
{
   #---------------#
   # check method. #
   #---------------#
   imethod <- pmatch(method,c("lr","smo"))
   if (is.na(imethod)) stop("method must be one of 'lr' or 'smo'")

   #----------------#
   # set constants. #
   #----------------#
   nparam <- length( coef.ha )
   imodel <- 6
   idesign <- 1
   params <- paste("coef",1:nparam,sep="")
   ngroup <- 1

   #----------------#
   # check xpoints. #
   #----------------#
   if (is.vector(xpoints)) {
      xpoints <- matrix(xpoints,ngroup,length(xpoints),byrow=T)
      dimp <- dim(xpoints)
   } else {
      dimp <- dim(xpoints)
      if (dimp[2] != nparam)
      stop("number of columns of xpoints and length of coef.ha must match")
   }
   n <- dimp[1]

   #------------#
   # check rss. #
   #------------#
   lrss <- length(rss)
   if ( lrss == 1 ) {
      wt <- rep(1,n)
      tot <- n
   } else if ( lrss == n ) {
      wt <- rss
      tot <- sum(rss)
   } else stop('length of rss must match number of columns of xpoints')

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   const.constraint.group <- -1
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   equal.constraint.group <- -1
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                     nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size

   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   if (imethod == 1) {
      info.mat <- info.mvlogistic(coef.ha,xpoints,rss)
      noncent.obj <- lr.noncent(coef.ha,info.mat,constraint)
      if (icalc == 1)
         significance <- lr.sig(noncent.obj,sample.size,power)
      else if (icalc == 2)
         power <- lr.power(noncent.obj,sample.size,significance)
      else
         sample.size <- lr.n(noncent.obj,power,significance)
   } else {
      noncent.obj <- noncent.mvlogistic(coef.ha,constraint,xpoints,rss)
      if (icalc == 1)
         significance <- self.sig(noncent.obj,sample.size,power,smo.df)
      else if (icalc == 2)
         power <- self.power(noncent.obj,sample.size,significance,smo.df)
      else
         sample.size <- self.n(noncent.obj,power,significance,smo.df)
   }

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   methods <- c("LR","SMO")
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method=methods[imethod],model="Multivariate Logistic",
               parameters=params,param.ha=matrix(coef.ha,nrow=1),
               xpoints=xpoints,rss=rss,
               constraint=constraint,calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   if (imethod == 2)
      ans$smo.df <- smo.df
   class(ans) <- "asypow"
   return(ans)
}
mvloglin.design <- function(method,
                            coef.ha,
                            xpoints,
                            rss=1,
                            const.constraint.param,
                            const.constraint.value,
                            equal.constraint.param,
                            significance,power,sample.size,
                            smo.df=T)
#----------------------------------------------------------------------
# Name: mvloglin.design
#
# Description:
#      Calculates the estimated non-centraility parameter using
# the SMO method for a single observation for a multivariate
# log-linear model where the parameter p, probability of an event,
# depends on the covariates, x = c(x[1], x[2], ..., x[n]), 
# through an exponential, p = exp(u), model. The variable
# u is a combination of the covariates via a set of
# coefficients, coef = c(coef[1], coef[2], ..., coef[n]),
# u = Sum ( log( coef[i] ) * x[i]) i = 1, ... ,n.
#
# The usual use of this routine is for tabulated data in which case the
# x's will all be 0 or 1 valued indicator variables.
#
# Uses the non-centrality parameter to calculate the significance,
# power or sample size.
#
# Model Parameters:
# "p" -- probability of an event
#
# User Parameters:
# "coef1", "coef2",... -- The coefficients of the model
# 
# Arguments:
# method --
#      The method used. One of {"lr" or "smo"} for the
#      likelihood ratio or SMO method.
#
# coef.ha --
#     Vector of length p (number of covariates) giving coefficients
#     of variables. Must be greater than 0.
#
# xpoints --
#     Matrix of length n X p each row of which gives values of
#     covariates at one of the n design points
#     Note: Most models will include a constant term and the column of
#     xpoints corresponding to this term will be identically 1.
#
# rss --
#     The relative sample size at each design point.  If changed
#     from its default value should be a vector of length n.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint. The parameters "coef1",...
#      are available in this model.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#
# smo.df --
#      Only relevent if method is "smo".
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n.
#----------------------------------------------------------------------
{
   #---------------#
   # check method. #
   #---------------#
   imethod <- pmatch(method,c("lr","smo"))
   if (is.na(imethod)) stop("method must be one of 'lr' or 'smo'")

   #----------------#
   # check coef.ha. #
   #----------------#
   nparam <- length(coef.ha)
   if (any(coef.ha <= 0.0)) stop("coef.ha must be greater than 0")

   #----------------#
   # set constants. #
   #----------------#
   imodel <- 7
   idesign <- 1
   params <- paste("coef",1:nparam,sep="")
   ngroup <- 1

   #----------------#
   # check xpoints. #
   #----------------#
   if (is.vector(xpoints)) {
      xpoints <- matrix(xpoints,ngroup,length(xpoints),byrow=T)
      dimp <- dim(xpoints)
   } else {
      dimp <- dim(xpoints)
      if (dimp[2] != nparam)
      stop("number of columns of xpoints and length of coef.ha must match")
   }
   n <- dimp[1]

   #------------#
   # check rss. #
   #------------#
   lrss <- length(rss)
   if ( lrss == 1 ) {
      wt <- rep(1,n)
      tot <- n
   } else if ( lrss == n ) {
      wt <- rss
      tot <- sum(rss)
   } else stop('length of rss must match number of columns of xpoints')

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   const.constraint.group <- -1
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   equal.constraint.group <- -1
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                     nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size

   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   if (imethod == 1) {
      info.mat <- info.mvloglin(coef.ha,xpoints,rss)
      noncent.obj <- lr.noncent(coef.ha,info.mat,constraint)
      if (icalc == 1)
         significance <- lr.sig(noncent.obj,sample.size,power)
      else if (icalc == 2)
         power <- lr.power(noncent.obj,sample.size,significance)
      else
         sample.size <- lr.n(noncent.obj,power,significance)
   } else {
      noncent.obj <- noncent.mvloglin(coef.ha,constraint,xpoints,rss)
      if (icalc == 1)
         significance <- self.sig(noncent.obj,sample.size,power,smo.df)
      else if (icalc == 2)
         power <- self.power(noncent.obj,sample.size,significance,smo.df)
      else
         sample.size <- self.n(noncent.obj,power,significance,smo.df)
   }

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   methods <- c("LR","SMO")
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method=methods[imethod],model="Multivariate Log-Linear",
               parameters=params,param.ha=matrix(coef.ha,nrow=1),
               xpoints=xpoints,rss=rss,
               constraint=constraint,calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   if (imethod == 2)
      ans$smo.df <- smo.df
   class(ans) <- "asypow"
   return(ans)
}
noncent.binomial.design <- function(theta.ha, constraints, xpoints, 
        model="linear",link="logistic", natx=1, group.size=1)
#-----------------------------------------------------------------------
# Name: noncent.binomial.design
#
# Description:
#      Calculates the estimated non-centraility parameter using
# the SMO method for a single observation for a binomial design 
# where the parameter p, probability of an event, depends on a 
# covariate, x, through a logistic, p = exp(u)/(1+exp(u)), or 
# complementary log, p = 1 - exp(-exp(u)), model. The variable u 
# is either a linear, u = a + b*x, or quadratic, u = a + b*x + c*x^2,
# function of the covariate x.
#
# Arguments:
# theta.ha --
#     Matrix of parameters of the linear part of the model.
#     Each row represents a group. If model is "linear" then
#     theta.ha has two columns, the values of (a,b) for each
#     group. If model is "quadratic" then theta.ha has three
#     columns, the values of (a,b,c) for each group.
#
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#     Clarification: The parameters of the "quadatic" model are
#     (a,b,c) for group 1, then (a,b,c) for group2 and so on. The
#     index for parameter b in group 2 would be 5. Likewise,
#     for the "linear" model the parameters are (a,b) for group 1,
#     then (a,b) for group 2  and so on. The index for parameter
#     b in group 2 would be 4.
#
# xpoints --
#     Matrix of covariate values for each group.
#     Each row represents a group.
#
# model --
#     One of {"linear", "quadratic"} Only enough to ensure a unique
#     match need be supplied. If model is "linear" then u = a + b*x;
#     if model is "quadratic" then u = a + b*x + c*x^2.
#
# link --
#     One of {"logistic", "complementary log"} Only enough to ensure
#     a unique match need be supplied. If link is "logistic" then
#     p = exp(u)/(1+exp(u)); if link is "complementary log" then
#     p = 1-exp(-exp(u)).
#
# natx --
#     Matrix of number of observations at each covariate value in
#     each group. Columns represent covariate values; rows represent
#     groups. At covariate value xpoint[i,j] there are natx[i,j] 
#     observations. If the number of observations at each covariate
#     value is the same for each group; natx can be a vector.
#     If the number of observations is the same for each covariate
#     value in each group; natx can be a scalar.
#
# group.size --
#     The relative number of observations in each group.
#-----------------------------------------------------------------------
{
   # model = 1 for "linear" model; 2 for "quadratic" model; otherwise error.
   model <- pmatch(model,c("linear","quadratic"))
   if (is.na(model)) stop("model must be one of {'linear','quadratic'}")

   # link = 1 for "logistic"; 2 for "complementary log"; otherwise error.
   link <- pmatch(link,c("logistic","complementary log"))
   if (is.na(link))
      stop("link must be one of {'logistic','complementary log'}")

   # Check theta.ha
   if (is.vector(theta.ha)) theta.ha <- t(as.matrix(theta.ha))
   dimt <- dim(theta.ha)
   ngroups <- dimt[1]
   ltheta <- dimt[2]
   if ((model == 1) & (ltheta != 2))
      stop("for a 'linear' model theta.ha must have 2 columns")
   if ((model == 2) & (ltheta != 3))
      stop("for a 'quadratic' model theta.ha must have 3 columns")

   # Check constraints
   n.params <- ltheta*ngroups
   constraints <- fix.constraints(constraints,n.params)

   # Check xpoints
   if (is.vector(xpoints)) {
      xpoints <- matrix(xpoints,ngroups,length(xpoints),byrow=T)
      dimp <- dim(xpoints)
   } else {
      dimp <- dim(xpoints)
      if (dimp[1] != ngroups)
      stop("number of rows of xpoints and theta.ha must match")
   }
   npoints <- dimp[2]

   # Check natx
   if (is.vector(natx)) {
      if (length(natx) == 1)
         natx <- matrix(natx,ngroups,dimp[2],byrow=T)
      else {
         if (length(natx) != dimp[2] )
            stop ("length of natx must match number of xpoints")
          natx <- matrix(natx,ngroups,dimp[2],byrow=T)
      }
      dimn <- dim(natx)
   } else {
      dimn <- dim(natx)
      if (dimn[1] != dimp[1] || dimn[2] != dimp[2])
         stop("xpoints and natx must have the same dimensions")
   }

   # Check group.size
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(group.size,ngroups)
   else if (ngroups != lngrpsz)
      stop("\nnumber of rows of theta.ha and length of group.size must match")

   # Define a function which calculates the expected value of the
   # log-likelihood at a point theta.ho over the true value theta.ha.
   # For 1 group and 1 design point x:
   # Let u = a + b*x                (if model is "linear")
   #       = a + b*x + c*x^2        (if model is "quadratic")
   # Let p = exp(u)/(1+exp(u))      (if link is "logistic")
   #       = 1-exp(-exp(u))         (if link is "complementary log")
   # The density is:
   #     d(p) = p                   (if the event occurs)
   #            1-p                 (if the event does not occur)
   # The log-likelihood is:
   #     l(p) = log(p)              (if the event occurs)
   #            log(1-p)            (if the event does not occur)
   # The expected value of the log-likelihood of p.ha over p.ho
   # is given by:
   #      p.ha*log(p.ho) + (1-p.ha)*log(1-p.ho)
   # NOTE: p.ha is caluclated from (a,b,c) values in the alternative
   # hypothesis; p.ho is calculated from (a,b,c) values in the null
   # hypothesis.
   # For all the design points in each group we average the above
   # values with the weights defined in natx and group.size.

   scale.x <- group.size*natx
   n.x <-  sum(scale.x)
   if (model == 1) xpoints2 <- matrix(0,nrow=ngroups,ncol=npoints)
   else xpoints2 <- xpoints^2
   assign("model",model,frame=1)
   assign("link",link,frame=1)
   assign("npoints",npoints,frame=1)
   assign("ngroups",ngroups,frame=1)
   assign("xpoints",xpoints,frame=1)
   assign("xpoints2",xpoints2,frame=1)
   assign("scale.x",scale.x,frame=1)
   assign("n.x",n.x,frame=1)
   toremove.list <- c(
    "model", "link", "ngroups", "xpoints", "xpoints2", "scale.x",
    "n.x"
    )

   expect.loglike <- function(theta.ha.vec,theta.ho.vec) {
      theta.ha <- matrix(theta.ha.vec,nrow=ngroups,byrow=T)
      theta.ho <- matrix(theta.ho.vec,nrow=ngroups,byrow=T)
      ell <- 0
      for (i in 1:ngroups) {
         for (j in 1:npoints) {
            x <- xpoints[i,j]
            x2 <- xpoints2[i,j]
            if (model == 1) {
               u.ha <- sum(theta.ha[i,]*c(1,x))
               u.ho <- sum(theta.ho[i,]*c(1,x))
            } else {
               u.ha <- sum(theta.ha[i,]*c(1,x,x2))
               u.ho <- sum(theta.ho[i,]*c(1,x,x2))
            }
            if (link == 1) {
               p.ha <- 1/(1+exp(-u.ha))
               p.ho <- 1/(1+exp(-u.ho))
            } else {
               p.ha <- 1-exp(-exp(u.ha))
               p.ho <- 1-exp(-exp(u.ho))
            }
            ell.one <- p.ha*log(p.ho) + (1-p.ha)*log(1-p.ho)
            ell <- ell + scale.x[i,j]*ell.one
         }
      }
      ell <- ell/n.x
      return(ell)
   }

   # Convert theta.ha to a vector for the generic part of this routine.
   theta.ha <- as.vector(t(theta.ha))

   # Calculate the expected value of the log-likelihood at theta.ha
   # over theta.ha.
   ell.ha <- expect.loglike(theta.ha,theta.ha)
   if (is.na(ell.ha))
      stop("theta.ha, model, link and xpoints are such that some probability in the alternative hypothesis is equal to 0 or 1")

   # Define a vector theta' = A*theta such that theta' = (phi,lambda).
   # Phi are the parameters set to phi.not by the null hypothesis.
   # Lambda are the unconstrained parameters. Define B = A^(-1)
   # so that theta = B*theta'.

   Aans <- construct.a(constraints,n.params)
   A <- Aans$a
   B <- solve(A)
   constraints <- Aans$constraints
   phi.ho <- Aans$phi.ho          # Value of constrained parameters
   n.ho <- dim(constraints)[1]    # Number of constrained parameters
   n.ha <- n.params - n.ho         # Number of unconstrained parameters

   # Calculate theta.ho, the value of theta under the null
   # hypothesis. This is defined as the value of theta that
   # maximizes E[l(phi.ho,lambda)] over theta.ha.

   if (n.ha > 0) {
      theta.lo <- rep(-1e5,n.params)
      theta.hi <- rep(1e5,n.params)
      ans <- max.expect.loglike(expect.loglike,
                               theta.ha,theta.lo,theta.hi,phi.ho,
                               A,B,
                               n.params,n.ha,n.ho,
                               1.0e-6)
      ierr <- ans$ierr
      if (ierr > 8) stop("Calculation of maximum log-likelihood failed.")
      theta.ho <- ans$theta.ho
   } else {
      theta.ho <- B%*%phi.ho
   }

   # Calculate the expected value of the log-likelihood at theta.ho
   # over theta.ha.
   ell.ho <- expect.loglike(theta.ha,theta.ho)
   if (is.na(ell.ho))
      stop("constraints, model, link and xpoints are such that some probability in the null hypothesis is equal to 0 or 1")

   # Return w, the noncentraility parameter estimate,
   # theta.ho, the estimate of the parameters under the null
   # hypothesis and df, the degress of freedom

   w <- 2*(ell.ha-ell.ho)
   df <- n.ho
   theta.ho <- matrix(theta.ho,nrow=ngroups,byrow=T)
   remove( toremove.list, frame=1 )
   return(w,df,theta.ho)
}
noncent.binomial.kgp <- function(p.ha,constraints,group.size=1)
#----------------------------------------------------------------------
# Name: noncent.binomial.kgp
#
# Description:
#      Calculates the estimated non-centraility parameter for 
# a single observation for single or multiple group binomial 
# distribution using the SMO method.
#
# Arguments:
# p.ha --
#      Scalar or vector of probability values.  The i'th component 
#      is the alternative hypothesis (or true) probability of
#      an event in the i'th group.
#
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#
# group.size --
#      The relative number of observations in each group.
#
# Return Values:
# w -- noncentrality parameter for 1 observation.
#
# df -- degrees of freedom of the test.
#
# p.ho -- estimates of the parameter values under the 
#         null hypothesis.
#----------------------------------------------------------------------
{
   # check to see that p.ha is in (0,1)
   if (any(p.ha <= 0.0 | p.ha >= 1.0)) stop ("p.ha must be in range (0,1)")
   ngroups <- length(p.ha)

   # check group.size
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(1,ngroups)
     else if (ngroups != lngrpsz)
       stop ("lengths of p.ha and group.size must match")

   # check the constraints
   constraints <- fix.constraints(constraints,ngroups)

   # Determine p.ho, the value of p under the null hypothesis.
   # There are 3 cases:
   # Case 1: No constraint
   # If p[i] is not constrainted then p.ho[i] = p.ha[i]
   # Case 2: Constrained to a value
   # If p[i] is set to a value by the null hypothesis then
   # p.ho[i] is that value.
   # Case 3: Equality constraints
   # If 2 or more probabilties are set equal to each other then
   # the null hypothesis is the mean of those probabilities
   # weighted by the number of observations in each group.
   p.ho <- p.ha
   p.ho.equal <- rep(0,ngroups)
   ind.equal <- 0
   n.ho <- nrow(constraints)
   for (i in 1:n.ho) {
      if (constraints[i,1] == 1) {
         p.ho[constraints[i,2]] <- constraints[i,3]
      } else {
         if (p.ho.equal[constraints[i,2]] == 0) {
            ind.equal <- ind.equal + 1
            p.ho.equal[constraints[i,2]] <- ind.equal
            p.ho.equal[constraints[i,3]] <- ind.equal
         } else {
            p.ho.equal[constraints[i,3]] <- p.ho.equal[constraints[i,2]]
         }
      }
   }

   if (ind.equal > 0) {
      for (i in 1:ind.equal) {
         ind <- (p.ho.equal == i)
         p.cur <- sum(group.size[ind]*p.ha[ind])/sum(group.size[ind])
         p.ho[ind] <- p.cur
      }
   }

   # Be sure that all probabilities in the null hypothesis are
   # in the range (0,1)
   if (any(p.ho <= 0.0 | p.ho >= 1.0)) 
      stop ("Bad constraint. p must be in range (0,1)")

   # The binomial density is
   #      f(p) = p     if event occurs
   #             1-p   if event does not occur
   # The log-likelihood is
   #      l(p) = log(p)      if the event occurs
   #             log(1-p)    if the event does not occur
   # The expected value of the log-likelihood of p.ha over p.ho
   # is given by:
   #      p.ha*log(p.ho) + (1-p.ha)*log(1-p.ho)

   # Calculate the expected value of the log-likelihood at p.ha
   # over p.ha.
   ell.ha <- sum((p.ha*log(p.ha) + (1-p.ha)*log(1-p.ha))*group.size)/
             sum(group.size)

   # Calcualte the expected value of the log-lieklihood at p.ho
   # over p.ha.
   ell.ho <- sum((p.ha*log(p.ho) + (1-p.ha)*log(1-p.ho))*group.size)/
             sum(group.size)

   # Return w, the noncentraility parameter estimate,
   # p.ho, the estimate of the parameters under the null hypothesis
   # and df, the degress of freedom

   w <- 2*(ell.ha-ell.ho)
   df <- n.ho
   return(w,df,p.ho)
}
noncent.expsurv.design <- function(theta.ha, L, constraints, xpoints, 
        model="linear", natx=1, group.size=1)
#----------------------------------------------------------------------
# Name: noncent.expsurv.kgroup
#
# Description:
#      Calculates the estimated non-centraility parameter using
# the SMO method for a single observation for a clinical trial
# with exponential survival where the rate, depends on a covariate
# x, via the equation rate=exp(u). The variable u is either a 
# linear, u = a + b*x, or quadratic, u = a + b*x + c*x^2, function 
# of the covariate x.
#
# Arguments:
# theta.ha --
#     Matrix of parameters of the linear part of the model.
#     Each row represents a group. If model is "linear" then
#     theta.ha has two columns, the values of (a,b) for each
#     group. If model is "quadratic" then theta.ha has three
#     columns, the values of (a,b,c) for each group.
#
# L --
#      The length of the study. If L is length 1 each group has
#      a study of length L. If L is the same as length as the
#      number of groups, each group has a different length.
#
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#     Clarification: The parameters of the "quadatic" model are
#     (a,b,c) for group 1, then (a,b,c) for group2 and so on. The
#     index for parameter b in group 2 would be 5. Likewise,
#     for the "linear" model the parameters are (a,b) for group 1,
#     then (a,b) for group 2  and so on. The index for parameter
#     b in group 2 would be 4.
#
# xpoints --
#     Matrix of covariate values for each group.
#     Each row represents a group.
#
# model --
#     One of {"linear", "quadratic"} Only enough to ensure a unique
#     match need be supplied. If model is "linear" then u = a + b*x;
#     if model is "quadratic" then u = a + b*x + c*x^2.
#
# natx --
#     Matrix of number of observations at each covariate value in
#     each group. Columns represent covariate values; rows represent
#     groups. At covariate value xpoint[i,j] there are natx[i,j] 
#     observations. If the number of observations at each covariate
#     value is the same for each group; natx can be a vector.
#     If the number of observations is the same for each covariate
#     value in each group; natx can be a scalar.
#
# group.size --
#     The relative number of observations in each group.
#-----------------------------------------------------------------------
{
   # model = 1 for "linear" model; 2 for "quadratic" model; otherwise error.
   model <- pmatch(model,c("linear","quadratic"))
   if (is.na(model)) stop("model must be one of {'linear','quadratic'}")

   # Check theta.ha
   if (is.vector(theta.ha)) theta.ha <- t(as.matrix(theta.ha))
   dimt <- dim(theta.ha)
   ngroups <- dimt[1]
   ltheta <- dimt[2]
   if ((model == 1) & (ltheta != 2))
      stop("for a 'linear' model theta.ha must have 2 columns")
   if ((model == 2) & (ltheta != 3))
      stop("for a 'quadratic' model theta.ha must have 3 columns")

   # Check L
   if (any(L) <= 0.0) 
      stop("L must be greater than 0")
   if (length(L) == 1) L <- rep(L,ngroups)
   if (length(L) != ngroups)
      stop("length of L and number of rows in theta.ha must match")

   # Check constraints
   n.params <- ltheta*ngroups
   constraints <- fix.constraints(constraints,n.params)

   # Check xpoints
   if (is.vector(xpoints)) {
      xpoints <- matrix(xpoints,ngroups,length(xpoints),byrow=T)
      dimp <- dim(xpoints)
   } else {
      dimp <- dim(xpoints)
      if (dimp[1] != ngroups)
      stop("number of rows of xpoints and theta.ha must match")
   }
   npoints <- dimp[2]

   # Check natx
   if (is.vector(natx)) {
      if (length(natx) == 1)
         natx <- matrix(natx,ngroups,dimp[2],byrow=T)
      else {
         if (length(natx) != dimp[2] )
            stop ("length of natx must match number of xpoints")
          natx <- matrix(natx,ngroups,dimp[2],byrow=T)
      }
      dimn <- dim(natx)
   } else {
      dimn <- dim(natx)
      if (dimn[1] != dimp[1] || dimn[2] != dimp[2])
         stop("xpoints and natx must have the same dimensions")
   }

   # Check group.size
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(group.size,ngroups)
   else if (ngroups != lngrpsz)
      stop("\nnumber of rows of theta.ha and length of group.size must match")

   # Define a function which calculates the expected value
   # of the log-likelihood over rate.ha at the point rate.ho.
   # For 1 group and 1 design point:
   # Let u = a + b*x                (if model is "linear")
   #       = a + b*x + c*x^2        (if model is "quadratic")
   #     rate = exp(u)
   # There are two contributions to the log-likelihood:
   # CASE 1: DEATH
   # The density of the exponential survival model is:
   #    d(rate) = rate*exp(-rate*t)
   # The log-likelihood is:
   #    l(rate) = log(rate) - rate*t
   # To find the expected value, E[l(rate.ho)], we multiply
   # the log-likelihood at the value rate.ho, l(rate.ho), times
   # the density at the true parameter values, d(rate.ha), and
   # integrate over t from 0 to U, the patients follow-up time.
   # Since the follow-up time is randomly distributed between
   # 0 and L, the length of the study, we integrate the result
   # over U from 0 to L and multiply by 1/L, the uniform density.
   # The result is:
   # ((2*rate.ho - rate.ha*log(rate.ho)) + exp(-L*rate.ha)*
   #         (-2*rate.ho - L*rate.ha*rate.ho + rate.ha*log(rate.ho)))
   #   /(L*rate.ha^2)
   # +
   # (-rate.ho + rate.ha*log(rate.ho))/rate.ha
   # CASE 2: CENSORING
   # If failure does not occur the subject is censored at the
   # follow-up time U. The probability of this is:
   #    f(rate) = exp(-rate*U)
   # The log-likelihood is:
   #    l(rate) = -rate*U
   # To find the epxected value, E[l(rate.ho)], we multiply
   # the log-likelihood at the value rate.ho, l(rate.ho), times
   # the desnity at the true parameter values, d(rate.ha), and
   # intergrate over U from 0 to L and multiply by 1/L.
   # The result is:
   # (-rate.ho + exp(-L*rate.ha)*rate.ho*(1+L*rate.ha))/(L*rate.ha^2) 
   # For all the design points in each group we average the above
   # values with the weights defined in natx and group.size.

   scale.x <- group.size*natx
   n.x <-  sum(scale.x)
   if (model == 1) xpoints2 <- matrix(0,nrow=ngroups,ncol=npoints)
   else xpoints2 <- xpoints^2
   assign("model",model,frame=1)
   assign("npoints",npoints,frame=1)
   assign("ngroups",ngroups,frame=1)
   assign("xpoints",xpoints,frame=1)
   assign("xpoints2",xpoints2,frame=1)
   assign("scale.x",scale.x,frame=1)
   assign("n.x",n.x,frame=1)
   assign("L",L,frame=1)
   toremove.list <- c(
                      "model", "npoints", "ngroups", "xpoints",
                      "xpoints2", "scale.x", "n.x", "L"
                      )


   expect.loglike <- function(theta.ha.vec,theta.ho.vec) {

      expect.loglike.one <- function(rate.ha,rate.ho,LL) {
         rlr <- rate.ha*log(rate.ho)
         elr <- exp(-LL*rate.ha)
         lr <- LL*rate.ha
         lr2 <- LL*rate.ha^2
         dead <- ((2*rate.ho - rlr) + elr*
                 (-2*rate.ho - lr*rate.ho + rlr))/(lr2) +
                  (-rate.ho + rlr)/rate.ha      
         censor <- (-rate.ho + elr*rate.ho*(1+lr))/(lr2)
         ell.one <- dead + censor
         return(ell.one)
      }

      theta.ha <- matrix(theta.ha.vec,nrow=ngroups,byrow=T)
      theta.ho <- matrix(theta.ho.vec,nrow=ngroups,byrow=T)
      ell <- 0
      for (i in 1:ngroups) {
         for (j in 1:npoints) {
            x <- xpoints[i,j]
            x2 <- xpoints2[i,j]
            if (model == 1) {
               u.ha <- sum(theta.ha[i,]*c(1,x))
               u.ho <- sum(theta.ho[i,]*c(1,x))
            } else {
               u.ha <- sum(theta.ha[i,]*c(1,x,x2))
               u.ho <- sum(theta.ho[i,]*c(1,x,x2))
            }
            rate.ha <- exp(u.ha)
            rate.ho <- exp(u.ho)
            ell.one <- expect.loglike.one(rate.ha,rate.ho,L[i])
            ell <- ell + scale.x[i,j]*ell.one
         }
      }
      ell <- ell/n.x
      return(ell)
   }

   # Convert theta.ha to a vector for the generic part of this routine.
   theta.ha <- as.vector(t(theta.ha))

   # Calculate the expected value of the log-likelihood at theta.ha
   # over theta.ha.
   ell.ha <- expect.loglike(theta.ha,theta.ha)
   if (is.na(ell.ha))
      stop("theta.ha, model and xpoints are such that some rate in the alternative hypothesis is infinite")

   # Define a vector rate' = A*rate such that rate' = (phi,lambda).
   # Phi are the parameters set to phi.not by the null hypothesis.
   # Lambda are the unconstrained parameters. Define B = A^(-1)
   # so that rate = B*rate'.

   Aans <- construct.a(constraints,n.params)
   A <- Aans$a
   B <- solve(A)
   constraints <- Aans$constraints
   phi.ho <- Aans$phi.ho          # Value of constrained parameters
   n.ho <- dim(constraints)[1]    # Number of constrained parameters
   n.ha <- n.params - n.ho         # Number of unconstrained parameters

   # Calculate theta.ho, the value of theta under the null
   # hypothesis. This is defined as the value of theta that
   # maximizes E[l(phi.ho,lambda)] over theta.ha.

   if (n.ha > 0) {
      theta.lo <- rep(-1e5,n.params)
      theta.hi <- rep(1e5,n.params)
      ans <- max.expect.loglike(expect.loglike,
                               theta.ha,theta.lo,theta.hi,phi.ho,
                               A,B,
                               n.params,n.ha,n.ho,
                               1.0e-6)
      ierr <- ans$ierr
      if (ierr > 8) stop("Calculation of maximum log-likelihood failed.")
      theta.ho <- ans$theta.ho
   } else {
      theta.ho <- B%*%phi.ho
   }

   # Calculate the expected value of the log-likelihood at theta.ho
   # over theta.ha.
   ell.ho <- expect.loglike(theta.ha,theta.ho)
   if (is.na(ell.ho))
      stop("constraints, model and xpoints are such that some rate in the null hypothesis is infinite")

   # Return w, the noncentraility parameter estimate,
   # theta.ho, the estimate of the parameters under the null
   # hypothesis and df, the degress of freedom

   w <- 2*(ell.ha-ell.ho)
   df <- n.ho
   theta.ho <- matrix(theta.ho,nrow=ngroups,byrow=T)

   remove( toremove.list, frame=1 )

   return(w,df,theta.ho)

}
noncent.expsurv.kgp <- function(rate.ha,L,constraints,group.size=1)
#----------------------------------------------------------------------
# Name: noncent.expsurv.kgp
#
# Description:
#      Calculates the estimated non-centraility parameter for 
# a single observation for single or multiple group kgp
# exponential survival model using the SMO method.
#
# Arguments:
# rate.ha --
#      Scalar or vector of the rates (or inverse of the means of the 
#      exponential distribution) for the groups. The i'th component
#      is the alternative hypothesis (or true) rate for the i'th group.
#
# L --
#      The length of the study. If L is length 1 each group has
#      a study of length L. If L is the same length as rate.ha
#      each group has a different length.
#
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#
# group.size --
#      The relative number of observations in each group.
#
# Return Values:
# w -- noncentrality parameter for 1 observation.
#
# df -- degrees of freedom of the test.
#
# rate.ho -- estimates of the parameter values under the 
#            null hypothesis.
#----------------------------------------------------------------------
{
   # Check to see that lambda.ha is greater than 0
   if (any(rate.ha <= 0.0)) stop ("rate.ha must be greater than 0")
   if (any(is.inf(rate.ha))) 
      stop("Inf not allowed in rate.ha")
   ngroups <- length(rate.ha)

   # Check L
   if (any(L) <= 0.0) 
      stop("L must be greater than 0")
   if (length(L) == 1) L <- rep(L,ngroups)
   if (length(L) != ngroups)
      stop("lengths of rate.ha and L must match")

   # Check group.size
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(1,ngroups)
     else if (ngroups != lngrpsz)
       stop ("lengths of rate.ha and group.size must match")

   # Check the constraints
   constraints <- fix.constraints(constraints,ngroups)
   rate.constrained <- constraints[(constraints[,1] == 1),3]
   if (length(rate.constrained) > 0)
      if (any(rate.constrained <= 0.0))
         stop("bad constraints. rate must be greater than 0.")

   # Define a function which calculates the expected value
   # of the log-likelihood over rate.ha at the point rate.ho.
   # For 1 group there are two contributions to the log-likelihood:
   # CASE 1: DEATH
   # The density of the exponential survival model is:
   #    d(rate) = rate*exp(-rate*t)
   # The log-likelihood is:
   #    l(rate) = log(rate) - rate*t
   # To find the expected value, E[l(rate.ho)], we multiply
   # the log-likelihood at the value rate.ho, l(rate.ho), times
   # the density at the true parameter values, d(rate.ha), and
   # integrate over t from 0 to U, the patients follow-up time.
   # Since the follow-up time is randomly distributed between
   # 0 and L, the length of the study, we integrate the result
   # over U from 0 to L and multiply by 1/L, the uniform density.
   # The result is:
   # ((2*rate.ho - rate.ha*log(rate.ho)) + exp(-L*rate.ha)*
   #         (-2*rate.ho - L*rate.ha*rate.ho + rate.ha*log(rate.ho)))
   #   /(L*rate.ha^2)
   # +
   # (-rate.ho + rate.ha*log(rate.ho))/rate.ha
   # CASE 2: CENSORING
   # If failure does not occur the subject is censored at the
   # follow-up time U. The probability of this is:
   #    f(rate) = exp(-rate*U)
   # The log-likelihood is:
   #    l(rate) = -rate*U
   # To find the epxected value, E[l(rate.ho)], we multiply
   # the log-likelihood at the value rate.ho, l(rate.ho), times
   # the desnity at the true parameter values, d(rate.ha), and
   # intergrate over U from 0 to L and multiply by 1/L.
   # The result is:
   # (-rate.ho + exp(-L*rate.ha)*rate.ho*(1+L*rate.ha))/(L*rate.ha^2) 
   
   assign("L",L,frame=1)
   assign("group.size",group.size,frame=1)
   toremove.list <- c(
                      "L", "group.size"
                      )
   expect.loglike <- function(rate.ha,rate.ho) {
      rlr <- rate.ha*log(rate.ho)
      elr <- exp(-L*rate.ha)
      lr <- L*rate.ha
      lr2 <- L*rate.ha^2
      dead <- ((2*rate.ho - rlr) + elr*
              (-2*rate.ho - lr*rate.ho + rlr))/(lr2) +
               (-rate.ho + rlr)/rate.ha      
      censor <- (-rate.ho + elr*rate.ho*(1+lr))/(lr2)
      ell <- dead + censor
      return(sum(group.size*ell)/sum(group.size))
   }

   # Define a vector rate' = A*rate such that rate' = (phi,lambda).
   # Phi are the parameters set to phi.not by the null hypothesis.
   # Lambda are the unconstrained parameters. Define B = A^(-1)
   # so that rate = B*rate'.

   Aans <- construct.a(constraints,length(rate.ha))
   A <- Aans$a
   B <- solve(A)
   constraints <- Aans$constraints
   phi.ho <- Aans$phi.ho          # Value of constrained parameters
   n.ho <- dim(constraints)[1]    # Number of constrained parameters
   n.ha <- ngroups - n.ho         # Number of unconstrained parameters

   # Calculate rate.ho, the value of rate under the null
   # hypothesis. This is defined as the value of rate that
   # maximizes E[l(phi.ho,lambda)] over rate.ha.

   if (n.ha > 0) {
      rate.lo <- c(0,0)
      rate.hi <- c(1e5,1e5)
      ans <- max.expect.loglike(expect.loglike,
                               rate.ha,rate.lo,rate.hi,phi.ho,
                               A,B,
                               ngroups,n.ha,n.ho,
                               1.0e-6)
      ierr <- ans$ierr
      if (ierr > 8) stop("Calculation of maximum log-likelihood failed.")
      rate.ho <- ans$theta.ho
   } else {
      rate.ho <- B%*%phi.ho
   }

   # Calculate the expected value of the log-likelihood at rate.ha
   # over rate.ha.
   ell.ha <- expect.loglike(rate.ha,rate.ha)

   # Calcualte the expected value of the log-lieklihood at rate.ho
   # over rate.ha.
   ell.ho <- expect.loglike(rate.ha,rate.ho)

   # Return w, the noncentraility parameter estimate,
   # rate.ho, the estimate of the parameters under the null
   # hypothesis and df, the degress of freedom

   w <- 2*(ell.ha-ell.ho)
   df <- n.ho
   rate.ho <- as.vector(rate.ho)

   remove( toremove.list, frame=1 )

   return(w,df,rate.ho)
}



noncent.generic <- function(theta.ha, theta.lo, theta.hi,
                             constraints,
                             expect.loglike,
                             concri=1.0e-6)
#----------------------------------------------------------------------
# Name: noncent.generic
#
# Description:
#      Calculates the estimated non-centraility parameter for 
# a generic problem using the SMO method.
#
# Arguments:
# theta.ha -- 
#      Array of parameter values under the alternative hypothesis.
#
# theta.lo,theta.hi -- 
#      Array of lower and upper limits on the parameter values.
#             
# constraints -- 
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#
# expect.loglike -- function(theta.ha,theta.ho)
#      "expect.loglike" is a user supplied function which
#      calculates the expected value of the log-likelihood
#      function over theta.ha at the value theta.ho.
#      Expect.loglike should be a function of the two vectors,
#      theta.ha and theta.ho.
#
#      If density(theta,...) is a function which calculates
#      the density of the model at the parameter values theta,
#      and loglike(theta,...) is a function which calculates
#      the log-likelihood of the model at the parameter values
#      theta, then the expected log-likehood at theta.ho over
#      theta.ha is density(theta.ha)*loglike(theta.ho) integrated
#      over the appropriate space.
#
# concri --
#      Convergence criterion used to minimize the expected
#      log-likelihood.
#
# Return Values:
# w -- noncentrality parameter for 1 observation.
#
# df -- degrees of freedom of the test.
#
# theta.ho -- estimates of the parameter values under the 
#             null hypothesis.
#----------------------------------------------------------------------
{

   # Define n.param, the number of parameters.
   if (is.matrix(theta.ha)) theta.ha <- as.vector(t(theta.ha))
   n.param <- length(theta.ha)

   # Check to see that theta.lo and theta.hi are the same
   # length as theta.ha and that theta.hi >= theta.lo
   if (length(theta.lo) != n.param) 
      stop("length of theta.lo must match length of theta.ha")
   if (length(theta.hi) != n.param)
      stop("length of theta.hi must match length of theta.ha")
   if (any(theta.lo > theta.hi)) 
      stop("all value in theta.hi must be >= theta.lo")

   # Check to see that concri is in (0,1)
   if ((concri <= 0) | (concri >= 1))
      stop("concri must be in range (0,1)")

   # Check the constraints
   constraints <- fix.constraints(constraints,length(theta.ha))

   # Define a vector theta' = A*theta such that theta' = (phi,lambda).
   # Phi are the parameters set to phi.not by the null hypothesis.
   # Lambda are the unconstrained parameters. Define B = A^(-1)
   # so that theta = B*theta'.
   
   Aans <- construct.a(constraints,length(theta.ha))
   A <- Aans$a
   B <- solve(A)
   constraints <- Aans$constraints
   phi.ho <- Aans$phi.ho          # Value of constrained parameters
   n.ho <- dim(constraints)[1]    # Number of constrained parameters
   n.ha <- n.param - n.ho         # Number of unconstrained parameters
   
   # Calcualte the expected value of l(theta.ha) over theta.ha,
   # E[l(theta.ha)], by integrating f(theta.ha)*l(theta,ha) over 
   # the appropriate space.

   ell.ha <- expect.loglike(theta.ha,theta.ha)

   # Calculate lambda.ho, the value of lambda under the null
   # hypothesis. This is defined as the value of lambda that
   # maximizes E[l(phi.ho,lambda)] over theta.ha.

   if (n.ha > 0) {
      ans <- max.expect.loglike(expect.loglike,
                               theta.ha,theta.lo,theta.hi,phi.ho,
                               A,B,
                               n.param,n.ha,n.ho,
                               concri)
      ierr <- ans$ierr
      if (ierr > 8) stop("Calculation of maximum log-likelihood failed.")
      theta.ho <- ans$theta.ho
   } else {
      theta.ho <- B%*%phi.ho
   }

   # Calculate the expected value of l(theta.ho) over theta.ha, 
   # E[l(theta.ho)], by integrating f(theta.ha)*l(theta.ho) over the 
   # appropriate space.

   ell.ho <- expect.loglike(theta.ha,theta.ho)

   # Return w, the noncentraility parameter estimate,
   # theta.ho, the estimate of the parameters under the null hypothesis
   # and df, the degress of freedom

   w <- 2*(ell.ha-ell.ho)
   df <- n.ho
   theta.ho <- as.vector(theta.ho)
   return(w,df,theta.ho)
}
noncent.multinomial.kgp <- function(p.ha,constraints,group.size=1)
#----------------------------------------------------------------------
# Name: noncent.multinomial.kgp
#
# Description:
#      Calculates the estimated non-centraility parameter for 
# a single observation for single or multiple group multinomial 
# distribution using the SMO method.
#
# Arguments:
# p.ha --
#      For a single group with n categories p.ha is a vector
#      where p.ha[i] is the probability an event occured in 
#      category i. The dimension of p in this case is (n-1)
#      since p.ha[n] would automatically be the sum of p.ha[i]
#      for i=1,...,n-1. For k groups p.ha is a [k x (n-1)] 
#      matrix with each row containing the category probabilities
#      for a group.
#
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#
#      Clarification: The index of the parameter can be found
#      by counting 1,2,...,n-1 for the first group. (n-1)+1,
#      (n-1)+2,...,(n-1)+(n-1) for the second group and so on.
#      This does not allow direct manipulation of the final
#      category probability.
#  
# group.size --
#      The relative number of observations in each group.
#
# Return Values:
# w -- noncentrality parameter for 1 observation.
#
# df -- degrees of freedom of the test.
#
# p.ho -- estimates of the parameter values under the 
#         null hypothesis.
#----------------------------------------------------------------------
{
   # Fix p.ha to be a matrix.
   if (is.vector(p.ha)) p.ha <- t(as.matrix(p.ha))
   ngroups <- dim(p.ha)[1]

   # Check to see that all p.ha are in the range (0,1)
   if (any(p.ha <= 0.0 | p.ha >= 1.0)) 
      stop("all p.ha must be in range (0,1)")

   # Define ncat, the number of categories
   ncatm1 <- ncol(p.ha)
   ncat <- ncatm1 + 1
   
   # Check to see that the sum of p.ha is less than 1
   if (ngroups == 1) 
      p.ha <- cbind(p.ha,1.0-sum(p.ha[,1:ncatm1]))
   else
      p.ha <- cbind(p.ha,(rep(1,ngroups)-apply(p.ha[,1:ncatm1],1,sum)))
   if (any(p.ha[,ncat] <= 0))
      stop("each row of p.ha must sum to less than 1.0")

   # check group.size
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(1,ngroups)
     else if (ngroups != lngrpsz)
       stop ("number of rows in p.ha and group.size must match")

   # check the constraints
   nparam <- ncatm1*ngroups
   constraints <- fix.constraints(constraints,nparam)

   # Determine p.ho, the probability that an event occurs
   # in category i under the null hypothesis.
   # There are 3 cases:
   # Case 1: No constraint
   # If p[i] is not constrainted then p.ho[i] = p.ha[i]
   # Case 2: Constrained to a value
   # If p[i] is set to a value by the null hypothesis then
   # p.ho[i] is that value and p.ho[i] = p[i] - p.ha[i].
   # Case 3: Equality constraints
   # If 2 or more probabilties are set equal to each other then
   # the null hypothesis is the mean of those probabilities
   # weighted by the number of observations in each group.

   p.ha.vec <- as.vector(t(p.ha[,1:ncatm1]))
   group.size.vec <- as.vector(matrix(group.size,ncol=ngroups,nrow=ncatm1,byrow=T))
   p.ho.vec <- p.ha.vec
   p.ho.equal <- rep(0,length(p.ho.vec))
   ind.equal <- 0
   n.ho <- nrow(constraints)
   for (i in 1:n.ho) {
      if (constraints[i,1] == 1) {
         p.ho.vec[constraints[i,2]] <- constraints[i,3]
      } else {
         if (p.ho.equal[constraints[i,2]] == 0) {
            ind.equal <- ind.equal + 1
            p.ho.equal[constraints[i,2]] <- ind.equal
            p.ho.equal[constraints[i,3]] <- ind.equal
         } else {
            p.ho.equal[constraints[i,3]] <- p.ho.equal[constraints[i,2]]
         }
      }
   }

   if (ind.equal > 0) {
      for (i in 1:ind.equal) {
         ind <- (p.ho.equal == i)
         p.cur <- sum(group.size.vec[ind]*p.ha.vec[ind])/
                                                sum(group.size.vec[ind])
         p.ho.vec[ind] <- p.cur
      }
   }
   p.ho <- cbind(matrix(p.ho.vec,nrow=ngroups,ncol=ncatm1,byrow=T),
                 rep(NA,ngroups))
   if (ngroups == 1) {
      p.ho[,ncat] <- rep(1,ngroups) - sum(p.ho[,1:ncatm1])
   } else {
      p.ho[,ncat] <- rep(1,ngroups) - apply(p.ho[,1:ncatm1],1,sum)
   }

   # Check to see that all p.ho are in the range (0,1)
   if (any(p.ho <= 0.0 | p.ho >= 1.0)) 
      stop("bad constraint. all p.ho must be in range (0,1) and category probabilies in the null hypothesis must sum to less than 1.0")

   # The density of the multinomial distribution for 1 group is
   #     f(p,i) = p[i] ; i is the category the event occurs in
   # NOTE: p[ncat] = 1 - p[i] i=1,...,(ncat-1). p.ha[ncat] and p.ho[ncat[
   # were defined above.
   # The log likelihood for 1 group is
   #     l(p,i) = log(p[i])
   # The expected value of the log-likelihood of p.ha over p.ho
   # for 1 group is given by:
   #     sum(i=1,...,ncat) f(p.ha,i)*l(p.ho,i) =
   #     sum(i=1,...,ncat) p.ha[i]*log(p.ho[i])
   # The expected value of the log-likelihood of p.ha over p.ho
   # for all the groups is the weighted sum of the expected value
   # for each group.

   # Calculate the expected value of the log-likelihood at p.ha
   # over p.ha.
   ell.ha <- sum(group.size*apply(p.ha*log(p.ha),1,sum))/sum(group.size)

   # Calcualte the expected value of the log-lieklihood at p.ho
   # over p.ha.
   ell.ho <- sum(group.size*apply(p.ha*log(p.ho),1,sum))/sum(group.size)

   # Return w, the noncentraility parameter estimate,
   # p.ho, the estimate of the parameters under the null hypothesis
   # and df, the degress of freedom

   w <- 2*(ell.ha-ell.ho)
   df <- n.ho
   p.ho <- p.ho[,1:ncatm1]
   return(w,df,p.ho)
}
noncent.mvlogistic <- function(coef.ha, constraints, design, rss=1)
#-----------------------------------------------------------------------
# Name: noncent.mvlogistic
#
# Description:
#      Calculates the estimated non-centraility parameter using
# the SMO method for a single observation for a multivariate
# logistic model where the parameter p, probability of an event,
# depends on the covariates, x = c(x[1], x[2], ..., x[n]), 
# through a logistic, p = exp(u)/(1+exp(u)), model. The variable
# u is a linear combination of the covariates via a set of
# coefficients, coef = c(coef[1], coef[2], ..., coef[n]),
# u = Sum (coef[i] * x[i]) i = 1, ... ,n.
#
# The usual use of this routine is for tabulated data in which case the
# x's will all be 0 or 1 valued indicator variables.
#
# Arguments:
# coef.ha --
#     Vector of length p (number of covariates) giving coefficients
#     of variables.
#
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#
# design --
#     Matrix of length n X p each row of which gives values of
#     covariates at one of the n design points
#     Note: Most models will include a constant term and the column of
#     design corresponding to this term will be identically 1.
#
# rss --
#     The relative sample size at each design point.  If changed
#     from its default value should be a vector of length n.
#-----------------------------------------------------------------------
{
   p <- length( coef.ha )

   # Check constraints
   constraints <- fix.constraints(constraints,p)

   # Check design matrix
   if (is.vector(design)) {
      design <- matrix(design,nrow=1)
   }
   ddim <- dim( design )
   if ( ddim[2] != p ) 
      stop('number of columns in design must match length of coef.ha')
   n <- ddim[1]

   # Check rss
   lrss <- length(rss)
   if ( lrss == 1 ) {
      wt <- rep(1,n)
      tot <- n
   } else if ( lrss == n ) {
      wt <- rss
      tot <- sum(rss)
   } else stop('length of rss must match number of columns of design')

   # Define a function which calculates the expected value of the
   # log-likelihood at a point coef.ho over the true value coef.ha.
   # For 1 group and 1 design point x=design[i,]:
   # Let u = sum(i=1,...,p) coef[i]*x[i]
   # Let p = exp(u)/(1+exp(u))      
   # The density is:
   #     d(p) = p                   (if the event occurs)
   #            1-p                 (if the event does not occur)
   # The log-likelihood is:
   #     l(p) = log(p)              (if the event occurs)
   #            log(1-p)            (if the event does not occur)
   # The expected value of the log-likelihood of p.ha over p.ho
   # is given by:
   #      p.ha*log(p.ho) + (1-p.ha)*log(1-p.ho)
   # For each design point we average the values above, weighted by rss.

   assign("n",n,frame=1)
   assign("design",design,frame=1)
   assign("wt",wt,frame=1)
   assign("tot",tot,frame=1)
   toremove.list <- c(
                      "n", "design", "wt", "tot"
                      )

   expect.loglike <- function(coef.ha,coef.ho) {
      ell <- 0
      for (i in 1:n) {
         x <- design[i,]
         u.ha <- sum(coef.ha*x)
         u.ho <- sum(coef.ho*x)
         p.ha <- 1/(1+exp(-u.ha))
         p.ho <- 1/(1+exp(-u.ho))
         ell.one <- p.ha*log(p.ho) + (1-p.ha)*log(1-p.ho)
         ell <- ell + wt[i]*ell.one
      }
      ell <- ell/tot
      return(ell)
   }

   # Calculate the expected value of the log-likelihood at coef.ha
   # over coef.ha.
   ell.ha <- expect.loglike(coef.ha,coef.ha)
   if (is.na(ell.ha))
      stop("coef.ha and design are such that some probability in the alternative hypothesis is equal to 0 or 1")

   # Define a vector coef' = A*coef such that coef' = (phi,lambda).
   # Phi are the parameters set to phi.not by the null hypothesis.
   # Lambda are the unconstrained parameters. Define B = A^(-1)
   # so that coef = B*coef'.

   Aans <- construct.a(constraints,p)
   A <- Aans$a
   B <- solve(A)
   constraints <- Aans$constraints
   phi.ho <- Aans$phi.ho          # Value of constrained parameters
   n.ho <- dim(constraints)[1]    # Number of constrained parameters
   n.ha <- p - n.ho         # Number of unconstrained parameters

   # Calculate coef.ho, the value of coef under the null
   # hypothesis. This is defined as the value of coef that
   # maximizes E[l(phi.ho,lambda)] over coef.ha.

   if (n.ha > 0) {
      coef.lo <- rep(-1e5,p)
      coef.hi <- rep(1e5,p)
      ans <- max.expect.loglike(expect.loglike,
                               coef.ha,coef.lo,coef.hi,phi.ho,
                               A,B,
                               p,n.ha,n.ho,
                               1.0e-6)
      ierr <- ans$ierr
      if (ierr > 8) stop("Calculation of maximum log-likelihood failed.")
      coef.ho <- ans$theta.ho
   } else {
      coef.ho <- B%*%phi.ho
   }

   # Calculate the expected value of the log-likelihood at coef.ho
   # over coef.ha.

   ell.ho <- expect.loglike(coef.ha,coef.ho)
   if (is.na(ell.ho))
      stop("constraints and design are such that some probability in the null hypothesis is equal to 0 or 1")

   # Return w, the noncentraility parameter estimate,
   # coef.ho, the estimate of the parameters under the null
   # hypothesis and df, the degress of freedom

   w <- 2*(ell.ha-ell.ho)
   df <- n.ho
   coef.ho <- as.vector(coef.ho)

   remove( toremove.list, frame=1 )

   return(w,df,coef.ho)
}
noncent.mvloglin <- function(coef.ha, constraints, design, rss=1)
#-----------------------------------------------------------------------
# Name: noncent.mvloglin
#
# Description:
#      Calculates the estimated non-centraility parameter using
# the SMO method for a single observation for a multivariate
# log-linear model where the parameter p, probability of an event,
# depends on the covariates, x = c(x[1], x[2], ..., x[n]), 
# through an exponential, p = exp(u), model. The variable
# u is a combination of the covariates via a set of
# coefficients, coef = c(coef[1], coef[2], ..., coef[n]),
# u = Sum ( log( coef[i] ) * x[i]) i = 1, ... ,n.
#
# The usual use of this routine is for tabulated data in which case the
# x's will all be 0 or 1 valued indicator variables.
#
# Arguments:
# coef.ha --
#     Vector of length p (number of covariates) giving coefficients
#     of variables. Must be greater than 0.
#
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#
# design --
#     Matrix of length n X p each row of which gives values of
#     covariates at one of the n design points
#     Note: Most models will include a constant term and the column of
#     design corresponding to this term will be identically 1.
#
# rss --
#     The relative sample size at each design point.  If changed
#     from its default value should be a vector of length n.
#-----------------------------------------------------------------------
{
   # Check coef.ha
   p <- length( coef.ha )
   if (any(coef.ha <= 0.0)) stop("coef.ha must be greater than 0")

   # Check constraints
   constraints <- fix.constraints(constraints,p)

   # Check design matrix
   if (is.vector(design)) {
      design <- matrix(design,nrow=1)
   }
   ddim <- dim( design )
   if ( ddim[2] != p ) 
      stop('number of columns in design must match length of coef.ha')
   n <- ddim[1]

   # Check rss
   lrss <- length(rss)
   if ( lrss == 1 ) {
      wt <- rep(1,n)
      tot <- n
   } else if ( lrss == n ) {
      wt <- rss
      tot <- sum(rss)
   } else stop('length of rss must match number of columns of design')

   # Define a function which calculates the expected value of the
   # log-likelihood at a point coef.ho over the true value coef.ha.
   # For 1 group and 1 design point x=design[i,]:
   # Let u = sum(i=1,...,p) log(coef[i])*x[i]
   # Let p = exp(u)
   # The density is:
   #     d(p) = p                   (if the event occurs)
   #            1-p                 (if the event does not occur)
   # The log-likelihood is:
   #     l(p) = log(p)              (if the event occurs)
   #            log(1-p)            (if the event does not occur)
   # The expected value of the log-likelihood of p.ha over p.ho
   # is given by:
   #      p.ha*log(p.ho) + (1-p.ha)*log(1-p.ho)
   # For each design point we average the values above, weighted by rss.

   assign("n",n,frame=1)
   assign("design",design,frame=1)
   assign("wt",wt,frame=1)
   assign("tot",tot,frame=1)
   toremove.list <- c(
                      "n", "design", "wt", "tot"
                      )


   expect.loglike <- function(coef.ha,coef.ho) {
      ell <- 0
      for (i in 1:n) {
         x <- design[i,]
         u.ha <- sum(log(coef.ha)*x)
         u.ho <- sum(log(coef.ho)*x)
         p.ha <- exp(u.ha)
         p.ho <- exp(u.ho)
         ell.one <- p.ha*log(p.ho) + (1-p.ha)*log(1-p.ho)
         ell <- ell + wt[i]*ell.one
      }
      ell <- ell/tot
      return(ell)
   }

   # Calculate the expected value of the log-likelihood at coef.ha
   # over coef.ha.
   ell.ha <- expect.loglike(coef.ha,coef.ha)
   if (is.na(ell.ha))
      stop("coef.ha and design are such that some probability in the alternative hypothesis is equal to 0 or 1")

   # Define a vector coef' = A*coef such that coef' = (phi,lambda).
   # Phi are the parameters set to phi.not by the null hypothesis.
   # Lambda are the unconstrained parameters. Define B = A^(-1)
   # so that coef = B*coef'.

   Aans <- construct.a(constraints,p)
   A <- Aans$a
   B <- solve(A)
   constraints <- Aans$constraints
   phi.ho <- Aans$phi.ho          # Value of constrained parameters
   n.ho <- dim(constraints)[1]    # Number of constrained parameters
   n.ha <- p - n.ho         # Number of unconstrained parameters

   # Calculate coef.ho, the value of coef under the null
   # hypothesis. This is defined as the value of coef that
   # maximizes E[l(phi.ho,lambda)] over coef.ha.

   if (n.ha > 0) {
      coef.lo <- rep(0,p)
      coef.hi <- rep(1e5,p)
      ans <- max.expect.loglike(expect.loglike,
                               coef.ha,coef.lo,coef.hi,phi.ho,
                               A,B,
                               p,n.ha,n.ho,
                               1.0e-6)
      ierr <- ans$ierr
      if (ierr > 8) stop("calculation of maximum log-likelihood failed.")
      coef.ho <- ans$theta.ho
   } else {
      coef.ho <- B%*%phi.ho
   }

   # Calculate the expected value of the log-likelihood at coef.ho
   # over coef.ha.

   ell.ho <- expect.loglike(coef.ha,coef.ho)
   if (is.na(ell.ho))
      stop("constraints and design are such that some probability in the null hypothesis is equal to 0 or 1")

   # Return w, the noncentraility parameter estimate,
   # coef.ho, the estimate of the parameters under the null
   # hypothesis and df, the degress of freedom

   w <- 2*(ell.ha-ell.ho)
   df <- n.ho
   coef.ho <- as.vector(coef.ho)

   remove( toremove.list, frame=1 )

   return(w,df,coef.ho)
}
noncent.ordinal.design <- function(theta.ha, constraints, xpoints, 
        model="linear",link="logistic", natx=1, group.size=1)
#-----------------------------------------------------------------------
# Name: noncent.ordinal.design
#
# Description:
#      Calculates the estimated non-centraility parameter using
# the SMO method for a single observation for a ordinal design 
# where the category probabilities p[i], i=1,...,(ncat-1)
# depend on the covariate, x, through a logistic, 
# p[i] = exp(u[i])/(1+exp(u)[i]), or complementary log, 
# p[i] = 1 - exp(-exp(u[i])), model. The variable u[i]
# is either a linear, u[i] = a[i] + b*x, or quadratic, 
# u[i] = a[i] + b*x + c*x^2, function of the covariate x and
# the parameters a[i] i=1,...,(ncat-1), b and c.
#
# Arguments:
# theta.ha --
#     Matrix of parameters of the linear part of the model.
#     Each row represents a group. If model is "linear" then
#     theta.ha has columns (a[1],...,a[ncat-1],b). Ncat is
#     the number of categories in the model. If model is 
#     "quadratic" then theta.ha has columns (a[1],...,a[ncat-1],b,c).
#
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#
#     Clarification: The parameters of the "quadatic" model are
#     (a[1],...,a[ncat-1],b,c) for group 1, then (a[1],...,a[ncat-1],b,c) 
#     for group2 and so on. The index for parameter b in group 2 would be 
#     ncat+2+ncat+1. Likewise, for the "linear" model the parameters are 
#     (a[1],...,a[ncat-1],b) for group 1, then (a[1],...,a[ncat-1],b) 
#     for group 2  and so on. The index for parameter b in group 2 would be 
#     ncat+1+ncat+1.
#
# xpoints --
#     Matrix of covariate values for each group.
#     Each row represents a group.
#
# model --
#     One of {"linear", "quadratic"} Only enough to ensure a unique
#     match need be supplied. If model is "linear" then u[i] = a[i] + b*x;
#     if model is "quadratic" then u[i] = a[i] + b*x + c*x^2.
#
# link --
#     One of {"logistic", "complementary log"} Only enough to ensure
#     a unique match need be supplied. If link is "logistic" then
#     p[i] = exp(u[i])/(1+exp(u[i])); if link is "complementary log" then
#     p[i] = 1-exp(-exp(u[i])).
#
# natx --
#     Matrix of number of observations at each covariate value in
#     each group. Columns represent covariate values; rows represent
#     groups. At covariate value xpoint[i,j] there are natx[i,j] 
#     observations. If the number of observations at each covariate
#     value is the same for each group; natx can be a vector.
#     If the number of observations is the same for each covariate
#     value in each group; natx can be a scalar.
#
# group.size --
#     The relative number of observations in each group.
#-----------------------------------------------------------------------
{
   # model = 1 for "linear" model; 2 for "quadratic" model; otherwise error.
   model <- pmatch(model,c("linear","quadratic"))
   if (is.na(model)) stop("model must be one of {'linear','quadratic'}")

   # link = 1 for "logistic"; 2 for "complementary log"; otherwise error.
   link <- pmatch(link,c("logistic","complementary log"))
   if (is.na(link))
      stop("link must be one of {'logistic','complementary log'}")

   # Check theta.ha
   if (is.vector(theta.ha)) theta.ha <- t(as.matrix(theta.ha))
   dimt <- dim(theta.ha)
   ngroups <- dimt[1]
   ltheta <- dimt[2]
   if (model == 1) {
      ncatm1 <- ltheta-1
      if (ltheta < 2)
         stop("number of columns in theta must be at least 2")
   } else {
      ncatm1 <- ltheta-2
      if (ltheta < 3)
         stop("number of columns in theta must be at least 3")
   }
   ncat <- ncatm1+1

   # Check constraints
   n.params <- ltheta*ngroups
   constraints <- fix.constraints(constraints,n.params)

   # Check xpoints
   if (is.vector(xpoints)) {
      xpoints <- matrix(xpoints,ngroups,length(xpoints),byrow=T)
      dimp <- dim(xpoints)
   } else {
      dimp <- dim(xpoints)
      if (dimp[1] != ngroups)
      stop("number of rows of xpoints and theta.ha must match")
   }
   npoints <- dimp[2]

   # Check natx
   if (is.vector(natx)) {
      if (length(natx) == 1)
         natx <- matrix(natx,ngroups,dimp[2],byrow=T)
      else {
         if (length(natx) != dimp[2] )
            stop ("length of natx must match number of xpoints")
          natx <- matrix(natx,ngroups,dimp[2],byrow=T)
      }
      dimn <- dim(natx)
   } else {
      dimn <- dim(natx)
      if (dimn[1] != dimp[1] || dimn[2] != dimp[2])
         stop("xpoints and natx must have the same dimensions")
   }

   # Check group.size
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(group.size,ngroups)
   else if (ngroups != lngrpsz)
      stop("number of rows of theta.ha and length of group.size must match")

   # Define a function which calculates the expected value of the
   # log-likelihood at a point theta.ho over the true value theta.ha.
   # For 1 group and 1 design point x:
   # For i = 1,...,ncat-1
   # Let u[i] = a[i] + b*x                (if model is "linear")
   #          = a[i] + b*x + c*x^2        (if model is "quadratic")
   # Let p[i] = exp(u[i])/(1+exp(u[i]))   (if link is "logistic")
   #           = 1-exp(-exp(u[i]))        (if link is "complementary log")
   # The density is:
   #     d(p,i) = prob[i]                 (event occured in category i)
   #     prob[i] = p[i]                   (i = 1)
   #             = p[i]-p[i-1]            (i = 2,...,ncat-1)
   #             = 1-p[i]                 (i = ncat)
   # The log-likelihood is:
   #     l(p,i) = log(prob[i])            (event occured in category i)
   # The expected value of the log-likelihood of p.ha over p.ho
   # is given by:
   #      sum(i=1,...,ncat) d(p.ha,i)*l(p.ho,i)
   # For all the design points in each group we average the above
   # values with the weights defined in natx and group.size.

   scale.x <- group.size*natx
   n.x <-  sum(scale.x)
   if (model == 1) xpoints2 <- matrix(0,nrow=ngroups,ncol=npoints)
   else xpoints2 <- xpoints^2
   assign("ncatm1",ncatm1,frame=1)
   assign("ncat",ncat,frame=1)
   assign("model",model,frame=1)
   assign("link",link,frame=1)
   assign("npoints",npoints,frame=1)
   assign("ngroups",ngroups,frame=1)
   assign("xpoints",xpoints,frame=1)
   assign("xpoints2",xpoints2,frame=1)
   assign("scale.x",scale.x,frame=1)
   assign("n.x",n.x,frame=1)
   
   toremove.list <- c(
                      "ncatm1", "ncat", "model", "link",
                      "npoints", "ngroups", "xpoints",
                      "xpoints2", "scale.x", "n.x"
                      )

   expect.loglike <- function(theta.ha.vec,theta.ho.vec) {
      theta.ha <- matrix(theta.ha.vec,nrow=ngroups,byrow=T)
      theta.ho <- matrix(theta.ho.vec,nrow=ngroups,byrow=T)
      ell <- 0
      for (i in 1:ngroups) {
         a.ha <- theta.ha[i,1:ncatm1]
         a.ho <- theta.ho[i,1:ncatm1]
         b.ha <- theta.ha[i,ncat]
         b.ho <- theta.ho[i,ncat]
         if (model == 2) {
            c.ha <- theta.ha[i,ncat+1]
            c.ho <- theta.ho[i,ncat+1]
         }
         for (j in 1:npoints) {
            x <- xpoints[i,j]
            x2 <- xpoints2[i,j]
            if (model == 1) {
               u.ha <- a.ha + b.ha*x
               u.ho <- a.ho + b.ho*x
            } else {
               u.ha <- a.ha + b.ha*x + c.ha*x2
               u.ho <- a.ho + b.ho*x + c.ho*x2
            }
            if (link == 1) {
               p.ha <- 1/(1+exp(-u.ha))
               p.ho <- 1/(1+exp(-u.ho))
            } else {
               p.ha <- 1-exp(-exp(u.ha))
               p.ho <- 1-exp(-exp(u.ho))
            }
            prob.ha <- c(p.ha,1)-c(0,p.ha)
            prob.ho <- c(p.ho,1)-c(0,p.ho)
            if (any(prob.ha <= 0.0 | any(prob.ha >= 1.0))) return(NA)
            if (any(prob.ho <= 0.0 | any(prob.ho >= 1.0))) return(NA)
            ell.one <- sum(prob.ha*log(prob.ho))
            ell <- ell + scale.x[i,j]*ell.one
         }
      }
      ell <- ell/n.x
      return(ell)
   }

   # Convert theta.ha to a vector for the generic part of this routine.
   theta.ha <- as.vector(t(theta.ha))

   # Calculate the expected value of the log-likelihood at theta.ha
   # over theta.ha.
   ell.ha <- expect.loglike(theta.ha,theta.ha)
   if (is.na(ell.ha))
      stop("theta.ha, model, link and xpoints are such that some probability in the alternative hypothesis is equal to 0 or 1")

   # Define a vector theta' = A*theta such that theta' = (phi,lambda).
   # Phi are the parameters set to phi.not by the null hypothesis.
   # Lambda are the unconstrained parameters. Define B = A^(-1)
   # so that theta = B*theta'.

   Aans <- construct.a(constraints,n.params)
   A <- Aans$a
   B <- solve(A)
   constraints <- Aans$constraints
   phi.ho <- Aans$phi.ho          # Value of constrained parameters
   n.ho <- dim(constraints)[1]    # Number of constrained parameters
   n.ha <- n.params - n.ho         # Number of unconstrained parameters

   # Calculate theta.ho, the value of theta under the null
   # hypothesis. This is defined as the value of theta that
   # maximizes E[l(phi.ho,lambda)] over theta.ha.

   if (n.ha > 0) {
      theta.lo <- rep(-1e5,n.params)
      theta.hi <- rep(1e5,n.params)
      ans <- max.expect.loglike(expect.loglike,
                               theta.ha,theta.lo,theta.hi,phi.ho,
                               A,B,
                               n.params,n.ha,n.ho,
                               1.0e-6)
      ierr <- ans$ierr
      if (ierr > 8)
         stop("calculation of maximum log-likelihood failed.")
      theta.ho <- ans$theta.ho
   } else {
      theta.ho <- B%*%phi.ho
   }

   # Calculate the expected value of the log-likelihood at theta.ho
   # over theta.ha.
   ell.ho <- expect.loglike(theta.ha,theta.ho)
   if (is.na(ell.ho))
      stop("constraints, model, link and xpoints are such that some probability in the null hypothesis is equal to 0 or 1")

   # Return w, the noncentraility parameter estimate,
   # theta.ho, the estimate of the parameters under the null
   # hypothesis and df, the degress of freedom

   w <- 2*(ell.ha-ell.ho)
   df <- n.ho
   theta.ho <- matrix(theta.ho,nrow=ngroups,byrow=T)

   remove( toremove.list, frame=1 )

   return(w,df,theta.ho)
}
noncent.ordinal.kgp <- function(p.ha,constraints,group.size=1)
#----------------------------------------------------------------------
# Name: noncent.ordinal.kgp
#
# Description:
#      Calculates the estimated noncentraility parameter for 
# a single observation for single or multiple group ordinal 
# distribution using the SMO method.
#
# Arguments:
# p.ha --
#      For a single group with n categories p.ha is a vector
#      where p.ha[i] is the probability an event occured in 
#      category i or less. The dimension of p in this case is (n-1)
#      since p.ha[n] would automatically be 1. For k groups p.ha
#      is a [k x (n-1)] matrix with each row containing the category
#      probabilities for a group.
#
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#
#      Clarification: The index of the parameter can be found
#      by counting 1,2,...,n-1 for the first group. (n-1)+1,
#      (n-1)+2,...,(n-1)+(n-1) for the second group and so on.
#      This does not allow direct manipulation of the final
#      category probability.
#      
#      Note: In the ordinal model two category probabilities
#      in the same group can not be set equal to each other.
#      See "noncent.multinomial.kgp" if this is required.
#
# group.size --
#      The relative number of observations in each group.
#
# Return Values:
# w -- noncentrality parameter for 1 observation.
#
# df -- degrees of freedom of the test.
#
# p.ho -- estimates of the parameter values under the 
#         null hypothesis.
#----------------------------------------------------------------------
{
   # Fix p.ha to be a matrix.
   if (is.vector(p.ha)) p.ha <- t(as.matrix(p.ha))
   ngroups <- dim(p.ha)[1]

   # Check to see that all p.ha are in the range (0,1)
   if (any(p.ha <= 0.0 | p.ha >= 1.0)) 
      stop("all p.ha must be in range (0,1)")

   # Define ncat, the number of categories
   ncatm1 <- ncol(p.ha)
   ncat <- ncatm1 + 1
   
   # Define prob.ha, the category probabilities, such that
   # prob.ha[i] = the probability an event occurs in category i
   prob.ha <- cbind(p.ha,rep(1,ngroups))-cbind(rep(0,ngroups),p.ha)

   # Check to see that category probabilities are in (0,1);
   # if not p.ha was not a strictly increasing vector.
   if (any(prob.ha <= 0.0 | prob.ha >= 1.0))
      stop("each row of p.ha must be strictly increasing")

   # check group.size
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(1,ngroups)
     else if (ngroups != lngrpsz)
       stop ("number of rows in p.ha and group.size must match")

   # check the constraints
   nparam <- ncatm1*ngroups
   constraints <- fix.constraints(constraints,nparam)


   # Determine p.ho, the probability that an event occurs
   # in category i or less under the null hypothesis.
   # There are 3 cases:
   # Case 1: No constraint
   # If p[i] is not constrainted then p.ho[i] = p.ha[i]
   # Case 2: Constrained to a value
   # If p[i] is set to a value by the null hypothesis then
   # p.ho[i] is that value.
   # Case 3: Equality constraints
   # If 2 or more probabilties are set equal to each other then
   # the null hypothesis is the mean of those probabilities
   # weighted by the number of observations in each group.
   # NOTE: Probabilities in the same group can not be set
   # equal.

   p.ha.vec <- as.vector(t(p.ha))
   group.size.vec <- as.vector(matrix(group.size,ncol=ngroups,nrow=ncatm1,byrow=T))
   p.ho.vec <- p.ha.vec
   p.ho.equal <- rep(0,length(p.ho.vec))
   ind.equal <- 0
   n.ho <- nrow(constraints)
   for (i in 1:n.ho) {
      if (constraints[i,1] == 1) {
         p.ho.vec[constraints[i,2]] <- constraints[i,3]
      } else {
         if (p.ho.equal[constraints[i,2]] == 0) {
            ind.equal <- ind.equal + 1
            p.ho.equal[constraints[i,2]] <- ind.equal
            p.ho.equal[constraints[i,3]] <- ind.equal
         } else {
            p.ho.equal[constraints[i,3]] <- p.ho.equal[constraints[i,2]]
         }
      }
   }

   if (ind.equal > 0) {
      for (i in 1:ind.equal) {
         ind <- (p.ho.equal == i)
         p.cur <- sum(group.size.vec[ind]*p.ha.vec[ind])/
                                        sum(group.size.vec[ind])
         p.ho.vec[ind] <- p.cur
      }
   }
   p.ho <- matrix(p.ho.vec,ncol=ncatm1,nrow=ngroups,byrow=T)

   # Check to see that the user did not set probabilities equal in
   # the same group.
   p.ho.equal <- matrix(p.ho.equal,ncol=ncatm1,nrow=ngroups,byrow=T)
   if (any(apply(p.ho.equal,1,duplicated)))
      stop("bad constraint. In the ordinal model two category probabilities in the same group can not be set equal to each other.")

   # Check to see that all p.ho are in the range (0,1)
   if (any(p.ho <= 0.0 | p.ho >= 1.0)) 
      stop("bad constraint. All p.ho must be in range (0,1) and strictly increasing.")

   # Define prob.ho, the category probabilities, such that
   # prob.ho[i] = the probability an event occurs in category i
   # under the null hypothesis.
   prob.ho <- cbind(p.ho,rep(1,ngroups))-cbind(rep(0,ngroups),p.ho)

   # Check to see that category probabilities are in (0,1);
   # if not p.ho was not a strictly increasing vector.
   if (any(prob.ho <= 0.0 | prob.ho >= 1.0))
      stop("bad constraint. All p.ho must be in range (0,1) and strictly increasing.")

   # The density of the multinomial distribution for 1 group is
   #     f(p,i) = prob[i] ; i is the category the event occurs in
   # NOTE: prob[i] = p[i] - p[i-1] i=2,...,(ncat-1)
   #               = p[1]          i=1
   #               = 1 - p[i-1]    i=ncat
   # These probabilities were defined above.
   # The log likelihood for 1 group is
   #     l(p,i) = log(prob[i])
   # The expected value of the log-likelihood of p.ha over p.ho
   # for 1 group is given by:
   #     sum(i=1,...,ncat) f(prob.ha,i)*l(prob.ho,i) =
   #     sum(i=1,...,ncat) prob.ha[i]*log(prob.ho[i])
   # The expected value of the log-likelihood of p.ha over p.ho
   # for all the groups is the weighted sum of the expected value
   # for each group.

   # Calculate the expected value of the log-likelihood at p.ha
   # over p.ha.
   ell.ha <- sum(group.size*apply(prob.ha*log(prob.ha),1,sum))/sum(group.size)

   # Calcualte the expected value of the log-lieklihood at p.ho
   # over p.ha.
   ell.ho <- sum(group.size*apply(prob.ha*log(prob.ho),1,sum))/sum(group.size)

   # Return w, the noncentraility parameter estimate,
   # p.ho, the estimate of the parameters under the null hypothesis
   # and df, the degress of freedom

   w <- 2*(ell.ha-ell.ho)
   df <- n.ho
   return(w,df,p.ho)
}
noncent.poisson.design <- function(theta.ha, constraints, xpoints, 
        model="linear", natx=1, group.size=1)
#-----------------------------------------------------------------------
# Name: noncent.poisson.design
#
# Description:
#      Calculates the estimated non-centraility parameter using
# the SMO method for a single observation for a Poisson design 
# where the parameter lambda, the mean, depends on a covariate,
# x, via the equation lambda=exp(u). The variable u is either a 
# linear, u = a + b*x, or quadratic, u = a + b*x + c*x^2, function 
# of the covariate x.
#
# Arguments:
# theta.ha --
#     Matrix of parameters of the linear part of the model.
#     Each row represents a group. If model is "linear" then
#     theta.ha has two columns, the values of (a,b) for each
#     group. If model is "quadratic" then theta.ha has three
#     columns, the values of (a,b,c) for each group.
#
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#     Clarification: The parameters of the "quadatic" model are
#     (a,b,c) for group 1, then (a,b,c) for group2 and so on. The
#     index for parameter b in group 2 would be 5. Likewise,
#     for the "linear" model the parameters are (a,b) for group 1,
#     then (a,b) for group 2  and so on. The index for parameter
#     b in group 2 would be 4.
#
# xpoints --
#     Matrix of covariate values for each group.
#     Each row represents a group.
#
# model --
#     One of {"linear", "quadratic"} Only enough to ensure a unique
#     match need be supplied. If model is "linear" then u = a + b*x;
#     if model is "quadratic" then u = a + b*x + c*x^2.
#
# natx --
#     Matrix of number of observations at each covariate value in
#     each group. Columns represent covariate values; rows represent
#     groups. At covariate value xpoint[i,j] there are natx[i,j] 
#     observations. If the number of observations at each covariate
#     value is the same for each group; natx can be a vector.
#     If the number of observations is the same for each covariate
#     value in each group; natx can be a scalar.
#
# group.size --
#     The relative number of observations in each group.
#-----------------------------------------------------------------------
{
   # model = 1 for "linear" model; 2 for "quadratic" model; otherwise error.
   model <- pmatch(model,c("linear","quadratic"))
   if (is.na(model)) stop("model must be one of {'linear','quadratic'}")

   # Check theta.ha
   if (is.vector(theta.ha)) theta.ha <- t(as.matrix(theta.ha))
   dimt <- dim(theta.ha)
   ngroups <- dimt[1]
   ltheta <- dimt[2]
   if ((model == 1) & (ltheta != 2))
      stop("for a 'linear' model theta.ha must have 2 columns")
   if ((model == 2) & (ltheta != 3))
      stop("for a 'quadratic' model theta.ha must have 3 columns")

   # Check constraints
   n.params <- ltheta*ngroups
   constraints <- fix.constraints(constraints,n.params)

   # Check xpoints
   if (is.vector(xpoints)) {
      xpoints <- matrix(xpoints,ngroups,length(xpoints),byrow=T)
      dimp <- dim(xpoints)
   } else {
      dimp <- dim(xpoints)
      if (dimp[1] != ngroups)
      stop("number of rows of xpoints and theta.ha must match")
   }
   npoints <- dimp[2]

   # Check natx
   if (is.vector(natx)) {
      if (length(natx) == 1)
         natx <- matrix(natx,ngroups,dimp[2],byrow=T)
      else {
         if (length(natx) != dimp[2] )
            stop ("length of natx must match number of xpoints")
          natx <- matrix(natx,ngroups,dimp[2],byrow=T)
      }
      dimn <- dim(natx)
   } else {
      dimn <- dim(natx)
      if (dimn[1] != dimp[1] || dimn[2] != dimp[2])
         stop("xpoints and natx must have the same dimensions")
   }

   # Check group.size
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(group.size,ngroups)
   else if (ngroups != lngrpsz)
      stop("\nnumber of rows of theta.ha and length of group.size must match")

   # Define a function which calculates the expected value of the
   # log-likelihood at a point theta.ho over the true value theta.ha.
   # For 1 group and 1 design point x:
   # Let u = a + b*x                (if model is "linear")
   #       = a + b*x + c*x^2        (if model is "quadratic")
   #     lambda = exp(u)
   # The expected value of the log-likelihood of lambda.ha over lambda.ho
   # is given by the Poisson density at lambda.ha time the log-likelihood
   # at lambda.ho:
   # ell(lambda.ha,lambda.ho) =
   #    sum(x=0,1,...) d(x;lambda.ha)*l(x;lambda.ho)
   # where:
   # d(x;lambda.ha) = (lambda.ha^x )*exp(-lambda.ha)/(x!)
   # l(x;lambda.ho) = x*log(lambda.ho) - lambda.ho - log(x!)
   # so:
   # ell(lambda.ha,lambda.ho)
   #    = sum(x=0,1,...) [x*log(lambda.ho) - lambda.ho - log(x!)]*
   #                     d(x;lambda.ha)
   #    =  log(lambda.ho)*{sum(x=0,1,...) x*d(x;lambda.ha)}
   #      -lambda.ho*{sum(x=0,1,...) d(x;lambda.ha)}
   #      -{sum(x=0,1,...) log(x!)*d(x;lambda.ha)}
   #
   # NOTE: {sum(x=0,1,...) x*d(x;lambda.ha)} is the expected value of
   #       x over lambda.ha which is the mean, lambda.ha
   # NOTE: {sum(x=0,1,...) d(x;lambda.ha)} is the sum of the density
   #       over the sample space which is 1
   # NOTE: Let C = -{sum(x=0,1,...) log(x!)*d(x;lambda.ha)}
   # so:
   # ell(lambda.ha,lambda.ho)
   #    = log(lambda.ho)*lambda.ha -lambda.ho + C
   # NOTE: We can ignore C in the calculation of ell because it
   # is constant over lambda.ho. It will not affect the calculation
   # of the unconstrained parameters under the null hypothesis
   # and C will cancel when we calculate 
   # w = 2*[ell(lambda.ha,lambda.ha) - (ell(lambda.ha,lambda.ho)].
   # NOTE: lambda.ha is caluclated from (a,b,c) values in the
   # alternative hypothesis; lambda.ho is calculated from (a,b,c) 
   # values in the null hypothesis.
   # For all the design points in each group we average the above
   # values with the weights defined in natx and group.size.

   scale.x <- group.size*natx
   n.x <-  sum(scale.x)
   if (model == 1) xpoints2 <- matrix(0,nrow=ngroups,ncol=npoints)
   else xpoint2 <- xpoints^2
   assign("model",model,frame=1)
   assign("npoints",npoints,frame=1)
   assign("ngroups",ngroups,frame=1)
   assign("xpoints",xpoints,frame=1)
   assign("xpoints2",xpoints2,frame=1)
   assign("scale.x",scale.x,frame=1)
   assign("n.x",n.x,frame=1)
   
   toremove.list <- c(
                      "model", "npoints", "xpoints",
                      "xpoints2", "scale.x", "n.x"
                      )
                      

   expect.loglike <- function(theta.ha.vec,theta.ho.vec) {
      theta.ha <- matrix(theta.ha.vec,nrow=ngroups,byrow=T)
      theta.ho <- matrix(theta.ho.vec,nrow=ngroups,byrow=T)
      ell <- 0
      for (i in 1:ngroups) {
         for (j in 1:npoints) {
            x <- xpoints[i,j]
            x2 <- xpoints2[i,j]
            if (model == 1) {
               u.ha <- sum(theta.ha[i,]*c(1,x))
               u.ho <- sum(theta.ho[i,]*c(1,x))
            } else {
               u.ha <- sum(theta.ha[i,]*c(1,x,x2))
               u.ho <- sum(theta.ho[i,]*c(1,x,x2))
            }
            lambda.ha <- exp(u.ha)
            lambda.ho <- exp(u.ho)
            ell.one <- log(lambda.ho)*lambda.ha -lambda.ho
            ell <- ell + scale.x[i,j]*ell.one
         }
      }
      ell <- ell/n.x
      return(ell)
   }

   # Convert theta.ha to a vector for the generic part of this routine.
   theta.ha <- as.vector(t(theta.ha))

   # Calculate the expected value of the log-likelihood at theta.ha
   # over theta.ha.
   ell.ha <- expect.loglike(theta.ha,theta.ha)
   if (is.na(ell.ha))
      stop("theta.ha, model and xpoints are such that some lambda in the alternative hypothesis is infinite")

   # Define a vector theta' = A*theta such that theta' = (phi,lambda).
   # Phi are the parameters set to phi.not by the null hypothesis.
   # Lambda are the unconstrained parameters. Define B = A^(-1)
   # so that theta = B*theta'.

   Aans <- construct.a(constraints,n.params)
   A <- Aans$a
   B <- solve(A)
   constraints <- Aans$constraints
   phi.ho <- Aans$phi.ho          # Value of constrained parameters
   n.ho <- dim(constraints)[1]    # Number of constrained parameters
   n.ha <- n.params - n.ho         # Number of unconstrained parameters

   # Calculate theta.ho, the value of theta under the null
   # hypothesis. This is defined as the value of theta that
   # maximizes E[l(phi.ho,lambda)] over theta.ha.

   if (n.ha > 0) {
      theta.lo <- rep(-100,n.params)
      theta.hi <- rep(100,n.params)
      ans <- max.expect.loglike(expect.loglike,
                               theta.ha,theta.lo,theta.hi,phi.ho,
                               A,B,
                               n.params,n.ha,n.ho,
                               1.0e-6)
      ierr <- ans$ierr
      if (ierr > 8) stop("Calculation of maximum log-likelihood failed.")
      theta.ho <- ans$theta.ho
   } else {
      theta.ho <- B%*%phi.ho
   }

   # Calculate the expected value of the log-likelihood at theta.ho
   # over theta.ha.
   ell.ho <- expect.loglike(theta.ha,theta.ho)
   if (is.na(ell.ho))
      stop("constraints, model and xpoints are such that some lambda in the null hypothesis is infinite")

   # Return w, the noncentraility parameter estimate,
   # theta.ho, the estimate of the parameters under the null
   # hypothesis and df, the degress of freedom

   w <- 2*(ell.ha-ell.ho)
   df <- n.ho
   theta.ho <- matrix(theta.ho,nrow=ngroups,byrow=T)

   remove( toremove.list, frame=1 )

   return(w,df,theta.ho)
}
noncent.poisson.kgp <- function(lambda.ha,constraints,group.size=1)
#----------------------------------------------------------------------
# Name: noncent.poisson.kgp
#
# Description:
#      Calculates the estimated non-centraility parameter for 
# a single observation for single or multiple group Poisson 
# distribution using the SMO method.
#
# Arguments:
# lambda.ha --
#      Scalar or vector of Poisson means for the groups.  The i'th
#      component is the alternative hypothesis (or true) mean for 
#      the i'th group.
#
# constraints --
#     the constraints which set the null hypothesis from the
#     alternative hypothesis. They are in matrix form.
#          CONSTRAINT[,1] is 1 for setting parameter to a value
#                            2 for equality of two parameters
#          CONSTRAINT[,2] is case on CONSTRAINT[,1]
#               (1) Index of parameter to set to value
#               (2) Index of one of two parameters to be set equal
#          CONSTRAINT[,3] is case on CONSTRAINT[,1]
#               (1) Value to which parameter is set
#               (2) Index of other of two parameters to be set equal
#
# group.size --
#      The relative number of observations in each group.
#
# Return Values:
# w -- noncentrality parameter for 1 observation.
#
# df -- degrees of freedom of the test.
#
# lambda.ho -- estimates of the parameter values under the 
#              null hypothesis.
#----------------------------------------------------------------------
{
   # check to see that lambda.ha is greater than 0
   if (any(lambda.ha <= 0.0)) stop ("lambda.ha must be greater than 0")
   if (any(is.inf(lambda.ha))) 
      stop("Inf not allowed in lambda.ha")

   ngroups <- length(lambda.ha)

   # check group.size
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(1,ngroups)
     else if (ngroups != lngrpsz)
       stop ("lengths of lambda.ha and group.size must match")

   # check the constraints
   constraints <- fix.constraints(constraints,ngroups)

   # Determine lambda.ho, the value of lambda under the null hypothesis.
   # There are 3 cases:
   # Case 1: No constraint
   # If lambda[i] is not constrainted then lambda.ho[i] = lambda.ha[i]
   # Case 2: Constrained to a value
   # If lambda[i] is set to a value by the null hypothesis then
   # lambda.ho[i] is that value.
   # Case 3: Equality constraints
   # If 2 or more lambdas are set equal to each other then
   # the null hypothesis is the mean of those lambdas
   # weighted by the number of observations in each group.
   lambda.ho <- lambda.ha
   lambda.ho.equal <- rep(0,ngroups)
   ind.equal <- 0
   n.ho <- nrow(constraints)
   for (i in 1:n.ho) {
      if (constraints[i,1] == 1) {
         lambda.ho[constraints[i,2]] <- constraints[i,3]
      } else {
         if (lambda.ho.equal[constraints[i,2]] == 0) {
            ind.equal <- ind.equal + 1
            lambda.ho.equal[constraints[i,2]] <- ind.equal
            lambda.ho.equal[constraints[i,3]] <- ind.equal
         } else {
            lambda.ho.equal[constraints[i,3]] <- 
                            lambda.ho.equal[constraints[i,2]]
         }
      }
   }

   if (ind.equal > 0) {
      for (i in 1:ind.equal) {
         ind <- (lambda.ho.equal == i)
         lambda.cur <- sum(group.size[ind]*lambda.ha[ind])/
                                           sum(group.size[ind])
         lambda.ho[ind] <- lambda.cur
      }
   }

   # Be sure that all lambda values in the null hypothesis are
   # in the range (0,+Infinity)
   if (any(lambda.ho <= 0.0))
      stop ("Bad constraint. lambda must be greater than 0")

   # The expected value of the log-likelihood of lambda.ha over lambda.ho
   # is given by the Poisson density at lambda.ha time the log-likelihood
   # at lambda.ho:
   # ell(lambda.ha,lambda.ho) =
   #    sum(x=0,1,...) d(x;lambda.ha)*l(x;lambda.ho)
   # where:
   # d(x;lambda.ha) = (lambda.ha^x )*exp(-lambda.ha)/(x!)
   # l(x;lambda.ho) = x*log(lambda.ho) - lambda.ho - log(x!)
   # so:
   # ell(lambda.ha,lambda.ho)
   #    = sum(x=0,1,...) [x*log(lambda.ho) - lambda.ho - log(x!)]*
   #                     d(x;lambda.ha)
   #    =  log(lambda.ho)*{sum(x=0,1,...) x*d(x;lambda.ha)}
   #      -lambda.ho*{sum(x=0,1,...) d(x;lambda.ha)}
   #      -{sum(x=0,1,...) log(x!)*d(x;lambda.ha)}
   #
   # NOTE: {sum(x=0,1,...) x*d(x;lambda.ha)} is the expected value of
   #       x over lambda.ha which is the mean, lambda.ha
   # NOTE: {sum(x=0,1,...) d(x;lambda.ha)} is the sum of the density
   #       over the sample space which is 1
   # NOTE: Let C = -{sum(x=0,1,...) log(x!)*d(x;lambda.ha)}
   # so:
   # ell(lambda.ha,lambda.ho)
   #    = log(lambda.ho)*lambda.ha -lambda.ho + C

   # Calculate the expected value of the log-likelihood at lambda.ha
   # over lambda.ha minus the expected value of the log-likelihood
   # at lambda.ho over lambda.ho:
   # ell(lambda.ha,lambda.ha) - ell(lambda.ha,lambda.ho)
   #    =  log(lambda.ha)*lambda.ha - lambda.ha + C
   #      -log(lambda.ho)*lambda.ha + lambda.ho - C
   # NOTE: That C cancels in the above equation.

   w <- 2*sum(group.size*(lambda.ha*(log(lambda.ha)-log(lambda.ho)) 
           - lambda.ha + lambda.ho))/(sum(group.size))

   # Return w, the noncentraility parameter estimate,
   # lambda.ho, the estimate of the parameters under the null
   # hypothesis and df, the degress of freedom

   df <- n.ho
   return(w,df,lambda.ho)
}
ordinal.design <- function(method,
                           theta.ha,design="linear",link="logistic",
                           xpoints, natx=1, group.size=1,
                           const.constraint.group,
                           const.constraint.param,
                           const.constraint.value,
                           equal.constraint.group,
                           equal.constraint.param,
                           significance,power,sample.size,
                           smo.df=T)
#----------------------------------------------------------------------
# Name: ordinal.design
#
# Description:
#      Calculates the estimated non-centraility parameter using
# the SMO method for a single observation for a ordinal design 
# where the category probabilities p[i], i=1,...,(ncat-1)
# depend on the covariate, x, through a logistic, 
# p[i] = exp(u[i])/(1+exp(u)[i]), or complementary log, 
# p[i] = 1 - exp(-exp(u[i])), model. The variable u[i]
# is either a linear, u[i] = a[i] + b*x, or quadratic, 
# u[i] = a[i] + b*x + c*x^2, function of the covariate x and
# the parameters a[i] i=1,...,(ncat-1), b and c. Uses the 
# non-centrality parameter to calculate the significance, power or 
# sample size.
#
# Model Parameters:
# "p1","p2",... -- The probability an event occured in category i 
#                  or less.
#                  i=1,...,(ncat-1); ncat is the number of categories
# 
# User Parameters:
# ("a1","a2",...,"b") for linear design and 
# ("a1","a2",...,"b","c") for quadratic design.
# 
# Arguments:
# method --
#      The method used. One of {"lr" or "smo"} for the
#      likelihood ratio or SMO method.
#
# theta.ha --
#      Matrix of parameters of the linear part of the model.
#      Each row represents a group. If model is "linear" then
#      theta.ha has columns (a[1],...,a[ncat-1],b). Ncat is
#      the number of categories in the model. If model is 
#      "quadratic" then theta.ha has columns (a[1],...,a[ncat-1],b,c).
#
# design --
#     One of {"linear", "quadratic"} Only enough to ensure a unique
#     match need be supplied. If model is "linear" then u = a + b*x;
#     if model is "quadratic" then u = a + b*x + c*x^2.
#
# link --
#     One of {"logistic", "complementary log"} Only enough to ensure
#     a unique match need be supplied. If link is "logistic" then
#     p = exp(u)/(1+exp(u)); if link is "complementary log" then
#     p = 1-exp(-exp(u)).
#
# natx --
#     Matrix of number of observations at each covariate value in
#     each group. Columns represent covariate values; rows represent
#     groups. At covariate value xpoint[i,j] there are natx[i,j] 
#     observations. If the number of observations at each covariate
#     value is the same for each group; natx can be a vector.
#     If the number of observations is the same for each covariate
#     value in each group; natx can be a scalar.
#
# group.size --
#      The relative number of observations in each group.
#      If group.size is identically 1 there are equal observations
#      in each group.
#
# const.constraint.group --
#      A vector of the group indicators for each constant constraint.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.group --
#      A vector of the group indicators for each parameter being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#
# smo.df --
#      Only relevent if method is "smo".
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n.
#----------------------------------------------------------------------
{
   #---------------#
   # check method. #
   #---------------#
   imethod <- pmatch(method,c("lr","smo"))
   if (is.na(imethod)) stop("method must be one of 'lr' or 'smo'")

   #--------------------------------#
   # set idesign.                   #
   # 2 for linear" 3 for quadratic. #
   #--------------------------------#
   designs <- c("kgp","linear","quadratic")
   idesign <- pmatch(design,c("linear","quadratic"))
   if (is.na(idesign)) stop("design must be one of {'linear','quadratic'}")
   idesign <- idesign + 1

   #------------------------------------------#
   # set ilink.                               #
   # 1 for logistic; 2 for complementary log. #
   #------------------------------------------#
   links <- c("logistic","complementary log")
   ilink <- pmatch(link,links)
   if (is.na(ilink))
      stop("link must be one of {'logistic','complementary log'}")

   #-----------------#
   # check theta.ha. #
   #-----------------#
   if (is.vector(theta.ha)) theta.ha <- t(as.matrix(theta.ha))
   dimt <- dim(theta.ha)
   ngroup <- dimt[1]
   nparam <- dimt[2]
   if (idesign == 1) {
      if (nparam < 2)
         stop("number of columns in theta must be at least 2")
   } else {
      if (nparam < 3)
         stop("number of columns in theta must be at least 3")
   }
   if (ilink == 1) ncat <- nparam-1
   else ncat <- nparam-2
   a <- theta.ha[,1:ncat]
   if (is.vector(a)) a <- matrix(a,nrow=1)
   abig <- a[,2:ncat]
   asmall <- a[,1:(ncat-1)]
   if (any(asmall >= abig))
      stop("values of a within a group must be monotonely increasing")

   #----------------#
   # set constants. #
   #----------------#
   imodel <- 4
   if (idesign == 2)
      params <- c(paste("a",1:(nparam-1),sep=""),"b")
   else 
      params <- c(paste("a",1:(nparam-2),sep=""),"b","c")

   #----------------#
   # check xpoints. #
   #----------------#
   if (is.vector(xpoints)) {
      xpoints <- matrix(xpoints,ngroup,length(xpoints),byrow=T)
      dimp <- dim(xpoints)
   } else {
      dimp <- dim(xpoints)
      if (dimp[1] != ngroup)
      stop("number of rows of xpoints and theta.ha must match")
   }
   npoints <- dimp[2]

   #-------------#
   # check natx. #
   #-------------#
   if (is.vector(natx)) {
      if (length(natx) == 1)
         natx <- matrix(natx,ngroup,dimp[2],byrow=T)
      else {
         if (length(natx) != dimp[2] )
            stop ("length of natx must match number of xpoints")
          natx <- matrix(natx,ngroup,dimp[2],byrow=T)
      }
      dimn <- dim(natx)
   } else {
      dimn <- dim(natx)
      if (dimn[1] != dimp[1] || dimn[2] != dimp[2])
         stop("xpoints and natx must have the same dimensions")
   }

   #-------------------#
   # check group.size. #
   #-------------------#
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(group.size,ngroup)
   else if (ngroup != lngrpsz)
      stop("number of rows of theta.ha and length of group.size must match")

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   if (missing(const.constraint.group)) const.constraint.group <- -1
   else qall <- F
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   if (missing(equal.constraint.group)) equal.constraint.group <- -1
   else qall <- F
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                     nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size

   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   if (imethod == 1) {
      info.mat <- info.ordinal.design(designs[idesign],links[ilink],
                  theta.ha,xpoints,natx,group.size)
      noncent.obj <- lr.noncent(theta.ha,info.mat,constraint)
      if (icalc == 1)
         significance <- lr.sig(noncent.obj,sample.size,power)
      else if (icalc == 2)
         power <- lr.power(noncent.obj,sample.size,significance)
      else
         sample.size <- lr.n(noncent.obj,power,significance)
   } else {
      noncent.obj <- noncent.ordinal.design(theta.ha,constraint,xpoints,
                     designs[idesign],links[ilink],natx,group.size)
      if (icalc == 1)
         significance <- self.sig(noncent.obj,sample.size,power,smo.df)
      else if (icalc == 2)
         power <- self.power(noncent.obj,sample.size,significance,smo.df)
      else
         sample.size <- self.n(noncent.obj,power,significance,smo.df)
   }

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   methods <- c("LR","SMO")
   designs <- c("Kgp","Linear","Quadratic")
   links <- c("Logistic","Complementary Log")
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method=methods[imethod],model="Ordinal",
               design=designs[idesign],
               link=links[ilink],parameters=params,param.ha=theta.ha,
               ngroup=ngroup,group.size=group.size,
               xpoints=xpoints,natx=natx,
               constraint=constraint,calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   if (imethod == 2)
      ans$smo.df <- smo.df
   class(ans) <- "asypow"
   return(ans)
}
ordinal.kgp <- function(method,
                        p.ha,group.size=1,
                        const.constraint.group,
                        const.constraint.param,
                        const.constraint.value,
                        equal.constraint.group,
                        equal.constraint.param,
                        significance,power,sample.size,
                        smo.df=T)
#----------------------------------------------------------------------
# Name: ordinal.kgp
#
# Description:
#      Calculates the estimated noncentraility parameter for 
# a single observation for single or multiple group ordinal 
# distribution using the SMO model. Uses the non-centrality 
# parameter to calculate the significance, power or sample size.
#
# Model Parameters:
# "p1","p2",... -- The probability an event occured in category i 
#                  or less.
#                  i=1,...,(ncat-1); ncat is the number of categories
#
# Arguments:
# method --
#      The method used. One of {"lr" or "smo"} for the
#      likelihood ratio or SMO method.
#
# p.ha --
#      Alternative hypothesis category.
#      For a single group with n categories p.ha is a vector
#      where p.ha[i] is the probability an event occured in 
#      category i or less. The dimension of p in this case is (n-1)
#      since p.ha[n] would automatically be 1. For k groups p.ha
#      is a [k x (n-1)] matrix with each row containing the category
#      probabilities for a group.
#
# group.size --
#      The relative number of observations in each group.
#      If group.size is identically 1 there are equal observations
#      in each group.
#
# const.constraint.group --
#      A vector of the group indicators for each constant constraint.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint. Available parameters are
#      "p1","p2",... up to the number of categories minus 1.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.group --
#      A vector of the group indicators for each parameter being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      NOTE: category probabilities in the same group can not
#            be set equal using the ordinal model.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#
# smo.df --
#      Only relevent if method is "smo".
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n. 
#----------------------------------------------------------------------
{
   #----------------#
   # Set constants. #
   #----------------#
   imodel <- 4
   idesign <- 1

   #---------------#
   # check method. #
   #---------------#
   imethod <- pmatch(method,c("lr","smo"))
   if (is.na(imethod)) stop("method must be one of 'lr' or 'smo'")

   #-------------#
   # check p.ha. #
   #-------------#
   if (is.vector(p.ha)) p.ha <- t(as.matrix(p.ha))
   if (any(p.ha <= 0.0 | p.ha >= 1.0)) 
      stop("all p.ha must be in range (0,1)")
   ngroup <- nrow(p.ha)
   nparam <- ncol(p.ha)
   params <- paste("p",1:nparam,sep="")
   prob.ha <- cbind(p.ha,rep(1,ngroup))-cbind(rep(0,ngroup),p.ha)
   if (any(prob.ha <= 0.0 | prob.ha >= 1.0))
      stop("each row of p.ha must be strictly increasing")

   #-------------------#
   # check group.size. #
   #-------------------#
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(1,ngroup)
   else if (ngroup != lngrpsz)
      stop ("number of rows in p.ha and length of group.size must match")

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   if (missing(const.constraint.group)) const.constraint.group <- -1
   else qall <- F
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   if (missing(equal.constraint.group)) equal.constraint.group <- -1
   else qall <- F
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                     nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #-------------------------------------------------#
   # check that the constraints create a valid p.ho. #
   #-------------------------------------------------#
   # Determine p.ho, the probability that an event occurs
   # in category i or less under the null hypothesis.
   # There are 3 cases:
   # Case 1: No constraint
   # If p[i] is not constrainted then p.ho[i] = p.ha[i]
   # Case 2: Constrained to a value
   # If p[i] is set to a value by the null hypothesis then
   # p.ho[i] is that value.
   # Case 3: Equality constraints
   # If 2 or more probabilties are set equal to each other then
   # the null hypothesis is the mean of those probabilities
   # weighted by the number of observations in each group.
   # NOTE: Probabilities in the same group can not be set
   # equal.

   p.ha.vec <- as.vector(t(p.ha))
   group.size.vec <- as.vector(matrix(group.size,ncol=ngroup,nrow=nparam,
                     byrow=T))
   p.ho.vec <- p.ha.vec
   p.ho.equal <- rep(0,length(p.ho.vec))
   ind.equal <- 0
   n.ho <- nrow(constraint)
   for (i in 1:n.ho) {
      if (constraint[i,1] == 1) {
         p.ho.vec[constraint[i,2]] <- constraint[i,3]
      } else {
         if (p.ho.equal[constraint[i,2]] == 0) {
            ind.equal <- ind.equal + 1
            p.ho.equal[constraint[i,2]] <- ind.equal
            p.ho.equal[constraint[i,3]] <- ind.equal
         } else {
            p.ho.equal[constraint[i,3]] <- p.ho.equal[constraint[i,2]]
         }
      }
   }

   if (ind.equal > 0) {
      for (i in 1:ind.equal) {
         ind <- (p.ho.equal == i)
         p.cur <- sum(group.size.vec[ind]*p.ha.vec[ind])/
                                        sum(group.size.vec[ind])
         p.ho.vec[ind] <- p.cur
      }
   }
   p.ho <- matrix(p.ho.vec,ncol=nparam,nrow=ngroup,byrow=T)

   # Check to see that the user did not set probabilities equal in
   # the same group.
   p.ho.equal <- matrix(p.ho.equal,ncol=nparam,nrow=ngroup,byrow=T)
   if (any(apply(p.ho.equal,1,duplicated)))
      stop("bad constraint. In the ordinal model two category probabilities in the same group can not be set equal to each other.")

   # Check to see that all p.ho are in the range (0,1)
   if (any(p.ho <= 0.0 | p.ho >= 1.0)) 
      stop("bad constraint. All p.ho must be in range (0,1) and strictly increasing.")

   # Define prob.ho, the category probabilities, such that
   # prob.ho[i] = the probability an event occurs in category i
   # under the null hypothesis.
   prob.ho <- cbind(p.ho,rep(1,ngroup))-cbind(rep(0,ngroup),p.ho)

   # Check to see that category probabilities are in (0,1);
   # if not p.ho was not a strictly increasing vector.
   if (any(prob.ho <= 0.0 | prob.ho >= 1.0))
      stop("bad constraint. All p.ho must be in range (0,1) and strictly increasing.")

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size
  
   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   if (imethod == 1) {
      info.mat <- info.ordinal.kgp(p.ha,group.size)
      noncent.obj <- lr.noncent(p.ha,info.mat,constraint)
      if (icalc == 1)
         significance <- lr.sig(noncent.obj,sample.size,power)
      else if (icalc == 2)
         power <- lr.power(noncent.obj,sample.size,significance)
      else
         sample.size <- lr.n(noncent.obj,power,significance)
   } else {
      noncent.obj <- noncent.ordinal.kgp(p.ha,constraint,group.size)
      if (icalc == 1)
         significance <- self.sig(noncent.obj,sample.size,power,smo.df)
      else if (icalc == 2)
         power <- self.power(noncent.obj,sample.size,significance,smo.df)
      else
         sample.size <- self.n(noncent.obj,power,significance,smo.df)
   }

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   methods <- c("LR","SMO")
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method=methods[imethod],model="Ordinal",design="Kgp",
               parameters=params,param.ha=p.ha,
               ngroup=ngroup,group.size=group.size,constraint=constraint,
               calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   if (imethod == 2)
      ans$smo.df <- smo.df
   class(ans) <- "asypow"
   return(ans)
}
parse.string <- function(string) {
#----------------------------------------------------------------------
# Name: parse.string
#
# Description:
#      Returns a vector of character strings found in "string"
# separated by spaces or tabs.
#
# Arguments:
# string --
#      Character string to be parsed.
#
# Returns:
# A vector of character strings found in string.
#----------------------------------------------------------------------
   ans <- ""
   loc <- 1
   qblank <- F
   for (i in 1:nchar(string)) {
      char <- substring(string,i,i)
      if ((char == " ") | (char == "\t") | (char == "\n")) {
         if (!qblank) {
            loc <- loc + 1
            ans[loc] <- ""
            qblank <- T
         }
      } else {
         ans[loc] <- paste(ans[loc],char,sep="")
         qblank <- F
      }
   }
   return(ans)
}
pause <- function() {
cat('Enter return to continue\n')
dummy <- scan(file='',n=1)
return( invisible() ) }
poisson.design <- function(method,
                           theta.ha,design="linear",
                           xpoints, natx=1, group.size=1,
                           const.constraint.group,
                           const.constraint.param,
                           const.constraint.value,
                           equal.constraint.group,
                           equal.constraint.param,
                           significance,power,sample.size,
                           smo.df=T)
#----------------------------------------------------------------------
# Name: poisson.design
#
# Description:
#      Calculates the estimated non-centraility parameter using
# the SMO method for a single observation for a Poisson design 
# where the parameter lambda, the mean, depends on a covariate,
# x, via the equation lambda=exp(u). The variable u is either a 
# linear, u = a + b*x, or quadratic, u = a + b*x + c*x^2, function 
# of the covariate x. Uses the non-centrality parameter to 
# calculate the significance, power or sample size.
#
# Model Parameters:
# "lambda" - mean
# 
# User Parameters:
# ("a","b") for linear design and ("a","b","c") for quadratic design.
# 
# Arguments:
# method --
#      The method used. One of {"lr" or "smo"} for the
#      likelihood ratio or SMO method.
#
# theta.ha --
#      Matrix of parameters of the linear part of the model.
#      Each row represents a group. If design is "linear" then
#      theta.ha has two columns, the values of (a,b) for each
#      group. If design is "quadratic" then theta.ha has three
#      columns, the values of (a,b,c) for each group.
#
# design --
#     One of {"linear", "quadratic"} Only enough to ensure a unique
#     match need be supplied. If model is "linear" then u = a + b*x;
#     if model is "quadratic" then u = a + b*x + c*x^2.
#
# natx --
#     Matrix of number of observations at each covariate value in
#     each group. Columns represent covariate values; rows represent
#     groups. At covariate value xpoint[i,j] there are natx[i,j] 
#     observations. If the number of observations at each covariate
#     value is the same for each group; natx can be a vector.
#     If the number of observations is the same for each covariate
#     value in each group; natx can be a scalar.
#
# group.size --
#      The relative number of observations in each group.
#      If group.size is identically 1 there are equal observations
#      in each group.
#
# const.constraint.group --
#      A vector of the group indicators for each constant constraint.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.group --
#      A vector of the group indicators for each parameter being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#
# smo.df --
#      Only relevent if method is "smo".
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n.
#----------------------------------------------------------------------
{
   #---------------#
   # check method. #
   #---------------#
   imethod <- pmatch(method,c("lr","smo"))
   if (is.na(imethod)) stop("method must be one of 'lr' or 'smo'")

   #--------------------------------#
   # set idesign.                   #
   # 2 for linear" 3 for quadratic. #
   #--------------------------------#
   designs <- c("kgp","linear","quadratic")
   idesign <- pmatch(design,c("linear","quadratic"))
   if (is.na(idesign)) stop("design must be one of {'linear','quadratic'}")
   idesign <- idesign + 1

   #----------------#
   # set constants. #
   #----------------#
   imodel <- 2
   if (idesign == 2) {
      nparam <- 2
      params <- c("a","b")
   } else {
      nparam <- 3
      params <- c("a","b","c")
   }

   #-----------------#
   # check theta.ha. #
   #-----------------#
   if (is.vector(theta.ha)) theta.ha <- t(as.matrix(theta.ha))
   dimt <- dim(theta.ha)
   ngroup <- dimt[1]
   ltheta <- dimt[2]
   if ((idesign == 2) & (ltheta != 2))
      stop("for a 'linear' model theta.ha must have 2 columns")
   if ((idesign == 3) & (ltheta != 3))
      stop("for a 'quadratic' model theta.ha must have 3 columns")

   #----------------#
   # check xpoints. #
   #----------------#
   if (is.vector(xpoints)) {
      xpoints <- matrix(xpoints,ngroup,length(xpoints),byrow=T)
      dimp <- dim(xpoints)
   } else {
      dimp <- dim(xpoints)
      if (dimp[1] != ngroup)
      stop("number of rows of xpoints and theta.ha must match")
   }
   npoints <- dimp[2]

   #-------------#
   # check natx. #
   #-------------#
   if (is.vector(natx)) {
      if (length(natx) == 1)
         natx <- matrix(natx,ngroup,dimp[2],byrow=T)
      else {
         if (length(natx) != dimp[2] )
            stop ("length of natx must match number of xpoints")
          natx <- matrix(natx,ngroup,dimp[2],byrow=T)
      }
      dimn <- dim(natx)
   } else {
      dimn <- dim(natx)
      if (dimn[1] != dimp[1] || dimn[2] != dimp[2])
         stop("xpoints and natx must have the same dimensions")
   }

   #-------------------#
   # check group.size. #
   #-------------------#
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(group.size,ngroup)
   else if (ngroup != lngrpsz)
      stop("number of rows of theta.ha and length of group.size must match")

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   if (missing(const.constraint.group)) const.constraint.group <- -1
   else qall <- F
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   if (missing(equal.constraint.group)) equal.constraint.group <- -1
   else qall <- F
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                     nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size

   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   if (imethod == 1) {
      info.mat <- info.poisson.design(designs[idesign],
                  theta.ha,xpoints,natx,group.size)
      noncent.obj <- lr.noncent(theta.ha,info.mat,constraint)
      if (icalc == 1)
         significance <- lr.sig(noncent.obj,sample.size,power)
      else if (icalc == 2)
         power <- lr.power(noncent.obj,sample.size,significance)
      else
         sample.size <- lr.n(noncent.obj,power,significance)
   } else {
      noncent.obj <- noncent.poisson.design(theta.ha,constraint,xpoints,
                     designs[idesign],natx,group.size)
      if (icalc == 1)
         significance <- self.sig(noncent.obj,sample.size,power,smo.df)
      else if (icalc == 2)
         power <- self.power(noncent.obj,sample.size,significance,smo.df)
      else
         sample.size <- self.n(noncent.obj,power,significance,smo.df)
   }

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   methods <- c("LR","SMO")
   designs <- c("Kgp","Linear","Quadratic")
   links <- c("Logistic","Complementary Log")
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method=methods[imethod],model="Poisson",
               design=designs[idesign],
               parameters=params,param.ha=theta.ha,
               ngroup=ngroup,group.size=group.size,
               xpoints=xpoints,natx=natx,
               constraint=constraint,calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   if (imethod == 2)
      ans$smo.df <- smo.df
   class(ans) <- "asypow"
   return(ans)
}
poisson.kgp <- function(method,
                        lambda.ha,group.size=1,
                        const.constraint.group,
                        const.constraint.param,
                        const.constraint.value,
                        equal.constraint.group,
                        equal.constraint.param,
                        significance,power,sample.size,
                        smo.df=T)
#----------------------------------------------------------------------
# Name: poisson.kgp
#
# Description:
#      Calculates the estimated non-centraility parameter for 
# a single observation for single or multiple group Poisson
# distribution using the likelihood ratio or SMO method. Uses the
# non-centrality parameter to calculate the significance,
# power or sample size.
#
# Model Parameters:
# "lambda" -- mean
#
# Arguments:
# method --
#      The method used. One of {"lr" or "smo"} for the
#      likelihood ratio or SMO method.
#
# lambda.ha --
#      Alternative hypothesis mean.
#      If there is more than 1 group lambda.ha is a matrix
#      with ngroup columns where lambda.ha[i,1] is the probability
#      of an event in group i. Lambda.ha can also be a vector
#      of length ngroup.
#
# group.size --
#      The relative number of observations in each group.
#      If group.size is identically 1 there are equal observations
#      in each group.
#
# const.constraint.group --
#      A vector of the group indicators for each constant constraint.
#
# const.constraint.param --
#      A vector of characters describing the parameters for
#      each constant constraint. In this case the only avaiable
#      parameter is "lambda" and this vector is only included for
#      completeness with other asypow functions.
#
# const.constraint.value --
#      A vector of numeric values for each constant constraint.
#
# equal.constraint.group --
#      A vector of the group indicators for each parameter being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
# equal.constraint.param --
#      A vector of characters describing the parameters being
#      set equal. If there is more than 1 set of parameters being
#      set equal this should be a list of vectors.
#
#      If all constraint parameters are missing then the
#      user will be queried for the constraints.
#
# significance --
#      The significance level of the test.
#      If missing will be calculated from power and sample.size.
#
# power --
#      The power of the test.
#      If missing will be calculated from signficiance and sample.size.
#
# sample.size --
#      The sample size of the test.
#      If missing will be calculated from signficiance and power.
#
#      User whould enter 2 of (significance,power and sample.size)
#      The function will calculate the third.
#
# smo.df --
#      Only relevent if method is "smo".
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n. 
#----------------------------------------------------------------------
{
   #----------------#
   # Set constants. #
   #----------------#
   nparam <- 1
   params <- "lambda"
   imodel <- 2
   idesign <- 1

   #---------------#
   # check method. #
   #---------------#
   imethod <- pmatch(method,c("lr","smo"))
   if (is.na(imethod)) stop("method must be one of 'lr' or 'smo'")

   #---------------------------------------------#
   # check to see that lambda.ha is in (0,Inf].  #
   #---------------------------------------------#
   if (is.matrix(lambda.ha)) lambda.ha <- as.vector(lambda.ha)
   if (any(lambda.ha <= 0.0)) stop ("lambda.ha must be greater than 0")
   if (any(is.inf(lambda.ha))) 
      stop("Inf not allowed in lambda.ha")
   ngroup <- length(lambda.ha)

   #-------------------#
   # check group.size. #
   #-------------------#
   lngrpsz <- length(group.size)
   if (lngrpsz == 1) group.size <- rep(1,ngroup)
   else if (ngroups != lngrpsz)
      stop ("number of rows in p.ha and length of group.size must match")

   #------------------------#
   # check the constraints. #
   #------------------------#
   qall <- T
   if (missing(const.constraint.group)) const.constraint.group <- -1
   else qall <- F
   if (missing(const.constraint.param)) const.constraint.param <- -1
   else qall <- F
   if (missing(const.constraint.value)) const.constraint.value <- -1
   else qall <- F
   if (missing(equal.constraint.group)) equal.constraint.group <- -1
   else qall <- F
   if (missing(equal.constraint.param)) equal.constraint.param <- -1
   else qall <- F
   if (qall) {
      constraint <- vector()
      constraint <- enter.constraints(imodel,idesign,
                                     nparam,params,ngroup)
      if (length(constraint) == 0) stop("no valid constraint entered")
   } else {
      constraint <- convert.constraints(imodel,idesign,nparam,params,ngroup,
                                const.constraint.group,
                                const.constraint.param,
                                const.constraint.value,
                                equal.constraint.group,
                                equal.constraint.param)
   }

   #--------------------------------------------#
   # check significance, power and sample.size. #
   #--------------------------------------------#
   if (missing(significance)) significance <- -1
   if (missing(power)) power <- -1
   if (missing(sample.size)) sample.size <- -1
   spss <- check.spss(significance,power,sample.size)
   icalc <- spss$icalc
   significance <- spss$significance
   power <- spss$power
   sample.size <- spss$sample.size
  
   #--------------------------------------------------#
   # calculate the sinificance, power or sample.size. #
   #--------------------------------------------------#
   if (imethod == 1) {
      info.mat <- info.poisson.kgp(lambda.ha,group.size)
      noncent.obj <- lr.noncent(lambda.ha,info.mat,constraint)
      if (icalc == 1)
         significance <- lr.sig(noncent.obj,sample.size,power)
      else if (icalc == 2)
         power <- lr.power(noncent.obj,sample.size,significance)
      else
         sample.size <- lr.n(noncent.obj,power,significance)
   } else {
      noncent.obj <- noncent.poisson.kgp(lambda.ha,constraint,group.size)
      if (icalc == 1)
         significance <- self.sig(noncent.obj,sample.size,power,smo.df)
      else if (icalc == 2)
         power <- self.power(noncent.obj,sample.size,significance,smo.df)
      else
         sample.size <- self.n(noncent.obj,power,significance,smo.df)
   }

   #---------------------------------------------#
   # create an object of class asypow to return. #
   #---------------------------------------------#
   methods <- c("LR","SMO")
   calcs <- c("Signifiance","Power","Sample Size")
   ans <- list(method=methods[imethod],model="Poisson",design="Kgp",
               parameters=params,param.ha=matrix(lambda.ha,ncol=1),
               ngroup=ngroup,group.size=group.size,constraint=constraint,
               calculated=calcs[icalc],
               significance=significance,power=power,sample.size=sample.size)
   if (imethod == 2)
      ans$smo.df <- smo.df
   class(ans) <- "asypow"
   return(ans)
}
print.asypow <- function(object) {
#----------------------------------------------------------------------
# Name: print.asypow
#
# Description:
#      Prints an object of calls "asypow" to the screen.
#
# Arguments:
# object --
#      Object of class asypow.
#----------------------------------------------------------------------

   #----------------------------#
   # check the class of object. #
   #----------------------------#
   badobj <- "object is not of class 'asypow'"
   if (class(object) != "asypow") stop(badobj)
   method <- object$method
   model <- object$model
   design <- object$design
   ngroup <- object$ngroup
   if (is.null(ngroup)) ngroup <- 1
   link <- object$link
   parameters <- object$parameters
   param.ha <- object$param.ha
   constraint <- object$constraint
   group.size <- object$group.size
   calculated <- object$calculated
   significance <- object$significance
   power <- object$power
   L <- object$L
   sample.size <- object$sample.size
   if ((is.null(method)) | (is.null(model)) |
        (is.null(parameters)) | (is.null(param.ha)) | 
        (is.null(constraint)) |
        (is.null(calculated)) | (is.null(significance)) |
        (is.null(power)) | (is.null(sample.size))) stop(badobj)
   nparam <- length(parameters)
   if (method == "SMO") {
      smo.df <- object$smo.df
      if (is.null(smo.df)) stop(badobj)
   }
   xpoints <- object$xpoints
   natx <- object$natx
   rss <- object$rss

   #-------------------#
   # print the method. #
   #-------------------#
   cat("Method:\n")
   if (method == "LR")
      cat("Likelihood Ratio\n")
   else if (method == "SMO") {
      if (smo.df)
         mssg <- "SMO with degrees of freedom"
      else
         mssg <- "SMO without degrees of freedom"
      cat(mssg,"\n")
   } else
      stop(badobj)

   #------------------#
   # print the model. #
   #------------------#
   cat("\nModel:\n")
   if ((model == "Multivariate Logistic") | 
       (model == "Multivariate Log-Linear"))
      mssg <- model
   else if (model == "Generic")
      mssg <- "Generic Model"
   else {
      if (design == "Raw") 
         mssg <- paste(design,model,"Model")
      else
         mssg <- paste(design,model,"Design")
      if (!is.null(link))
         mssg <- paste(mssg,"with",link,"Link")
   }
   if (ngroup > 1) mssg <- paste(ngroup,"Group",mssg)
   cat(mssg,"\n")

   #-----------------------#
   # print the parameters. #
   #-----------------------#
   cat("\nParameters:\n")
   cat(paste(parameters,collaspe=" "),"\n")

   #-------------------------------------------------------#
   # for an clinical trial with exponential survival model #
   # print the length of the trial.                        #
   #-------------------------------------------------------#
   if (!is.null(L)) {
      cat("\nLength of Clinical Trial:")
      if (ngroup == 1) {
         cat(" ",L,"\n")
      } else if (any(L[2:ngroup] != L[1])) {
         prn <- cbind(1:ngroup,L)
         dimnames(prn) <- list(rep("",ngroup),c("Group","Length"))
         cat("\n")
         print(prn)
      } else {
         cat(" ",L[1],"\n")
      }
   }

   #------------------------------------------#
   # print the alternative hypothesis values. #
   #------------------------------------------#
   cat("\nAlternative Hypothesis:\n")
   if (ngroup > 1) {
      if (any(group.size != 1)) {
         prn <- cbind(1:ngroup,group.size,param.ha)
         dimnames(prn) <- list(rep("",ngroup),c("Group","Size",parameters))
      } else {
         prn <- cbind(1:ngroup,param.ha)
         dimnames(prn) <- list(rep("",ngroup),c("Group",parameters))
      }
   } else {
      prn <- param.ha
      names(prn) <- parameters
   }
   print(prn)

   #--------------------------------------------#
   # for design models print the design points. #
   #--------------------------------------------#
   if (!is.null(xpoints)) {
      cat("\nDesign Points:\n")
      npoints <- ncol(xpoints)
      nr <- nrow(xpoints)
      if (nr > 1) {
         if (all(apply(xpoints,2,duplicated)[2:nr,])) {
            nr <- 1
            xpoints <- matrix(xpoints[1,],nrow=1)
         }
      }
      xprn <- round(xpoints,3)
      if (nr == 1) {
         dimnames(xprn) <- list("",paste(1:npoints))
      } else if (nr == ngroup) {
         xprn <- cbind(1:nr,xprn)
         dimnames(xprn) <- list(rep("",ngroup),c("Group",paste(1:npoints)))
      } else {
         dimnames(xprn) <- list(rep("",nr),
                                paste("X",1:npoints,sep=""))
      }
      print(xprn)
   }

   #------------------------------------------------------------------#
   # if required print the relative sample size at each design point. #
   #------------------------------------------------------------------#
   if (!is.null(natx)) {
      if (any(natx != 1)) {
         cat("\nRelative Sample Size at Design Points:\n")
         npoints <- ncol(natx)
         nr <- nrow(natx)
         if (nr > 1) {
            if (all(apply(natx,2,duplicated)[2:nr,])) {
               nr <- 1
               natx <- matrix(natx[1,],nrow=1)
            }
         }
         xprn <- round(natx,3)
         if (nr == 1) {
            dimnames(xprn) <- list("",paste(1:npoints))
         } else {
            xprn <- cbind(1:nr,xprn)
            dimnames(xprn) <- list(paste(1:ngroup),
                                   c("Group",paste(1:npoints)))
         }
         print(xprn)
      }
   }

   if (!is.null(rss)) {
      if (any(rss != 1)) {
         cat("\nRelative Sample Size at Design Points:\n")
         rprn <- matrix(rss,nrow=1)
         dimnames(rprn) <- list("",paste(1:length(rss)))
         print(rprn)
      }
   }

   #------------------------#
   # print the constraints. #
   #------------------------#
   print.constraints(nparam,parameters,ngroup,constraint)

   #--------------------#
   # print the results. #
   #--------------------#
   n <- length(significance)
   ssform <- format(as.integer(round(sample.size)))
   sigform <- format(as.single(round(c(significance,.001),3)))
   powform <- format(as.single(round(c(power,.001),3)))
   cat(paste("\n",calculated," Calculations:\n",sep=""))
   cat("                           Sample\n")
   cat("  ","Sig ","     ","Power","      ","Size","\n")
   for (i in 1:n) 
      cat("  ",sigform[i],"    ",
          powform[i],
          "      ",ssform[i],"\n")
}
print.constraints <- function(nparam,param,ngroup,constraint) {
#----------------------------------------------------------------------
# Name: print.constraints
#
# Description:
#      Prints a description of the constraint matrix to the screen.
#
# Arguments:
# nparam --
#      Number of parameters in the model.
#
# param --
#      Vector of characters descriptions of the parameters in
#      the model.
#
# ngroup --
#      Number of groups in the design.
#
# constraint --
#      Current constraint matrix.
#
# Returns:
# A list of the rows of the constraint matrix associated with
# each constraint printed.
#----------------------------------------------------------------------
   cat("\nConstraints:\n")
   i <- 1
   j <- 0
   n <- nrow(constraint)
   while (i <= n) {
      j <- j + 1
      if (constraint[i,1] == 1) {
         iloc <- constraint[i,2]
         iparam <- (iloc %% nparam)
         if (iparam == 0) iparam <- nparam
         igroup <- ((iloc - iparam)/nparam) + 1
         value <- constraint[i,3]
         mssg <- paste("(",j,") Parameter ",param[iparam],sep="")
         if (ngroup > 1)
            mssg <- paste(mssg," in group ",igroup,sep="")
         mssg <- paste(mssg," set equal to ",value,".",sep="")
         cat(mssg,"\n")
         row.list <- i
         i <- i + 1
      } else {
         iloc <- constraint[i,2]
         iparam <- (iloc %% nparam)
         if (iparam == 0) iparam <- nparam
         igroup <- ((iloc - iparam)/nparam) + 1
         mssg <- paste("(",j,") Parameter ",param[iparam],sep="")
         if (ngroup > 1)
            mssg <- paste(mssg," in group ",igroup,sep="")
         mssg <- paste(mssg," set equal to",sep="")
         cat(mssg,"\n")
         row.list <- i
         while(1) {
            iloc <- constraint[i,3]
            iparam <- (iloc %% nparam)
            if (iparam == 0) iparam <- nparam
            igroup <- ((iloc - iparam)/nparam) + 1
            mssg <- paste("    parameter ",
                          param[iparam],sep="")
            if (ngroup > 1)
                mssg <- paste(mssg," in group ",igroup,sep="")
            qnext <- F
            if (i < n)
               if ((constraint[i+1,1] == 2) & 
                   (constraint[i+1,2] == iloc)) qnext <- T
            if (qnext) {
               mssg <- paste(mssg," and",sep="")
               cat(mssg,"\n")
               i <- i + 1
               row.list <- c(row.list,i)
            } else {
               mssg <- paste(mssg,".",sep="")
               cat(mssg,"\n")
               break
            }
         }
      i <- i + 1
      }
      if (j == 1)
         ans.list <- list(row.list)
      else
         ans.list[[j]] <- row.list
   }
   return(ans.list)
}
self.n <- function(noncent.obj,power,significance,dfadd=T) {
#----------------------------------------------------------------------
# Name: self.n
#
# Description:
#      Calculates the sample size need to obtain the desired power
# for a test using the SMO method.
#
# Arguments:
# noncent.obj --
#      Object returned from one of the noncent.* routines.
#      Should be a list containing w, the estimate of 
#      2*(E[l(theta.ha)]-E[l(theta.ho)]), and df, the degrees
#      of freedom of the Chi-Squared distribution or the number
#      of constraints in the null hypothesis.
#
# power --
#      The power of the test.
#
# significance --
#      The significance level of the test.
#
# dfadd --
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n. 
#
# Return Value:
# The needed sample size.
#----------------------------------------------------------------------

   # Check noncent.obj, should be list containing w, the estimate of 
   # 2*(E[l(theta.ha)]-E[l(theta.ho)]), and df, the degrees
   # of freedom of the Chi-Squared distribution or the number
   # of constraints in the null hypothesis.
   df <- noncent.obj$df
   w <- noncent.obj$w
   if (is.null(df) | is.null(w))
      stop("noncent.obj is not an object from one of the noncent.* routines")

   # Check significance and power
   nsig <- length(significance)
   npow <- length(power)
   if (nsig !=1 & npow!= 1 & nsig != npow)
      stop("lengths of significance and power must match")
   if (nsig == 1) significance <- rep(significance,length=npow)
   if (npow == 1) power <- rep(power,length=nsig)
   nn <- max(nsig,npow)

   # The expectation of the non-central Chi-Square with non-centrality
   # parameter, nu, and degrees of freedom, df, is df + nu, so we have
   # the approximation nu = 2*E[l(y;theta) - l(y;theta.ho)] - df

   # The SMO estimate uses an estimate of 2*E[l(y[i];theta) - 
   # l(y[i];theta.ho)] for 1 observation called w to get
   # nu = noncent*n - df 
   # or
   # n = (nu + df)/w

   # NOTE: w is calculated by one of the noncent.* routines.

   nu <- rep(0,nn)
   crit <- qchisq(1-significance,df)

   for(i in 1:nn) {
      nu[i] <- cdfchn(4,p=1-power[i],x=crit[i],df=df)$pnonc
   }

   if (dfadd) n <- (nu + df)/w
   else n <- nu/w

   return(n)
}
self.power <- function(noncent.obj,sample.size,significance,dfadd=T) {
#----------------------------------------------------------------------
# Name: self.power
#
# Description:
#      Calculates the power of a test with a given sample size
# and significance level using the SMO method.
#
# Arguments:
# noncent.obj --
#      Object returned from one of the noncent.* routines.
#      Should be a list containing w, the estimate of 
#      2*(E[l(theta.ha)]-E[l(theta.ho)]), and df, the degrees
#      of freedom of the Chi-Squared distribution or the number
#      of constraints in the null hypothesis.
#
# sample.size --
#      The sample size of the test.
#
# significance --
#      The significance level of the test.
#
# dfadd --
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n. 
#
# Return Value:
# The power.
#----------------------------------------------------------------------

   # Check noncent.obj, should be list containing w, the estimate of 
   # 2*(E[l(theta.ha)]-E[l(theta.ho)]), and df, the degrees
   # of freedom of the Chi-Squared distribution or the number
   # of constraints in the null hypothesis.
   df <- noncent.obj$df
   w <- noncent.obj$w
   if (is.null(df) | is.null(w))
      stop("noncent.obj is not an object from one of the noncent.* routines")

   # Check sample size and signficiance level
   nsig <- length(significance)
   nss <- length(sample.size)
   if (nsig !=1 & nss!= 1 & nsig != nss)
      stop("lengths of significance and sample.size must match")
   if (nsig == 1) significance <- rep(significance,length=nss)
   if (nss == 1) sample.size <- rep(sample.size,length=nsig)
   nn <- max(nsig,nss)

   # The expectation of the non-central Chi-Square with non-centrality
   # parameter, nu, and degrees of freedom, df, is df + nu, so we have
   # the approximation nu = 2*E[l(y;theta) - l(y;theta.ho)] - df

   # The SMO estimate uses an estimate of 2*E[l(y[i];theta) - 
   # l(y[i];theta.ho)] for 1 observation called w to get
   # nu = noncent*n - df 
   
   # The power is calculated from the non-central Chi-Square
   # parameter with non-centrality parameter nu and significance
   # level, significance.

   power <- rep(0,nn)

   if (dfadd) nu <- w*sample.size - df
   else nu <- w*sample.size

   if (any(nu <= 0.0))
      stop("significance calculation not possible")

   crit <- qchisq(1-significance,df)

   for(i in 1:nn) {
      power[i] <- 1-cdfchn(1,x=crit[i],df=df,pnonc=nu[i])$p
   }

   return(power)
}
self.sig <- function(noncent.obj,sample.size,power,dfadd=T) {
#----------------------------------------------------------------------
# Name: self.sig
#
# Description:
#      Calculates the significance level of a test with a given 
# sample size and power using the SMO method.
#
# Arguments:
# noncent.obj --
#      Object returned from one of the noncent.* routines.
#      Should be a list containing w, the estimate of 
#      2*(E[l(theta.ha)]-E[l(theta.ho)]), and df, the degrees
#      of freedom of the Chi-Squared distribution or the number
#      of constraints in the null hypothesis.
#
# sample.size --
#      The sample size of the test.
#
# power --
#      The power of the test.
#
# dfadd --
#      Logical Variable. If TRUE sample size is calculated via the
#      equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n - df
#      where nu is the non-centraility parameter of the Chi-Square
#      model and df is the degrees of freedom. This is the most
#      conservative calculation. If FALSE sample size is calculated 
#      via the equation nu = 2*(E[l(theta.ha)]-E[l(theta.ho)])*n. 
#
# Return Value:
# The significance level.
#----------------------------------------------------------------------

   # Check noncent.obj, should be list containing w, the estimate of 
   # 2*(E[l(theta.ha)]-E[l(theta.ho)]), and df, the degrees
   # of freedom of the Chi-Squared distribution or the number
   # of constraints in the null hypothesis.
   df <- noncent.obj$df
   w <- noncent.obj$w
   if (is.null(df) | is.null(w))
      stop("noncent.obj is not an object from one of the noncent.* routines")

   # Check sample size and power level
   npow <- length(power)
   nss <- length(sample.size)
   if (npow !=1 & nss!= 1 & npow != nss)
      stop("lengths of power and sample.size must match")
   if (npow == 1) power <- rep(power,length=nss)
   if (nss == 1) sample.size <- rep(sample.size,length=npow)
   nn <- max(npow,nss)

   # The expectation of the non-central Chi-Square with non-centrality
   # parameter, nu, and degrees of freedom, df, is df + nu, so we have
   # the approximation nu = 2*E[l(y;theta) - l(y;theta.ho)] - df

   # The SMO estimate uses an estimate of 2*E[l(y[i];theta) - 
   # l(y[i];theta.ho)] for 1 observation called w to get
   # nu = noncent*n - df 
   
   # The significance level is calculated from the non-central Chi-Square
   # parameter with non-centrality parameter nu and power, power.


   if (dfadd) nu <- w*sample.size - df
   else nu <- w*sample.size

   if (any(nu <= 0.0))
      stop("significance calculation not possible")

   crit <- rep(0,nn)

   for(i in 1:nn) {
     crit[i] <- cdfchn(2,p=1-power[i],df=df,pnonc=nu[i])$x
   }

   significance <- 1-pchisq(crit,1)
   return(significance)
}
transform.phi <- function(theta.ha,constraints) {

      s <- dim(constraints)[1]
      phi.ha.tran <- rep(NA,s)

      for(i in 1:s) {
           if(constraints[i,1] == 1)
                phi.ha.tran[i] <- theta.ha[constraints[i,2]]
           else phi.ha.tran[i] <- 
                     theta.ha[constraints[i,3]] - theta.ha[constraints[i,2]]
      }

      return(phi.ha.tran)
}
